precision highp float;
varying highp vec2 textureCoordinate;
//四个角
uniform mat4 colors;
uniform float roate;
uniform float ratio;
uniform vec2 off;
uniform vec2 scale;
vec2 center = vec2(0.5);

vec2 doroate(vec2 uv2) {
    //计算旋转角度
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    return vec2(dx2, dy2);
}

vec2 getoffpos(vec2 pos) {
    pos = abs(pos);
    vec2 value = fract(pos);
    if (mod(pos.x, 2.0) > 1.0) {
        value.x = 1.0 - value.x;
    }
    if (mod(pos.y, 2.0) > 1.0) {
        value.y = 1.0 - value.y;
    }
    return value;
}

vec2 resetpos(vec2 pos) {
    pos = pos - center;
    pos = doroate(pos);
    pos += off;
    pos *= scale;
    pos = pos + center;
    pos = getoffpos(pos);
    return pos;
}

void main() {
    vec2 colorpos = resetpos(textureCoordinate);
    vec4 colortop = mix(colors[0], colors[1], colorpos.x);
    vec4 colorbottom = mix(colors[2], colors[3], colorpos.x);
    vec4 color = mix(colortop, colorbottom, colorpos.y);
    gl_FragColor = color;
}
