precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float ratio;
highp vec2 center = vec2(0.5);


//白色部分的长度
float l2 = 0.15;
//圆角
float l3 = 0.03;

//矩形
float sdBox(in vec2 p, in vec2 b)
{
    vec2 d = abs(p) - b;
    return length(max(d, 0.0)) + min(max(d.x, d.y), 0.0);
}

//圆角矩形
float sdBoxRadius(in vec2 p, in vec2 b, float radius)
{
    vec2 d = abs(p) - b + radius;
    return length(max(d, 0.0)) + min(max(d.x, d.y), 0.0) - radius;
}

float sdRoundedBox(in vec2 p, in vec2 b, in vec4 r)
{
    r.xy = (p.x > 0.0) ? r.xy : r.zw;
    r.x = (p.y > 0.0) ? r.x : r.y;
    vec2 q = abs(p) - b + r.x;
    return min(max(q.x, q.y), 0.0) + length(max(q, 0.0)) - r.x;
}

vec2 pos;
float lx, ly;
vec4 shadowcolor = vec4(0.3, 0.3, 0.3, 1.0);
bool yinying() {
    //阴影部分的长度
    float l1 = 0.02;
    if (ratio > 1.0) {
        lx = l1 / ratio;
        ly = l1;
    } else {
        lx = l1;
        ly = l1 * ratio;
    }
    float chax = 0.5 - abs(pos.x - 0.5);
    float chay = 0.5 - abs(pos.y - 0.5);
    if (chax < lx || chay < ly) {
        vec2 usepos=pos;
        vec2 maxoff= center - vec2(lx, ly);

        if (ratio > 1.0) {
            usepos.x=0.5+(usepos.x-0.5)*ratio;
            maxoff.x*=ratio;
        } else {
            usepos.y=0.5+(usepos.y-0.5)/ratio;
            maxoff.y/=ratio;
        }


        float length = l1 - sdBox(usepos - center, maxoff);
        length = length * (0.25 / l1);
        gl_FragColor = shadowcolor * length;
        return true;
    }
    pos.x = (pos.x - 0.5) / (0.5 - lx) / 2.0 + 0.5;
    pos.y = (pos.y - 0.5) / (0.5 - ly) / 2.0 + 0.5;
    return false;
}
vec3 bordercolor = vec3(1.0);

bool baikuang() {
    lx *= 1.5;
    ly *= 1.5;
    float chax = 0.5 - abs(pos.x - 0.5);
    float chay = 0.5 - abs(pos.y - 0.5);
    if (chax < lx || chay < ly) {
        gl_FragColor = vec4(bordercolor, 1.0);
        return true;
    }
    pos.x = (pos.x - 0.5) / (0.5 - lx) / 2.0 + 0.5;
    pos.y = (pos.y - 0.5) / (0.5 - ly) / 2.0 + 0.5;
    return false;
}


void main() {
    pos = textureCoordinate / 1.0;
    if (yinying()) {
        return;
    }
    if (baikuang()) {
        return;
    }
//    float length = sdBoxRadius(pos - center, center, 0.01);
//    if (length > 0.0) {
//        gl_FragColor = vec4(bordercolor, 1.0);
//    } else {
//        gl_FragColor = texture2D(inputImageTexture, pos);
//    }
    gl_FragColor = texture2D(inputImageTexture, pos);

}
