precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float ratio;
highp vec2 center = vec2(0.5);

vec2 pos;
float lx, ly;

void main() {
    pos = textureCoordinate / 1.0;
    //阴影部分的长度
    float l1 = 0.04;
    if (ratio > 1.0) {
        lx = l1 / ratio;
        ly = l1;
    } else {
        lx = l1;
        ly = l1 * ratio;
    }
    float chax = 0.5 - abs(pos.x - 0.5);
    float chay = 0.5 - abs(pos.y - 0.5);
    if (chax < lx || chay < ly) {
        vec2 usepos;
        if(pos.x>0.5){
            pos.x=1.0-pos.x;
        }
        if(pos.y>0.5){
            pos.y=1.0-pos.y;
        }
//        分成三部分，拐角,上边，左边，
        if(pos.y<ly&&pos.x<lx){
            usepos.x=pos.x/lx/2.0;
            usepos.y=pos.y/ly/2.0;
        }else if(pos.y<ly){
            usepos.x=0.5;
            usepos.y=pos.y/ly/2.0;
        }else if(pos.x<lx){
            usepos.y=0.5;
            usepos.x=pos.x/lx/2.0;
        }
        vec4 color=texture2D(inputImageTexture2, usepos);
        color.rgb=color.rgb*color.a;
        gl_FragColor = color;
    }else{
        pos.x = (pos.x - 0.5) / (0.5 - lx) / 2.0 + 0.5;
        pos.y = (pos.y - 0.5) / (0.5 - ly) / 2.0 + 0.5;
        gl_FragColor = texture2D(inputImageTexture, pos);
    }


}
