precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform lowp float progress;
uniform float ratio;
uniform float alpha;
uniform vec4 params;

//  lut 4
vec4 getlut(vec4 base, sampler2D overlay) {
    highp float blueColor = base.b * 63.0;
    highp vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);

    highp vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);

    highp vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * base.r);
    texPos1.y = (quad1.y * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * base.g);

    highp vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * base.r);
    texPos2.y = (quad2.y * 0.125) + 0.5 / 512.0 + ((0.125 - 1.0 / 512.0) * base.g);

    highp vec4 newColor1 = texture2D(overlay, texPos1);
    highp vec4 newColor2 = texture2D(overlay, texPos2);

    highp vec4 rtn = mix(newColor1, newColor2, fract(blueColor));
    //    rtn = mix(base, rtn, inBlendprogress.a);
    //    变成lut文件颜色
    return rtn;
}

vec4 getcolor(vec4 baseColor, vec4 blendColor) {
    vec4 rtn = baseColor / (vec4(1.0) - blendColor);
    rtn = min(rtn, vec4(1.0));
    return rtn;
}

void main() {
    vec2 uv = textureCoordinate.xy / 1.0;
    vec4 base = texture2D(inputImageTexture, uv);
    vec4 color = getlut(base, inputImageTexture3);
    color = mix(base, color, params.r);
    vec2 center = vec2(0.5);
    //    uv-=center;
    //    if(ratio>1.0){
    //        uv.y/= ratio;
    //    }else{
    //        uv.x*= ratio;
    //    }
    //    uv+=center;
    vec4 colorheart = texture2D(inputImageTexture2, uv);
    color = getcolor(color, colorheart);
    color = mix(base, color, alpha);
    gl_FragColor = color;
}



