precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

/// 透明度混合 2
vec4  getalphacolor(vec4 base,vec4 overlay){
    vec4 one=vec4(1.0);
    vec4 rtn= base*(one-overlay.a)+overlay*overlay.a;
    return vec4(rtn.rgb,1.0);
}

vec4 color = vec4(0.89, 0.105, 0.263, 1.0);
vec2 center = vec2(0.5);
void main() {
    vec2 uv = textureCoordinate.xy / 1.0;
    if (ratio > 1.0) {
        uv.x = (uv.x - 0.5) * ratio + 0.5;
    } else {
        uv.y = (uv.y - 0.5) / ratio + 0.5;
    }
    float mixvalue = length(uv - center) - 0.2;
    mixvalue = mixvalue < 0.0 ? 0.0 : mixvalue*2.0;
    color*=mixvalue;
    vec4 usecolor = texture2D(inputImageTexture, textureCoordinate);
    usecolor=getalphacolor(usecolor,color);
    gl_FragColor=usecolor;
}



