precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform vec4 params;
vec3 rgbToHsv(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsvToRgb(vec3 c) {//convertHsvToRgb
                       vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
                       vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
                       return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

vec4 changecolorhue(vec4 color) {
    if (params.g != 0.0) {
        vec3 hsv = rgbToHsv(color.rgb);
        hsv.r += params.g;
        hsv.r = fract(hsv.r);
        color.rgb = hsvToRgb(hsv);
    }
    return color;
}
vec2 center = vec2(0.5);
void main() {
    vec2 uv = textureCoordinate.xy / 1.0;
    float pro = fract(progress / 1000.0 * 3.0);
    pro = abs(pro - 0.5);
    if (pro < 0.2) {
        float scale = 1.1 - pro*0.5;
        uv = (uv - center)/scale+center;
    }

    vec4 base = texture2D(inputImageTexture, uv);
    vec4 startcolor = texture2D(inputImageTexture2, vec2(0.01, 0.5));
    vec4 endcolor = texture2D(inputImageTexture2, vec2(0.99, 0.5));
    vec4 cha = abs(startcolor - endcolor);
    if (cha.x + cha.y + cha.z < 0.01) {
        gl_FragColor = base;
    } else {
        float xpos = (base.x * 0.3 + base.y * 0.59 + base.z * 0.11);
        vec4 color = texture2D(inputImageTexture2, vec2(xpos, 0.5));
        color = changecolorhue(color);
        color = mix(base, color, params.r);
        gl_FragColor = color;
    }
}



