precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;

vec2 center = vec2(0.5);
vec2 doroate(vec2 uv2, float roate) {
    //计算旋转角度
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    return vec2(dx2, dy2);
}
vec4 getExposure2(vec4 color, float value) {
    return vec4(color.rgb * pow(2.0, value), color.a);// rgb * 2^效果值
}


void main() {
    vec2 uv = textureCoordinate.xy / 1.0 - center;
    float roate = params.r;
    if (roate != 0.0) {
        uv = doroate(uv, roate);
    }
    float scale = params.g;
    uv /= scale;
    vec4 base = texture2D(inputImageTexture, uv + center);
//    vec4 color = vec4(0.0);
//    float offmax = params.b * 0.01;
//    if (offmax > 0.0) {
//        for (float i = 1.0; i < 5.0; i++) {
//            vec2 pos = center + uv * (1.0 + i * offmax);
//            color += texture2D(inputImageTexture, pos);
//        }
//        color /= 4.0;
//        base = mix(base, color, 0.8);
//    }
    base = getExposure2(base, params.a);
    gl_FragColor = base;

}



