precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;

vec2 center = vec2(0.5);
//亮度
//https://juejin.cn/post/7057793339164196900
vec4 getbrightness(vec4 color, float value) {
    float value = value;
    color = vec4((color.rgb + vec3(value)), color.a);
    return color;
}
vec4 getExposure2(vec4 color, float value) {
    return vec4(color.rgb * pow(2.0, value), color.a);// rgb * 2^效果值
}


void main() {
    vec2 uv = textureCoordinate.xy / 1.0 - center;
    float scale = params.r;
    uv /= scale;
    vec4 base = texture2D(inputImageTexture, uv + center);
    float off=params.g*0.3;
    //    亮度
    base = getbrightness(base, off);
    base=min(base,vec4(1.0));
    base = getExposure2(base, off);
    gl_FragColor = base;

}



