precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;


vec4 getExposure2(vec4 color, float value) {
    return vec4(color.rgb * pow(2.0, value), color.a);// rgb * 2^效果值
}

void main() {
    vec2 uv = textureCoordinate.xy / 1.0;

    vec4 color = vec4(0.0);
    float offsize = 0.006;
    float offmax = params.r * offsize;
    float addnum = 0.0;
    vec2 add = vec2(0.0);
    float max = 40.0 * params.r;
    float weight;
    if (offmax > 0.0 && max > 1.0) {
        for (float i = 1.0; i < max; i++) {
            add.y = i * offmax;
            weight = max - i;
            color += texture2D(inputImageTexture, uv + add) * weight;
            color += texture2D(inputImageTexture, uv - add) * weight;
            addnum += weight * 2.0;
        }
    } else {
        color = texture2D(inputImageTexture, uv);
        addnum = 1.0;
    }
    color /= addnum;

    float light = params.g;
    //    color.rgb += vec3(light * 0.3);
    color = getExposure2(color, light);
    gl_FragColor = color;

}



