precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;

vec2 center = vec2(0.5);
//曝光度
vec4 getExposure2(vec4 color, float value) {
    return vec4(color.rgb * pow(2.0, value), color.a);// rgb * 2^效果值
}
//饱和度
vec4 getsaturation(vec4 color, float value) {
    vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);
    //    范围0-2;
    float saturation = value + 1.0;
    vec3 greyScaleColor = vec3(dot(color.rgb, luminanceWeighting));
    vec4 rtn = vec4(mix(greyScaleColor, color.rgb, saturation), color.a);
    return rtn;
}

void main() {
    vec2 uv = textureCoordinate.xy / 1.0 - center;
    //    缩放
    uv /= params.gb;
    uv.y -= params.r;
    uv += center;


    vec4 color = vec4(0.0);
    float offsize = 0.005;
    float offmax = progress * offsize;
    float addnum = 0.0;
    vec2 add = vec2(0.0);
    float max = 15.0;
    float weight;
    if (offmax > 0.0) {
        for (float i = 1.0; i < max; i++) {
            add.y = i * offmax;
            weight = max - i;
            color += texture2D(inputImageTexture, uv + add) * weight;
            color += texture2D(inputImageTexture, uv - add) * weight;
            addnum += weight * 2.0;
        }
    } else {
        color = texture2D(inputImageTexture, uv);
        addnum = 1.0;
    }
    offmax = progress * offsize;
    add.y = 0.0;
    max = 5.0;
    if (offmax > 0.0) {
        for (float i = 1.0; i < 5.0; i++) {
            weight = max - i;
            add.x = i * offmax;
            color += texture2D(inputImageTexture, uv + add) * weight;
            color += texture2D(inputImageTexture, uv - add) * weight;
            addnum += weight * 2.0;
        }
    }
    color /= addnum;
    color *= (1.0 + params.a*0.8);
    color = getExposure2(color, progress);
    gl_FragColor = color;

}



