precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
uniform float roate;

vec2 center = vec2(0.5);

vec2 getusepos() {
    vec2 uv = textureCoordinate.xy - center;
    if(roate>0.0){
        uv=uv.yx;
    }
    uv.x *= progress;
    uv.y *= ratio;
    return uv + center;
}
void main() {

    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec2 useuv = getusepos();
    if (abs(useuv.x - 0.5) > 0.5 || abs(useuv.y - 0.5) > 0.5) {
        gl_FragColor = base;
    } else {
        vec4 color2 = texture2D(inputImageTexture2, useuv);
        float olda = color2.a;
        if (olda == 0.0) {
            gl_FragColor = base;
            return;
        }
        //        if (isfromanim > 0) {
        //            color2.rgb /= olda;
        //        }
        color2.a = 1.0;
        gl_FragColor = mix(base, color2, olda);
    }
}



