precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float texStepX;
uniform lowp float texStepY;
/*
uniform float beginX;
uniform float beginY;
varying vec2 vPos;
if(abs(vPos.x)<abs(beginX) && abs(vPos.y)<abs(beginY)){
       gl_FragColor = texture2D(sampler, textureCoord.st);
       return;
   }
   */



mediump float getGaussWeight(mediump float currentPos, mediump float sigma)
{
    return 1.0 / sigma * exp(-(currentPos * currentPos) / (2.0 * sigma * sigma));
}

float getpro(float x){
    if(x<0.02)return x;
    x=(x-0.02)/0.98;
    return sqrt(1.0 - pow(x - 1.0, 2.0));
}

void main()
{
    float uRadius=(1.0-getpro(progress))*35.0;
    float diameter = 2.0 * uRadius + 1.0;
    vec4 sampleTex = vec4(0.0);
    vec3 col = vec3(0.0);
    float weightSum = 0.0;
    for(float i = 0.0; i < diameter; i++) {
        vec2 offset = vec2((i - uRadius) * texStepX, (i - uRadius) * texStepY);
        sampleTex = texture2D(inputImageTexture, textureCoordinate+offset);
        float gaussWeight = getGaussWeight(
        i - (diameter - 1.0)/2.0,
        ((diameter - 1.0)/2.0 + 1.0) / 2.0);
        col += sampleTex.rgb * gaussWeight;
        weightSum += gaussWeight;
    }
    gl_FragColor = vec4(col / weightSum, 1.0);
//    gl_FragColor = mix(gl_FragColor, black,distance(vec2(0.5),textureCoordinate)*2.0);
}


