precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float texStepX;
uniform lowp float texStepY;
float PI=3.1415926;

mediump float getGaussWeight(mediump float currentPos, mediump float sigma)
{
    return 1.0 / sigma * exp(-(currentPos * currentPos) / (2.0 * sigma * sigma));
}

float getpro(float x){
    if(x<0.02)return 0.0;
    x=(x-0.02)/0.98;
//    return sqrt(1.0 - pow(x - 1.0, 1.0));
    return x;
}
float getscale(float x){
    float rtn=1.0-sin(x*PI)*0.2;
    return rtn;
}

/*bool isin(vec2 texCoord){
    //    准备范围数据
    float centerx1=0.4;
    float centery1=0.4;

    float posx=0.01/4.0;
    float posy=0.01/4.0;

    float length=0.0;
    bool incicle=false;

    if(ratio>1.0){
        posx/=ratio;
        centerx1=0.5+(centerx1-0.5)/ratio;
        length=sqrt(pow((texCoord.x-0.5)*ratio,2.0)+pow(texCoord.y-0.5,2.0));
        incicle=length<posx*6.0;
    }else{
        posy*=ratio;
        centery1=0.5+(centery1-0.5)*ratio;
        length=sqrt(pow((texCoord.x)-0.5,2.0)+pow((texCoord.y-0.5)/ratio,2.0));
        incicle=length<posy*6.0;
    }
    if(incicle) return true;



    float centerx2=1.0-centerx1;
    float centery2=1.0-centery1;
    float tx=texCoord.x;
    float ty=texCoord.y;



    //  排除外围
    if(abs(0.5-tx)>(0.5-centerx1+posx)){
        return false;
    }
    if(abs(0.5-ty)>(0.5-centery1+posy)){
        return false;
    }
    //   排除内部
    if(abs(0.5-tx)<posx*12.0){
        return false;
    }
    if(abs(0.5-ty)<posy*12.0){
        return false;
    }
    bool isin1=(abs(tx-centerx1)<posx)||(abs(tx-centerx2)<posx);
    bool isin2=(abs(ty-centery1)<posy)||(abs(ty-centery2)<posy);

    return isin1||isin2;
}*/

float getscale2(float x){
    float rtn=1.0;
    if(x<0.1){
        rtn=1.0-x*2.0;
    }else if(x<0.3){
        rtn=0.7+x;
    }else if(x>0.9)rtn=0.0;
    return rtn;
}

void main()
{
    vec4 balck=vec4(0.0,0.0,0.0,1.0);
    float mixnum=0.0;
    float usepro=progress/0.9;
    if(progress<0.4){
        mixnum=1.0-getpro(progress*2.5);
    }
//    gl_FragColor=vec4(mixnum);
//    return;
//  1-0.8-1
    float scale=1.0;
    if(usepro<1.0)
    scale=getscale(usepro);

    float uRadius=(1.0-scale)*10.0*5.0;
    vec2 center=vec2(0.5);
    vec2 texCoord=(textureCoordinate-center)*scale+center;

    //毛玻璃
    vec3 col = vec3(0.0);
    float diameter = 2.0 * uRadius + 1.0;
    vec4 sampleTex = vec4(0.0);
    float weightSum = 0.0;
    for(float i = 0.0; i < diameter; i++) {
        vec2 offset = vec2((i - uRadius) * texStepX, (i - uRadius) * texStepY);
        sampleTex = texture2D(inputImageTexture, texCoord+offset);
        float gaussWeight = getGaussWeight(
        i - (diameter - 1.0)/2.0,
        ((diameter - 1.0)/2.0 + 1.0) / 2.0);
        col += sampleTex.rgb * gaussWeight;
        weightSum += gaussWeight;
    }
    vec4 base = vec4(col / weightSum, 1.0);
    //毛玻璃end
//    第二次毛玻璃完成加素材混合
    if(texStepY>0.0){
//       中间的
        scale=getscale2(progress);
        vec4 over=vec4(0.0);
        if(scale!=0.0){
            vec2 texCoord2=(textureCoordinate-center)*scale*4.0+center;
            if(ratio>1.0){
                texCoord2.x=(texCoord2.x-0.5)*ratio+0.5;
            }else{
                texCoord2.y=(texCoord2.y-0.5)/ratio+0.5;
            }
            if(abs(texCoord2.x-0.5)<0.5&&abs(texCoord2.y-0.5)<0.5){
                over = texture2D(inputImageTexture3, texCoord2);
            }
        }
        base=mix(base,over,over.a);

//        右上角部分
        texCoord=textureCoordinate/1.0;
        over =vec4(0.0);
        float scalex=0.25;
        float scaley=0.25;
        if(ratio>1.0){
            scalex/=ratio;
        }else{
            scaley*=ratio;
        }
        texCoord.x=1.0-texCoord.x;
        texCoord.x=texCoord.x/scalex;
        texCoord.y=texCoord.y/scaley;
        if(!(texCoord.x>1.0||texCoord.y>1.0)){
            texCoord.x=1.0-texCoord.x;
            over  = texture2D(inputImageTexture2, texCoord);
            over.rgb=vec3(1.0);
            base=mix(base,over,over.a);
//            只有白色强制画上了
//            if(over.a>0.5){
//                base = vec4(1.0);
//            }
        }
        gl_FragColor = mix(base,balck,mixnum);
    }else{
        gl_FragColor=base;
    }


}


