precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float dodistance(vec2 v1,vec2 v2){
   vec2 cha= v1-v2;

    ratio>=1.0?cha.x*=ratio:cha.y/=ratio;
    return sqrt(cha.x*cha.x+cha.y*cha.y);
}

float sq(float a){
    return pow(a,2.0);
}

//http://www.flong.com/archive/texts/code/shapers_circ/  Double-Circle Seat

void main()
{   vec4 black=vec4(0.0,0.0,0.0,1.0);

    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    float pro=0.45;

    vec4 color = texture2D(inputImageTexture, texCoord);
    vec2 center=vec2(0.5);
    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),
    smoothstep(pro-0.01,pro+0.01,dodistance(center,texCoord)));
}


