precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float dodistance(vec2 v1,vec2 v2){
   vec2 cha= v1-v2;
    if(ratio>1.0){
        cha.x*=ratio;
    }else{
        cha.y/=ratio;
    }

    return sqrt(cha.x*cha.x+cha.y*cha.y);
}
float getpro(float x){
    if(x<0.02)return x;
    x=(x-0.02)/0.98;
    return sqrt(1.0 - pow(x - 1.0, 2.0));
}


void main()
{


    float pro=getpro(progress);
    if(pro<0.01){
        gl_FragColor =vec4(0.0,0.0,0.0,1.0);
        return ;
    }
    vec2 center=vec2(0.5);
    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    vec4 color = texture2D(inputImageTexture, texCoord);
    float cha=ratio>1.0?ratio:1.0/ratio;
//    计算出对角最长的距离
    float lengthmax=sqrt(0.5*0.5+cha*0.5*cha*0.5);
    pro*=lengthmax;

    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),
    smoothstep(pro-0.01,pro+0.01,dodistance(center,texCoord)));
//    gl_FragColor = mix(vec4(0.0,0.0,0.0,1.0),color,step(pro,abs(texCoord.y-0.5)));
}


