precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float getpro(float x){
    if(x<0.02)return x;
    x=(x-0.02)/0.98;
    return sqrt(1.0 - pow(x - 1.0, 2.0));
}



void main()
{


    float pro=getpro(progress)/2.0;
    if(pro<0.01){
        gl_FragColor =vec4(0.0,0.0,0.0,1.0);
        return ;
    }
    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    vec4 color = texture2D(inputImageTexture, texCoord);
//    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),
//    smoothstep(pro-0.01,pro+0.01,abs(texCoord.x-0.5)));
    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),step(pro,abs(texCoord.x-0.5)));
}


