precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float dodistance(vec2 v1,vec2 v2){
   vec2 cha= v1-v2;

    ratio>=1.0?cha.x*=ratio:cha.y/=ratio;
    return sqrt(cha.x*cha.x+cha.y*cha.y);
}

float sq(float a){
    return pow(a,2.0);
}

//http://www.flong.com/archive/texts/code/shapers_circ/  Double-Circle Seat
float doprogress(float x, float a){
    float min_param_a = 0.0;
    float max_param_a = 1.0;
    a = max(min_param_a, min(max_param_a, a));

    float y = 0.0;
    if (x<=a){
        y = sqrt(sq(a) - sq(x-a));
    } else {
        y = 1.0 - sqrt(sq(1.0-a) - sq(x-a));
    }
    return y;
}

void main()
{   vec4 black=vec4(0.0,0.0,0.0,1.0);

    if(progress>=0.95){
        gl_FragColor= black;
        return;
    }

    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    float pro=1.0-doprogress(progress/0.95,0.7);

    vec4 color = texture2D(inputImageTexture, texCoord);
    vec2 center=vec2(0.5);
    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),
    smoothstep(pro-0.01,pro+0.01,dodistance(center,texCoord)));
//    gl_FragColor = mix(vec4(0.0,0.0,0.0,1.0),color,step(pro,abs(texCoord.y-0.5)));
}


