precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float getpro(float x){
    if(x<0.05)return x;
    x=(x-0.05)/0.95;
    return sqrt(1.0 - pow(x - 1.0, 2.0));
}

void main()
{
    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    float pro=getpro(1.0-progress)/2.0;
    vec4 color = texture2D(inputImageTexture, texCoord);
    float maxv=progress<=0.95?smoothstep(pro-0.01,pro+0.01,abs(texCoord.x-0.5)):1.0;
    gl_FragColor = mix(color,vec4(0.0,0.0,0.0,1.0),maxv);
//    gl_FragColor = mix(vec4(0.0,0.0,0.0,1.0),color,step(pro,abs(texCoord.x-0.5)));
}


