precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 glitchoff=vec2(0.002);
vec2 center=vec2(0.5);
vec4 black=vec4(0.0);

void main() {
    if(ratio>1.0){
        glitchoff.x/=ratio;
    }else{
        glitchoff.y*=ratio;
    }
    vec2 uv = textureCoordinate.xy;
    vec2 uvr = textureCoordinate.xy-glitchoff;
    vec2 uvb = textureCoordinate.xy+glitchoff;
    float r=getFromColor(uvr).r;
    float g=getFromColor(uv).g;
    float b=getFromColor(uvb).b;
    float mixvalue=distance(center,uv)-0.4;
    mixvalue=max(0.0,mixvalue)*2.0;
    vec4 c1=vec4(r,g,b,1.0);
    gl_FragColor=mix(c1,black,mixvalue);
}
