precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
float getusepro(float x) {
        return 1.0 - pow(1. - x, 3.);
//    return pow(x,2.0);
}
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    if (uv.y > 0.5) {
        uv.y = 1.0 - uv.y;
    }
    float isin;
    float offy;
    float uselength = 0.25;
    float maxscale = 4.0;
    float sx = 1.0;
    float sy = 1.0;
    if (ratio >= 1.0) {
        sx /= ratio;
        maxscale *= ratio;
    } else {
        sy *= ratio;
        maxscale /= ratio;
    }
    float usepro;
    if (progress < 0.5) {
        usepro = sqrt(progress * 2.0);
        usepro = sqrt(usepro);
        usepro = sqrt(usepro) / 2.0;
    } else {
        usepro = 0.5 + getusepro((progress - 0.5) * 2.0) / 2.0;
    }

    if (usepro < 0.5) {
        offy = (usepro - 0.5) * 1.5;
    } else {
        offy = 0.0;
        usepro = usepro - 0.5;
        uselength *= (1.0 + usepro * maxscale);
    }

    center.y += offy;
    vec2 cha = uv - center;
    cha /= vec2(sx, sy);
    if (length(cha) > uselength) {
        gl_FragColor = black;
    } else {
        gl_FragColor = getFromColor(textureCoordinate);
    }
}
