precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);
vec2 doroate(vec2 c2, float roate) {
    //计算旋转角度
    vec2 uv2 = c2 - center;
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    vec2 rtn = vec2(dx2, dy2) + center;
    return rtn;
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
float getusepro(float x) {
//    return 1.0 - pow(1. - x, 3.);
    return x < 0.5 ? 4.0 * x * x * x : 1. - pow(-2. * x + 2., 3.) / 2.;

}

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float isin;
    float uselength = 0.35;
    float maxscale = 3.0;
    float sx = 1.0;
    float sy = 1.5;
    float roate = 0.0;
    if (ratio >= 1.0) {
        sx /= ratio;
        maxscale *= ratio;
    } else {
        sy *= ratio;
        maxscale /= ratio;
    }
    float usepro;
    if (progress < 0.5) {
        usepro = getusepro(progress * 2.0) / 2.0;
    } else {
        usepro = 0.5 + getusepro((progress - 0.5) * 2.0) / 2.0;
    }

    if (usepro < 0.5) {
        roate = -(usepro - 0.5) / 2.0 * 3.14;
        sy /= (1.0 + usepro);
    } else {
        sy /= 1.5;
        sy += (usepro - 0.5);
        usepro = usepro - 0.5;
        uselength *= (1.0 + usepro * maxscale);
    }
    uv = doroate(uv, roate);
    vec2 cha = uv - center;
    cha /= vec2(sx, sy);
    if (length(cha) > uselength) {
        gl_FragColor = black;
    } else {
        gl_FragColor = getFromColor(textureCoordinate);
    }
}
