precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
float getusepro(float x) {
    return 1.0 - pow(1. - x, 3.);
}

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float isin;
    float uselength = 0.1;
    float sx = 1.0;
    float sy = 1.0;
    float offx = -0.75;
    if (progress < 0.3) {
        float usepro=getusepro(progress/0.3)*0.3;
        uselength += usepro * 2.0;
    } else if (progress < 0.33) {
        uselength += 0.6;
    } else if (progress < 0.63) {
        uselength += 0.6;
        float usepro=getusepro((progress-0.33)/0.3);
        offx += 1.5 * usepro;
    } else if (progress < 0.66) {
        uselength += 0.6;
        offx += 1.5;
    } else {
        offx += 1.5;
        uselength += 0.6;
        float usepro=getusepro((progress-0.66)/0.34);
        uselength += usepro;
    }
    if (ratio >= 1.0) {
//        offx /= (1.0 + (ratio - 1.0) / 1.4);
        sx /= ratio;
        uselength *= (1.0 + (ratio - 1.0) / 2.0);
    } else {
        sy *= ratio;
        uselength /= (ratio + (1.0 - ratio) / 2.0);
    }
    center.x += offx;
    vec2 cha = uv - center;
    cha /= vec2(sx, sy);
    if (length(cha) > uselength) {
        gl_FragColor = black;
    } else {
        gl_FragColor = getFromColor(textureCoordinate);
    }
}
