precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * 3.14159) / 2.0) + 0.5);
}

void main() {
    vec2 uv = textureCoordinate.xy / 1.0;
    float usepro=progress/2.0+0.5;
    float pro=getspeedpro(usepro);
    float mixvalue = 1.0 - pro;
    float random = (0.5 - Rand(uv * pro)) *0.05*mixvalue;
    float random2 = (0.5 - Rand(uv * pro/2.0)) *0.05*mixvalue;
    
    uv += vec2(random, random2);
    vec2 size = vec2(mixvalue * 0.02);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol=0.0;
    {
        lowp vec4 sum = vec4(0.0);
        sum += getFromColor(uv) * 1.0;

        sum += getFromColor(uv + vec2(size.x, size.y));
        sum += getFromColor(uv + vec2(-size.x, size.y));
        sum += getFromColor(uv + vec2(size.x, -size.y));
        sum += getFromColor(uv + vec2(-size.x, -size.y));

        sum += getFromColor(uv + vec2(0.0, -size.y));
        sum += getFromColor(uv + vec2(0.0, size.y));
        sum += getFromColor(uv + vec2(size.x, 0.0));
        sum += getFromColor(uv + vec2(-size.x, 0.0));
        tol+=9.0;

        sum += getFromColor(uv + vec2(0.0, -size.y*2.0));
        sum += getFromColor(uv + vec2(size.x, -size.y*2.0));
        sum += getFromColor(uv + vec2(size.x*2.0, -size.y*2.0));
        sum += getFromColor(uv + vec2(-size.x*2.0, -size.y*2.0));
        sum += getFromColor(uv + vec2(-size.x, -size.y*2.0));

        sum += getFromColor(uv + vec2(0.0, size.y*2.0));
        sum += getFromColor(uv + vec2(size.x, size.y*2.0));
        sum += getFromColor(uv + vec2(size.x*2.0, size.y*2.0));
        sum += getFromColor(uv + vec2(-size.x*2.0, size.y*2.0));
        sum += getFromColor(uv + vec2(-size.x, size.y*2.0));

        sum += getFromColor(uv + vec2(size.x*2.0, size.y));
        sum += getFromColor(uv + vec2(size.x*2.0, -size.y));
        sum += getFromColor(uv + vec2(size.x*2.0, 0.0));

        sum += getFromColor(uv + vec2(-size.x*2.0, size.y));
        sum += getFromColor(uv + vec2(-size.x*2.0, -size.y));
        sum += getFromColor(uv + vec2(-size.x*2.0, 0.0));
        tol+=16.0;
        usecolor = sum / tol;
    }
    gl_FragColor = usecolor;
}



