precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


float getusepro(float x) {
    return x < 0.5
    ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
    : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    vec2 uv = textureCoordinate / 1.0;
    float usepro = progress;
    if (uv.y < 1.0 / 3.0) {
        usepro /= 0.8;
    } else if (uv.y < 2.0 / 3.0) {
        usepro = (usepro - 0.1) / 0.8;
    } else {
        usepro = (usepro - 0.2) / 0.8;
    }
    if (usepro <= 0.0) {
        gl_FragColor = black;
        return;
    } else if (usepro >= 1.0) {
        gl_FragColor = getFromColor(uv);
        return;
    }
    usepro = getusepro(usepro);
    gl_FragColor = uv.x < usepro ? getFromColor(uv) : black;
}
