precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

vec2 doroate(vec2 c2, float roate) {
    vec2 center = vec2(0.5);
    //计算旋转角度
    vec2 uv2 = c2 - center;
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    vec2 rtn = center + vec2(dx2, dy2);
    return rtn;
}

float getusepro(float x) {
    return x < 0.5
    ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
    : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
}

//通过端点和宽度绘制矩形
//第一个是屏幕坐标，第二个是矩形的起点，上边中心点，第三个是矩形的终点，下边中心点，第四个参数是矩形的宽度，
float sdOrientedBox(in vec2 p, in vec2 a, in vec2 b, float th)
{
    float l = length(b - a);
    vec2 d = (b - a) / l;
    vec2 q = (p - (a + b) * 0.5);
    q = mat2(d.x, -d.y, d.y, d.x) * q;
    q = abs(q) - vec2(l, th) * 0.5;
    return length(max(q, 0.0)) + min(max(q.x, q.y), 0.0);
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    vec2 topcenter1 = vec2(0.35, -0.25);
    vec2 bottomcenter1 = vec2(0.35 - 0.4, 1.75);

    vec2 topcenter2 = vec2(1.05, -0.75);
    vec2 bottomcenter2 = vec2(1.05 - 0.4, 1.25);
    float usepro = progress;
    float width = 0.5;
    if (usepro < 0.5) {
        usepro=getusepro(usepro*2.0)/2.0;
        width=width+(0.5-progress)*0.2;
        usepro /= 2.0;
        topcenter1.x -= usepro;
        bottomcenter1.x -= usepro;
        topcenter2.x += usepro;
        bottomcenter2.x += usepro;
    } else {
        usepro = (usepro - 0.5);
        usepro=getusepro(usepro*2.0);
        topcenter1.x -= 0.25;
        bottomcenter1.x -= 0.25;
        topcenter2.x += 0.25;
        bottomcenter2.x += 0.25;

        vec2 cha1 = bottomcenter1 - topcenter1;
        vec2 cha2 = topcenter2 - bottomcenter2;
        //      角度
        float jiaodu = -3.14 / 2.0;
        jiaodu *= usepro;
        cha1 = doroate(cha1, jiaodu);
        cha2 = doroate(cha2, jiaodu);
        bottomcenter1 = topcenter1 + cha1;
        topcenter2 = bottomcenter2 + cha2;
    }
    float isin = sdOrientedBox(textureCoordinate, topcenter1, bottomcenter1, width);
    if (isin < 0.0) {
        gl_FragColor = black;
        return;
    }
    isin = sdOrientedBox(textureCoordinate, topcenter2, bottomcenter2, width);
    if (isin < 0.0) {
        gl_FragColor = black;
        return;
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
