precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);
vec2 doroate(vec2 c2, float roate) {
    //计算旋转角度
    vec2 uv2 = c2 - center;
    //    if (ratio > 1.0) {
    //        uv2.x = uv2.x * ratio;
    //    } else {
    //        uv2.y = uv2.y / ratio;
    //    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    //    if (ratio > 1.0) {
    //        dx2 = dx2 / ratio;
    //    } else {
    //        dy2 = dy2 * ratio;
    //    }
    vec2 rtn = vec2(dx2, dy2) + center;
    return rtn;
}
float sdOrientedBox(in vec2 p, in vec2 a, in vec2 b, float th)
{
    float l = length(b - a);
    vec2 d = (b - a) / l;
    vec2 q = (p - (a + b) * 0.5);
    q = mat2(d.x, -d.y, d.y, d.x) * q;
    q = abs(q) - vec2(l, th) * 0.5;
    return length(max(q, 0.0)) + min(max(q.x, q.y), 0.0);
}

float getusepro(float x) {
    return x < 0.5 ? 16.0 * x * x * x * x * x : 1.0 - pow(-2.0 * x + 2.0, 5.0) / 2.0;
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    float usepro;
    if (progress < 0.5) {
        usepro = getusepro(progress * 2.0) / 2.0;
    } else {
        usepro = 0.5 + getusepro((progress - 0.5) * 2.0) / 2.0;
    }
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    if (ratio > 1.0) {
        uv.x = 0.5 + (uv.x - 0.5) * ratio;
    } else {
        uv.y = 0.5 + (uv.y - 0.5) / ratio;
    }
    float isin;
    if (usepro < 0.5) {
        if (uv.x > 0.5) {
            uv.x = 1.0 - uv.x;
        }
        if (uv.y > 0.5) {
            uv.y = 1.0 - uv.y;
        }
        float uselength = 0.25 * sqrt(2.0);
        float miny = 0.5 - uselength;
        if (uv.x < miny || uv.y < miny) {
            isin = 1.0;
        } else {
            float maxw = usepro * 2.0 * uselength;
            float usex = 0.5 - (uv.y - miny) / uselength * maxw;
            isin = uv.x < usex ? 1.0 : -1.0;
        }
    } else {
        float width = usepro;
        //        0->0.5
        usepro = usepro - 0.5;
        //        45->0
        float roate = 3.14 / 2.0 * (0.5 - usepro);
        //        0.25->0
        float ww = 0.25 - usepro / 2.0;

        vec2 topcenter1, bottomcenter1;
        topcenter1 = vec2(ww, 0.5);
        topcenter1 = doroate(topcenter1, roate);
        bottomcenter1 = vec2(1.0) - topcenter1;
        float scale = ratio > 1.0 ? ratio : 1.0 / ratio - 1.0;
        uv = (uv - center) / (1.0 + usepro * 2.0 * scale) + center;
        isin = sdOrientedBox(uv, topcenter1, bottomcenter1, width);
    }
    if (isin > 0.0) {
        gl_FragColor = black;
    } else {
        gl_FragColor = getFromColor(textureCoordinate);
    }
}
