precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float isin;
    float offy;
    float sx = 1.0;
    float sy = 1.2;
    float uselength = 0.25;
    float maxscale=4.0;
    if(ratio>=1.0){
        sx/=ratio;
        maxscale*=ratio;
    }else{
        sy*=ratio;
        maxscale/=ratio;
    }
    if (progress < 0.5) {
        offy = 1.0 - progress * 2.0;
    } else {
        offy = 0.0;
        float usepro = progress - 0.5;
        uselength *= (1.0 + usepro * maxscale);
        sx *= 1.0 + usepro * 0.4;
    }

    center.y += offy;
    vec2 cha = uv - center;
    cha /= vec2(sx, sy);
    if (length(cha) > uselength) {
        gl_FragColor = black;
    } else {
        gl_FragColor = getFromColor(textureCoordinate);
    }
}
