precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp float lengthx;
uniform highp float lengthy;

highp vec2 center = vec2(0.5);
//矩形
float sdBox(in vec2 p, in vec2 b) {
    vec2 d = abs(p) - b;
    return length(max(d, 0.0)) + min(max(d.x, d.y), 0.0);
}
vec4 bordercolor = vec4(1.0);

void main() {
    vec2 rect=vec2(lengthx,lengthy);
    highp float length = sdBox(textureCoordinate - center, rect);
    if (length > 0.0) {
        gl_FragColor = bordercolor;
    } else {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }
}