precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

vec2 FactorA = vec2(100.0, 100.0);
vec2 FactorB = vec2(1.0, 1.0);
vec2 FactorScale = vec2(0.005);

vec2 shake() {
    if (progress < 0.01){
        return (vec2(0.0));
    }
    float iTime = progress/5.0;
    vec2 uniA = FactorA;
    vec2 uniB = FactorB;
    vec2 uniScale = FactorScale;

    vec2 dt = vec2(0.0, 0.0);
    dt.x = sin(iTime * uniA.x + uniB.x) * uniScale.x;
    dt.y = cos(iTime * uniA.y + uniB.y) * uniScale.y;
    return dt;
}

void main() {
    vec2 uv = textureCoordinate.xy / 1.0;
    vec4 color1 = texture2D(inputImageTexture, uv + shake());
    gl_FragColor = color1;

}



