precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

void main() {
    //分屏特效
    //x 和 y 的 分割数量
    vec2 num = vec2(2.0, 2.0);

    vec2 uv = mod(textureCoordinate, 1.0 / num);

    if (num.x == num.y) {
        uv *= num;
        gl_FragColor = getFromColor(uv);
        return;
    }

    if (num.x > num.y) {
        uv *= num.y;
        uv.x += (1.0 - num.y / num.x) * 0.5;
    } else {
        uv *= num.x;
        uv.y += (1.0 - num.x / num.y) * 0.5;
    }

    gl_FragColor = getFromColor(uv);
}
