precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//黑白三格
void main() {

    if(textureCoordinate.y > 0.2 && textureCoordinate.y < 0.8) {
        gl_FragColor = getFromColor(textureCoordinate);
        return;
    }

    //先图片按照中心放大1.7倍，再转换成黑白色
    vec2 uv = (textureCoordinate - 0.5) / 1.7 + 0.5;

    vec4 src = getFromColor(uv);
    // 先把彩色转换为黑白色
    float f1 = src.r * 0.3 + src.g * 0.59 + src.b * 0.11;
    //再用颜色表映射下，给定的颜色表是ffffff-2a2a2a的线性灰度条
    //因此把FF-00映射到FF-2A，即255-0映射到255-42
    float f2 = (f1 * 213.0 + 42.0) / 255.0;

    gl_FragColor = vec4(f2, f2, f2, src.a);

}
