precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

float dodistance(vec2 v1, vec2 v2){
    vec2 cha= v1-v2;
    ratio>=1.0?cha.y/=ratio:cha.x*=ratio;
    cha.x/=1.5;
    return sqrt(cha.x*cha.x+cha.y*cha.y);
}

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

float fenkuai(float pro, float sp){
    float usey=pro*sp-fract(pro*sp);
    return usey;
}
void main()
{
    float usepro=progress;
    usepro=usepro*2.0;
    if (usepro<0.1){
        gl_FragColor= vec4(0.0, 0.0, 0.0, 1.0);
        return;
    }
    vec2 texCoord = textureCoordinate;//根据纹理尺寸，对采用坐标进行转换
    if (usepro<0.5){
        float pro=(usepro-0.1)*2.5;
        vec2 center=vec2(0.5);
        pro=smoothstep(0.0, 1.0, pro)/2.0;
        float num=1.0-smoothstep(pro, pro+(0.2*min(pro*10.0, 1.0)), dodistance(center, texCoord));
        gl_FragColor=vec4(num, num, num, 1.0);
        return;
    }
    if (usepro>0.99){
        gl_FragColor= texture2D(inputImageTexture, texCoord);
        return;
    }

    float pro=(usepro-0.5)*2.0;
    float kuai=360.0/ratio;
    float usey1=fenkuai(texCoord.y, kuai);
    float usey2=usey1+kuai;
    float usey3=usey1-kuai;

    float offx1=Rand(vec2(usey1, pro));
    float offx2=Rand(vec2(usey2, pro));
    float offx3=Rand(vec2(usey3, pro));
    float offx=(offx1+offx2+offx3)/3.0;
    offx-=0.5;
//    gl_FragColor=vec4(offx,offx,offx,1.0);
    offx=offx/10.0/ratio*smoothstep(0.0,1.0,1.0-pro);
    texCoord.x+=offx;
    vec4 color = texture2D(inputImageTexture, texCoord);
    gl_FragColor = color;
}


