// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 1-6
// https://gl-transitions.com/editor/CrossZoom

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
float druction=1000.0;
float nowtime=0.0;

float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}
vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

float getvalue(float usepro){
    float rtn=0.0;
    if (usepro<0.1){
        rtn=usepro*2.0;
    } else if (usepro<0.5){
        rtn=0.2+(usepro-0.1)/2.0;
    } else {
        rtn=0.4-(usepro-0.5)*0.8;
    }
    return rtn;
}

float getscale(float usepro){
    float rtn=0.0;
    if (usepro<0.1){
        rtn=1.0-usepro*1.5;
    } else {
        rtn=0.85+(usepro-0.1)/9.0*1.5;
    }
    return rtn;
}


void main() {
    nowtime=mod(progress,druction)/druction;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    float usepro=getspeedpro(nowtime);
    vec2 center =vec2(0.5);

    vec2 toCenter = center - texCoord;
    float scale=getscale(usepro);
    toCenter*=scale;
    //    vec2 pos=center-toCenter;
    //    gl_FragColor=texture2D(inputImageTexture, pos);    return;

    float strength = getvalue(usepro);
    vec3 color = vec3(0.0);
    float total = 0.0;

    /* randomize the lookup values to hide the fixed number of samples */
    float num=10.0;
    for (float t = 0.0; t <= num; t++) {
        vec2 pos=center - toCenter *(1.0+t/10.0*strength);
        vec4 use=texture2D(inputImageTexture, pos);
        total += 1.0;
        color.rgb += use.rgb;
    }
    gl_FragColor= vec4(color / total*(1.0+strength),1.0);
}
