precision highp float;
varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

//要画多少条线
uniform float linenum;

//将x*linenum归一化处理，判断宽度 x是线的宽度
uniform float linewidth;

//y轴对称
uniform int iscenter;
//绘制下落的高点
uniform int drawdown;
// 画方块,y部分是间隔(0-0.5)，x部分是分几段
uniform vec2 userect;
uniform float alpha;
float usealpha = 1.0;
uniform int type;
//镜像
//0 不镜像
//1 0-->1 1-->0
//2 1-->0 0-->1
uniform int mirror;
//没传入数据
uniform int empty;
uniform vec2 circle;
uniform float ratio;

uniform vec4 colors0;
uniform vec4 colors1;
uniform vec4 colors2;
uniform vec4 colors3;
uniform vec4 colors4;
uniform vec2 colorsinfo;

bool usepoint;




vec4 getcolor(float pos) {
    if (pos < 1.0) {
        return colors0;
    }
    if (pos < 2.0) {
        return colors1;
    }
    if (pos < 3.0) {
        return colors2;
    }
    if (pos < 4.0) {
        return colors3;
    }
    if (pos < 5.0) {
        return colors4;
    }
    return vec4(0.0);
}
vec4 setcolor(float y) {
    vec4 rtn;
    //渐变颜色
    vec4 color1;
    vec4 color2;
    float colorsize = colorsinfo.x;
    if (colorsize == 1.0) {
        rtn = colors0 * alpha;
        return rtn;
    }
    //不渐变，color1与color2一样
    usepoint = colorsinfo.y > 0.0;
    if (!usepoint) {
        colorsize -= 1.0;
    }
    float colorpos = y * colorsize;
    float color1pos = floor(colorpos);
    color1 = getcolor(color1pos);
    if (usepoint) {
        rtn = color1;
    } else {
        color2 = getcolor(color1pos + 1.0);
        rtn = mix(color1, color2, fract(colorpos));
    }
    return rtn * alpha * usealpha;
}

float getmirrorx(float x) {
    if (mirror == 1) {
        if (x > 0.5) {
            x = 1.0 - x;
        }
        //        x *= 2.0;
    } else if (mirror == 2) {
        if (x < 0.5) {
            x = 0.5 - x;
        } else {
            x -= 0.5;
        }
        //        x *= 2.0;
    }
    return x;
}

float getvalue(sampler2D Texture, vec2 pos) {
    if (empty > 0) {
        return 0.01;
    }
    float v = texture2D(Texture, pos).a;
    float addmin = 0.01;
    if (type == 3) {
        addmin = 0.01;
    }
    return max(v, addmin);
    //    return 1.0;
}

void main() {
    vec2 pos = textureCoordinate / 1.0;
    if (type == 3) {
        float value = getvalue(inputImageTexture, pos);
        if (value > pos.y) {
            //            float cha = value - pos.y;
            //            if (cha < 0.01) {
            //                usealpha = cha * 100.0;
            //            }
            gl_FragColor = setcolor(pos.y);
        } else {
            discard;
        }

        //        pos.x = 1.0 - pos.x;
        //        float valuemirror = getvalue(inputImageTexture, pos);
        //        float maxvalue = max(value, valuemirror);
        //        if (maxvalue > pos.y) {
        //            if (value > pos.y) {
        //                usealpha = 1.0;
        //            } else if (valuemirror > pos.y) {
        //                usealpha = 0.5;
        //            }
        //            gl_FragColor = setcolor(pos.y);
        //        } else {
        //            discard;
        //        }
        return;
    }
    if (type == 7) {
        vec2 ratiov = vec2(0.001);
        if (ratio < 1.0) {
            ratiov.x /= ratio;
        } else {
            ratiov.y *= ratio;
        }
        for (float i = -2.0; i < 2.5; i++) {
            for (float j = -2.0; j < 2.5; j++) {
                vec2 add = vec2(i, j) * ratiov;
                vec2 usepos = add + pos;
                float value = getvalue(inputImageTexture, usepos);
                float cha = abs(pos.y - value);
                if (cha < 0.02) {
                    gl_FragColor = setcolor(pos.y);
                    return;
                }
            }
        }
        discard;
        return;
    /**float value = getvalue(inputImageTexture, pos);
        float cha = abs(pos.y - value);
        if (cha < 0.02) {
            gl_FragColor = setcolor(pos.y);
        } else {
            discard;
        }
        return;*/
    }
    pos.x = getmirrorx(pos.x);

    float outx = pos.x * linenum;
    //    float x = fract(outx);
    float x = outx - floor(outx);
    float xpos = abs(0.5 - x);
    float chax = (linewidth / 2.0) - xpos;

    if (chax > 0.0) {
        //        float falloff = 0.1;
        //        if (chax < falloff && userect.x < 0.0) {
        //            usealpha = chax * 10.0;
        //        }
        float toborderx;
        float tobordery;
        bool isiny;
        outx = outx - x;
        float usex = outx / linenum;
        pos.x = usex;
        pos.y = 0.5;
        float value = getvalue(inputImageTexture, pos);
        //value = 1.0;
        float mixy;
        //       userect的整数与小数部分
        float rectsize = userect.x;
        float voids = userect.y;

        if (drawdown > 0) {
            float valuedown = getvalue(inputImageTexture2, pos);
            if (valuedown > value && rectsize > 0.0) {
                tobordery = abs(textureCoordinate.y - valuedown);
                isiny = tobordery * rectsize < voids / 2.0;

                if (isiny) {
                    if (type == 1) {
                        tobordery /= circle.y;
                        isiny = tobordery < 1.0;
                        float posx = min(x, 1.0 - x);
                        float borderx = (1.0 - linewidth) / 2.0;
                        toborderx = (posx - borderx) / linenum;
                        toborderx /= circle.x;
                        if (isiny && toborderx < 1.0) {
                            toborderx = 1.0 - toborderx;
                            isiny = toborderx * toborderx + tobordery * tobordery < 1.0;
                        }
                    }
                    if (isiny) {
                        gl_FragColor = setcolor(valuedown);
                        // gl_FragColor = vec4(0.0);
                        // gl_FragColor.a = 1.0;
                        return;
                    }
                    discard;
                    return;
                }
            }
        }

        float colory = textureCoordinate.y;
        if (rectsize > 0.0) {
            colory = floor(textureCoordinate.y * rectsize) / rectsize;
        }
        if (iscenter > 0) {
            mixy = abs(0.5 - textureCoordinate.y) * 2.0;
            isiny = mixy < value;
            colory = mixy;
        } else {
            isiny = colory <= value;
        }

        if (isiny) {
            if (rectsize > 0.0) {
                float usey = fract(textureCoordinate.y * rectsize);
                voids /= 2.0;
                isiny = abs(voids - usey) <= voids;
                //            绘制圆角
            /** if (isiny && type == 1) {
                    tobordery = abs(voids - usey) / rectsize;
                    float posx = min(x, 1.0 - x);
                    float borderx = (1.0 - linewidth) / 2.0;
                    toborderx = (posx - borderx) / linenum;
                    toborderx /= circle.x;
                    tobordery /= circle.y;
                    isiny = tobordery < 1.0;
                    if (isiny && toborderx < 1.0) {
                        toborderx = 1.0 - toborderx;
                        isiny = toborderx * toborderx + tobordery * tobordery < 1.0;
                    }
                }*/
            }
        }
        if (isiny) {
            gl_FragColor = setcolor(colory);;
            return;
        }
    }

    //    else{
    //        gl_FragColor = vec4(1.0);
    //        return;
    //    }
    //      放弃本次绘制
    discard;

}
