precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec4 color;
uniform float ratio;
uniform float alpha;


float getusecolor(vec2 pos) {
    return texture2D(inputImageTexture, pos).a;
}
void main() {
    vec2 uv = textureCoordinate;
    float mixvalue = 540.0;
    vec2 size = vec2(1.0 / mixvalue);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol = 25.0;
    float sum = 0.0;
    sum += getusecolor(uv);
    sum += getusecolor(uv + vec2(size.x, size.y));
    sum += getusecolor(uv + vec2(-size.x, size.y));
    sum += getusecolor(uv + vec2(size.x, -size.y));
    sum += getusecolor(uv + vec2(-size.x, -size.y));
    sum += getusecolor(uv + vec2(0.0, -size.y));
    sum += getusecolor(uv + vec2(0.0, size.y));
    sum += getusecolor(uv + vec2(size.x, 0.0));
    sum += getusecolor(uv + vec2(-size.x, 0.0));

    sum += getusecolor(uv + vec2(0.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x, -size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x * 2.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x, -size.y * 2.0));

    sum += getusecolor(uv + vec2(0.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x, size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x * 2.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x * 2.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x, size.y * 2.0));

    sum += getusecolor(uv + vec2(size.x * 2.0, size.y));
    sum += getusecolor(uv + vec2(size.x * 2.0, -size.y));
    sum += getusecolor(uv + vec2(size.x * 2.0, 0.0));

    sum += getusecolor(uv + vec2(-size.x * 2.0, size.y));
    sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y));
    sum += getusecolor(uv + vec2(-size.x * 2.0, 0.0));
    sum /= tol;
    if (sum == 0.0) {
        gl_FragColor = vec4(0.0);
    } else {
        gl_FragColor = color * sum * alpha;
    }

}
