precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float ratio;
uniform float roate;
uniform vec2 scale;

vec2 center = vec2(0.5);

vec2 doroate(vec2 uv) {
    //计算旋转角度
    if (ratio > 1.0) {
        uv.x = uv.x * ratio;
    } else {
        uv.y = uv.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv.x * c + uv.y * s;
    float dy2 = -uv.x * s + uv.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    return vec2(dx2, dy2);
}

void main() {
    vec2 pos = textureCoordinate - center;
    pos /= scale;
    pos = doroate(pos);
    if (abs(pos.x) >= 0.5 || abs(pos.y) >= 0.5) {
        gl_FragColor = vec4(0.0);
    } else {
        pos += center;
        gl_FragColor = texture2D(inputImageTexture, pos);
    }
}
