precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

const float PI = 3.1415926535897932;
const float speed = 0.2;
const float speed_x = 0.3;
const float speed_y = 0.3;
const float intensity = 3.0;
const int steps = 8;
const float frequency = 4.0;
const int angle = 7;

const float delta = 20.0;
const float intence = 400.0;
const float emboss = 0.3;

const vec2 vp = vec2(1080.0, 1080.0);

void main() {
    float t = progress * 10.0 + textureCoordinate.x;
    vec2 uv = textureCoordinate;
    vec2 p0 = (uv - 0.5) * vp;
    vec2 hvp = vp * 0.5;
    vec2 p1d = vec2(cos( t / 98.0),  sin( t / 178.0)) * hvp - p0;
    vec2 p2d = vec2(sin(-t / 124.0), cos(-t / 104.0)) * hvp - p0;
    vec2 p3d = vec2(cos(-t / 165.0), cos( t / 45.0))  * hvp - p0;
    float sum = 0.5 + 0.5 * (
    cos(length(p1d) / 30.0) +
    cos(length(p2d) / 20.0) +
    sin(length(p3d) / 25.0) * sin(p3d.x / 20.0) * sin(p3d.y / 15.0));
    gl_FragColor = texture2D(inputImageTexture, textureCoordinate+vec2(fract(sum)/50.0));
}


