precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

const float PI = 3.1415926535897932;
const float speed = 0.2;
const float speed_x = 0.3;
const float speed_y = 0.3;
const float intensity = 3.0;
const int steps = 8;
const float frequency = 4.0;
const int angle = 7;

const float delta = 20.0;
const float intence = 400.0;
const float emboss = 0.3;

float col(vec2 coord)
{
    float delta_theta = 2.0 * PI / float(angle);
    float col = 0.0;
    float theta = 0.0;
    float time = progress;
    for (int i = 0; i < steps; i++)
    {
        vec2 adjc = coord;
        theta = delta_theta * float(i);
        adjc.x += cos(theta)*time*speed + time * speed_x;
        adjc.y -= sin(theta)*time*speed - time * speed_y;
        col = col + cos((adjc.x*cos(theta) - adjc.y*sin(theta))
                        *frequency)*intensity;
    }
    return cos(col);
}
void main() {
    vec2 p = textureCoordinate;
    vec2 c1 = p;
    vec2 c2 = p;
    float cc1 = col(c1);

    c2.x += progress/delta;
    float dx = emboss*(cc1-col(c2))/delta;

    c2.x = p.x;
    c2.y += progress/delta;
    float dy = emboss*(cc1-col(c2))/delta;

    c1.x += dx;
    c1.y += dy;
    gl_FragColor = texture2D(inputImageTexture,c1);
}


