precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 pos;
uniform vec2 scale;
uniform float bg;
uniform float roate;
uniform float alpha;

float getusevalue(float value, float scale) {
    bool isless = value < 0.0;
    value = abs(value);
    value *= scale;
    float cha = scale / 2.0 - 0.5;
    value -= cha;
    value = max(0.0, value);
    value *= isless ? -1.0 : 1.0;
    return value;
}

vec2 center = vec2(0.5);
void main() {
    vec2 texCoord = textureCoordinate / vec2(1.0);
    vec2 usepos = texCoord - center;
//    usepos *= 0.8;
    usepos.y = -usepos.y;
    if (bg < 0.5) {
        vec2 usepos1 = usepos / pos.xy + center;
        if (roate > 0.0) {
            usepos1 = usepos1.yx;
        }
        gl_FragColor = texture2D(inputImageTexture, usepos1);
    } else {
        vec2 usepos2 = usepos / pos.xy;
        if (abs(usepos2.x) <= 0.5 && abs(usepos2.y) <= 0.5) {
            usepos2.x = getusevalue(usepos2.x, scale.x);
            usepos2.y = getusevalue(usepos2.y, scale.y);
            usepos2 += center;
            vec4 color2 = texture2D(inputImageTexture, usepos2);
            if (color2.a < 0.02) {
                color2 = vec4(0.0);
            }
            gl_FragColor = color2;
            //            vec4 red = vec4(1.0, 0.0, 0.0, 1.0);
            //            gl_FragColor = mix(red, color2, 0.5);
        } else {
            gl_FragColor = vec4(0.0);
        }
    }
    gl_FragColor.a = gl_FragColor.a * alpha;

}
