precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;//图片的宽高比

//滚动的图片中心点y坐标
float scy=0.1;
float points [8];


//这个是横向的
void main() {
    //长的一端会缩小到这个比例/2.0
    float usescalex;
    if(ratio>1.0)
    usescalex=0.15/ratio;
    else
    usescalex=0.15*ratio;

    float usescaley=usescalex/ratio;

    //    优先检测y的范围
    if (abs(textureCoordinate.y-scy)<usescaley
    ||abs(textureCoordinate.y-(1.0-scy))<usescaley){

        float point=8.0;
        int i =0;
        float pointpos=0.0;
        for (i =0;i<8;i++, pointpos++){
            points[i]=1.0/point*pointpos;
        }
        i =0;
        bool istop=true;
        vec2 usecenter=vec2(0.0);
        bool redo=false;
        for (i =0;i<8;i++,istop=!istop){
            usecenter.x =points[i]+progress;
            usecenter.x=usecenter.x>1.0?usecenter.x-1.0:usecenter.x;
            usecenter.y=istop?scy:1.0-scy;
            usecenter.x=istop?usecenter.x:1.0-usecenter.x;
            if (abs(textureCoordinate.y-usecenter.y)<usescaley){
                if (abs(textureCoordinate.x-usecenter.x)<usescalex){
                    vec2 realpos=textureCoordinate-usecenter;
                    realpos.x/=(usescalex);
                    realpos.y/=(usescaley);
                    realpos+=0.5;
                    if(abs(realpos.x-0.5)>0.49||abs(realpos.y-0.5)>0.49){
                        gl_FragColor=vec4(0.0,0.0,0.0,0.0);
                        return;
                    }
                    gl_FragColor=texture2D(inputImageTexture, realpos);
//                    gl_FragColor=vec4(1.0);
                    return;
                }
                //        usecenter靠近1 textureCoordinate.x在0的一端
                if (usecenter.x>1.0-usescalex&&textureCoordinate.x<usecenter.x+usescalex-1.0){
//                    gl_FragColor=vec4(0.0,usecenter.x*10.0,0.0,1.0);
//                    return;
                    usecenter.x-=1.0;
                    redo=true;
                }
                else if (usecenter.x<usescalex && textureCoordinate.x>1.0-(usescalex-usecenter.x)){ // usecenter靠近0
//                    gl_FragColor=vec4(usecenter.x*10.0,0.0,0.0,1.0);
//                    return;
                    usecenter.x=1.0+(usecenter.x);
                    redo=true;
                }
                if (redo){
                    vec2 realpos=textureCoordinate-usecenter;
                    realpos.x/=(usescalex);
                    realpos.y/=(usescaley);
                    realpos+=0.5;
                    if(abs(realpos.x-0.5)>0.49||abs(realpos.y-0.5)>0.49){
                        gl_FragColor=vec4(0.0,0.0,0.0,0.0);
                        return;
                    }
                    gl_FragColor=texture2D(inputImageTexture, realpos);
                    return;
                }
            }

        }
    }
    gl_FragColor=vec4(0.0);

}
