precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
const float PI = 3.1415926;
uniform float ratio;//显示界面的宽高比

//滚动的图片中心点y坐标
float scx=0.1;
//这个是横向的
void main() {

    float points [10];
    int pointlength=10;

    //长的一端会缩小到这个比例/2.0
    float usescalex;
    if(ratio>1.0)
    usescalex=0.15/ratio;
    else
    usescalex=0.15*ratio;

    float usescaley=usescalex/ratio;

    float panudanx=max(usescalex,usescaley)/2.0;
    float panudany=max(usescalex,usescaley)/2.0;

    //    优先检测y的范围
    if (abs(textureCoordinate.x-scx)<panudanx
    ||abs(textureCoordinate.x-(1.0-scx))<panudanx){

        float point=10.0;
        int i =0;
        float pointpos=0.0;
        for (i =0;i<pointlength;i++, pointpos++){
            points[i]=1.0/point*pointpos;
        }
        i =0;
        bool isleft=true;
        vec2 usecenter=vec2(0.0);
        bool redo=false;
        float roate=0.0;
//        float tolroate=4.0*PI;
        for (i =0;i<pointlength;i++,isleft=!isleft){
            usecenter.y =points[i]-progress;
            usecenter.y=usecenter.y<1.0?usecenter.y+1.0:usecenter.y;
//            roate=usecenter.y*tolroate;
            usecenter.x=isleft?scx:1.0-scx;
            usecenter.y=isleft?usecenter.y:1.0-usecenter.y;
            if (abs(textureCoordinate.x-usecenter.x)<panudanx){
                if (abs(textureCoordinate.y-usecenter.y)<panudany){
                    vec2 realpos=textureCoordinate-usecenter;
                    realpos.x/=(usescalex);
                    realpos.y/=(usescaley);
                    realpos+=0.5;
                    if(abs(realpos.x-0.5)>0.49||abs(realpos.y-0.5)>0.49){
                        gl_FragColor=vec4(0.0,0.0,0.0,0.0);
                        return;
                    }
                    gl_FragColor=texture2D(inputImageTexture, realpos);
                    return;
                }
                //        usecenter靠近1 textureCoordinate.x在0的一端
                if (usecenter.y>1.0-panudany&&textureCoordinate.y<usecenter.y+panudany-1.0){
                    usecenter.y-=1.0;
                    redo=true;
                }
                else
                if (usecenter.y<panudany && textureCoordinate.y>1.0-(panudany-usecenter.y)){ // usecenter靠近0
                    usecenter.y=1.0+(usecenter.y);
                    redo=true;
                }
                if (redo){
                    vec2 realpos=textureCoordinate-usecenter;
                    realpos.x/=(usescalex);
                    realpos.y/=(usescaley);
                    realpos+=0.5;
                    if(abs(realpos.x-0.5)>0.49||abs(realpos.y-0.5)>0.49){
                        gl_FragColor=vec4(0.0,0.0,0.0,0.0);
                        return;
                    }
                    gl_FragColor=texture2D(inputImageTexture, realpos);
                    return;
                }
            }
        }
    }
    gl_FragColor=vec4(0.0);

}
