precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform float offroate;
uniform float alpha;
const float PI = 3.1415926;
vec2 center=vec2(0.5,1.5);



vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(dx2,dy2)+center;
    return rtn;
}


vec2 reset2(vec2 texCoord){
    if (texCoord.x<0.0){
        texCoord.x=0.0;
    } else if (texCoord.x>1.0){
        texCoord.x=1.0;
    }
    if (texCoord.y<0.0){
        texCoord.y=0.0;
    } else if (texCoord.y>1.0){
        texCoord.y=1.0;
    }
    return texCoord;

}

//左右抖动
void main() {

    vec2 texCoord=textureCoordinate/vec2(1.0);
//    gl_FragColor= texture2D(inputImageTexture, texCoord);return;
    float num=5.0;
    vec4 color=vec4(0.0);
    float total=num*2.0;
    for (float t = 0.0; t < total; t++) {
        vec2 movepos=texCoord;
        movepos=doroate(movepos,(t/total)*(offroate));
        movepos=reset2(movepos);
        vec4 use=texture2D(inputImageTexture, movepos);
        color += use;
    }
    gl_FragColor= vec4(color / total);
    gl_FragColor*=(gl_FragColor.a*alpha);
}
