precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

//结束时的缩小比例
float endscale=0.2;
//存储十个最终坐标
vec2 points [5];
vec2 movecenter=vec2(0.5,0.8);

void main() {
    if (progress<0.05){
        gl_FragColor=vec4(0.0);
        return;
    }
    else {
        //重置0-1
        float usepro=1.0;
        if (progress<0.95)
        usepro=(progress-0.05)/0.9;
        usepro=smoothstep(0.0,1.0,usepro);
        float alpha = 1.0;
        if(usepro>0.9){
            alpha=sqrt((1.0-usepro)*10.0);
        }else
        if(usepro<0.1){
            alpha=sqrt(usepro*10.0);
        }
        float miny=movecenter.y-(movecenter.y-0.2)*usepro;
        float maxy=movecenter.y-(movecenter.y-0.52)*usepro;
        if(textureCoordinate.y>maxy||textureCoordinate.y<miny){
            gl_FragColor=vec4(0.0);
            return;
        }


        points[0]=vec2(0.5, 0.3);
        points[2]=vec2(0.14, 0.42);
        points[3]=vec2(1.0-0.14, 0.42);
        points[1]=vec2(0.32, 0.33);
        points[4]=vec2(1.0-0.32, 0.33);

        vec2 center=vec2(0.5);

        vec2 usecenter;
        float usescale=endscale*usepro;
        gl_FragColor=vec4(0.0);
        for(int i=0;i<5;i++){
            usecenter=points[i];
            if(ratio>1.0){
                usecenter.x=0.5+(usecenter.x-0.5)/ratio;
            }else if(ratio<1.0){
                usecenter.y=0.5+(usecenter.y-0.5)*ratio;
            }

            usecenter=movecenter+(usecenter-movecenter)*usepro;
            if(
            abs(usecenter.x-textureCoordinate.x)<=usescale/2.0&&
            abs(usecenter.y-textureCoordinate.y)<=usescale/2.0){
                vec2 realpos=center+(textureCoordinate-usecenter)/usescale;
                if(
                abs(realpos.x-0.5)>=(0.48-0.03*(1.0-usepro))||
                abs(realpos.y-0.5)>=(0.48-0.03*(1.0-usepro))){
                    continue;
                }
                gl_FragColor=texture2D(inputImageTexture, realpos);
                gl_FragColor*=alpha;
                if(gl_FragColor.r!=0.0)
                return;
            }
        }
    }

}
