precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

const float PI = 3.1415926;

float getcolor(vec2 pos){
    vec4 color=texture2D(inputImageTexture, pos);
    float rtn=color.r+color.g+color.b;
    return rtn/3.0;
}
void main() {
    float size=1.0/300.0;
    vec2 pos=textureCoordinate;
    float gx=
    (-1.0)*getcolor(pos-vec2(size,size))+
    (-2.0)*getcolor(pos-vec2(size,0))+
    (-1.0)*getcolor(pos-vec2(size,-size))+
    (1.0)*getcolor(pos+vec2(size,size))+
    (2.0)*getcolor(pos+vec2(size,0))+
    (1.0)*getcolor(pos+vec2(size,-size));

    float gy=
    (-1.0)*getcolor(pos-vec2(-size,size))+
    (-2.0)*getcolor(pos-vec2(0,size))+
    (-1.0)*getcolor(pos-vec2(size,size))+
    (1.0)*getcolor(pos+vec2(-size,size))+
    (2.0)*getcolor(pos+vec2(0,size))+
    (1.0)*getcolor(pos+vec2(size,size));

    float rtn=sqrt(gx*gx+gy*gy);
    gl_FragColor=rtn>0.5?vec4(1.0):vec4(0.0,0.0,0.0,1.0);

//    gl_FragColor = texture2D(inputImageTexture, pos);
}


