precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float texStepX;
uniform lowp float texStepY;
uniform lowp int  isemoji;

mediump float getGaussWeight(mediump float currentPos, mediump float sigma)
{
    return 1.0 / sigma * exp(-(currentPos * currentPos) / (2.0 * sigma * sigma));
}

vec2 center=vec2(0.5);
float getvalue(vec2 realpos){
    vec2 pos=texStepY==0.0?realpos:(center+(realpos-center)*1.5);
    if(pos.x<=0.0||pos.y<=0.0||pos.x>=1.0||pos.y>=1.0){
        return 0.0;
    }
    if(isemoji>0){
        return texture2D(inputImageTexture, pos).a;
    }else{
        return texture2D(inputImageTexture, pos).r;
    }

}

void main()
{
    float uRadius=10.0;
    float diameter = 2.0 * uRadius + 1.0;
    float sampleTex = 0.0;
    float col = 0.0;
    float weightSum = 0.0;
    for(float i = 0.0; i < diameter; i++) {
        vec2 offset = vec2((i - uRadius) * texStepX, (i - uRadius) * texStepY);
        sampleTex = getvalue(textureCoordinate+offset);
        float gaussWeight = getGaussWeight(
        i - (diameter - 1.0)/2.0,
        ((diameter - 1.0)/2.0 + 1.0) / 2.0);
        col += sampleTex * gaussWeight;
        weightSum += gaussWeight;
    }
    float value=col / weightSum;
    value=texStepY==0.0?value:sqrt(value);
    gl_FragColor = vec4(value);
}


