#version 300 es
precision highp float;
in vec2 textureCoordinate;

//绘制渐变文字的时候实际位置
//r x 起始位置，g x的长度,b y 起始位置,a y的长度
in float textalpha;
in vec4 realpos;
in float isemoji;

out vec4 outcolor;

uniform sampler2D inputImageTexture;
uniform sampler2D textsharder;
uniform int isback;
//这次绘制是画到屏幕上还是画到画布上 1，画布，<1 屏幕
uniform int istoTexture;
//花字的图片
uniform int istextsharder;


// 渐变
uniform int isgradient;
uniform vec3 gradientcolor_start;
uniform vec3 gradientcolor_end;
//1://左 → 右
//2://上 → 下
uniform int gradient_state;

uniform vec4 backcolor;
uniform float backround;
uniform float ratio;


uniform int isblur;

//这个alpha 是类似于动画传入的alpha
uniform float alpha;
//打字机等待的显示的那个横杠
uniform int textdrawcolor;
//爱心跳跳
uniform int drawpic;


uniform vec3 textColor;
//x 动画类型，y -1=入场，1=出场
uniform ivec2 type;
uniform float progress;



vec2 clampCoordinate(vec2 coordinate) {
    return vec2(clamp(coordinate.x, 0.0, 1.0), clamp(coordinate.y, 0.0, 1.0));
}

void main() {
//    outcolor=vec4(1.0);
//    return;
//    if (abs(textureCoordinate.x - 0.5) < 0.02 ||
//    abs(textureCoordinate.y - centery) < 0.02) {
//        outcolor = vec4(1.0, 0., 1., 1.0);
//        return;
//    }
    if(drawpic>0){
        outcolor=texture(textsharder, textureCoordinate);
        return;
    }
    if (isback > 1) {
//        圆角
        if (backround>0.0){
            vec2 pos=textureCoordinate;
                if (ratio>1.0){
                    pos.x=pos.x*ratio;
                    if (textureCoordinate.x>0.5){
                        pos.x=ratio-pos.x;
                    }
                    if (textureCoordinate.y>0.5){
                        pos.y=1.0-pos.y;
                    }
                } else {
                    pos.y=pos.y/ratio;
                    if (textureCoordinate.y>0.5){
                        pos.y=1.0/ratio-pos.y;
                    }
                    if (textureCoordinate.x>0.5){
                        pos.x=1.0-pos.x;
                    }
                }
                if (pos.y<backround&&pos.x<backround) {
                    vec2 center=vec2(backround);
                    float length = distance(pos, center) / backround;
                    if (length > 0.99) {
                        outcolor = mix(backcolor, vec4(0.0), (length - 0.98) * 200.0);
                        outcolor.a=outcolor.a*alpha;
                        return;
                    }
                }
            }
        outcolor = backcolor;
        if(istoTexture>1){
            outcolor*=(outcolor.a*alpha);
        }else{
            outcolor.a=outcolor.a*alpha;
        }

    }
    else {
        vec2 pos =textureCoordinate;
        if(isemoji>0.0){
            outcolor= texture(inputImageTexture, pos);
            if(isblur>0){
                outcolor= vec4(textColor.rgb,outcolor.a);
            }
        }
        else{
            vec4 color=vec4(1.0);
            float coloralpha = texture(inputImageTexture, pos).r;
            color.a=coloralpha;
            if(type.x==14001){
                float usex=pos.x;
                if(pos.x>0.5){
                    usex=pos.x-0.5;
                }
                if(type.y<0){
                    if(usex>progress/2.0){
                        outcolor=vec4(0.0);
                        return;
                    }
                }else{
                    if(usex<progress/2.0){
                        outcolor=vec4(0.0);
                        return;
                    }
                }

            }else if(type.x==14002){
                bool draw=false;
                float usex=pos.x;
                if(progress<=0.5){
                    if((pos.x>0.5&&pos.y>0.5)||(pos.x<0.5&&pos.y<0.5)){
                       if (pos.y>0.5){
                           usex=pos.x-0.5;
                       }
                       draw=usex<=progress;
                    }
                }else{
                    draw=true;
                    if((pos.x>0.5&&pos.y<0.5)||(pos.x<0.5&&pos.y>0.5)){
                        if (pos.y>0.5){
                            usex=pos.x+0.5;
                        }
                        draw=usex<=progress;
                    }
                }
                if(type.y>0){
                    draw=!draw;
                }
                if(!draw){
                    outcolor=vec4(0.0);
                    return;
                }
            }
            if(textdrawcolor>0){
                color.rgb = textColor;
                color.a=1.0;
            }else if (isgradient>0){
//            根据x坐标来计算颜色
                float pos2;
                if (gradient_state==0){
                    pos2=realpos.r+(realpos.g)*pos.x;
                } else {
                    pos2=realpos.b+(realpos.a)*pos.y;
                }
                color.rgb=mix(gradientcolor_start, gradientcolor_end, pos2);
            } else if(istextsharder>0){
                vec2 realpos=vec2(realpos.r+realpos.g*pos.x,realpos.b+realpos.a*pos.y);
                vec4 shardercolor=texture(textsharder, realpos);
//                这个得加上shardercolor自身的alpha
                outcolor=shardercolor;
                if(istoTexture>1){
                    outcolor*=(coloralpha*textalpha*alpha*shardercolor.a);
                }else{
                    outcolor.a=coloralpha*shardercolor.a*textalpha*alpha;
                    if(type.x==10012){
                        outcolor.rgb=mix(outcolor.rgb,vec3(0.0,0.0,1.0),progress);
                    }
                }
                return;
            } else {
                color.rgb = textColor;
            }
            outcolor=color;
        }
        if(istoTexture>1){
            outcolor*=(outcolor.a*textalpha*alpha);
        }else{
            outcolor.a=outcolor.a*textalpha*alpha;
            if(type.x==10012){
                outcolor.rgb=mix(outcolor.rgb,vec3(0.0,0.0,1.0),progress);
            }
        }
    }

}

