// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform  float progress;
uniform vec4 move1;
uniform vec4 move2;
//type 0 横向 1 纵向 34xy 都移动，3是左上+xy右下-xy， 4是左下+xy右上-xy
uniform float type;
//分成几个部分
uniform float splitnum;

const float PI = 3.1415926;
//uniform float strength; // = 0.4
float strength2 = 0.6;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec3 crossFade(in vec2 uv, in float dissolve) {
    return mix(getFromColor(uv).rgb, getToColor(uv).rgb, dissolve);
}


float getusepro(){

    float splitpos=0.0;
    //    type移动方向由另一个位置决定
    if (type==0.0){
        splitpos=textureCoordinate.y*splitnum;
    } else {
        splitpos=textureCoordinate.x*splitnum;
    }
    //    计算出这是第几部分
    splitpos=floor(splitpos);
    float usepro;
    if(splitpos<0.5){
        usepro=move1[0];
    }else if(splitpos<1.5){
        usepro=move1[1];
    }else if(splitpos<2.5){
        usepro=move1[2];
    }else if(splitpos<3.5){
        usepro=move1[3];
    }else if(splitpos<4.5){
        usepro=move2[0];
    }else if(splitpos<5.5){
        usepro=move2[1];
    }else if(splitpos<6.5){
        usepro=move2[2];
    }else if(splitpos<7.5){
        usepro=move2[3];
    }
    return usepro;
}


vec2 resetpos(vec2 texCoord){
    //    超出镜像
    bool isx=type==0.0;
    if (progress<=0.5){
        if(isx){
            if (texCoord.x<0.0){
                texCoord.x=-texCoord.x;
            }
        }else{
            if (texCoord.y>1.0){
                texCoord.y=2.0-texCoord.y;
            }
        }
    }
    if (progress>0.5){
        if(isx){
            if (texCoord.x>0.0){
                texCoord.x=1.0-texCoord.x;
            } else if (texCoord.x<0.0){
                texCoord.x=1.0+texCoord.x;
            }
        }else{
            if (texCoord.y>0.0&&texCoord.y<1.0){
                texCoord.y=1.0-texCoord.y;
            } else if (texCoord.y>1.0){
                texCoord.y=texCoord.y-1.0;
            }
        }
    }
    return texCoord;
}


void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    float usepro=getusepro();
    if (usepro<=0.0){
        gl_FragColor=getFromColor(texCoord);
        return;
    } else if (usepro>=1.0){
        gl_FragColor=getToColor(texCoord);
        return;
    }

    vec2 move=vec2(0.0);
    if (type==0.0){
        move.x=usepro;
        texCoord=texCoord-move;
    } else {
        move.y=usepro;
        texCoord=texCoord+move;
    }
    texCoord=resetpos(texCoord);

    float domove=min(usepro,1.0-usepro);
    if (type==0.0){
        move.x=domove;
    } else {
        move.y=domove;
    }
    vec2 center = texCoord+move;
//原逻辑
//    float strength = strength2*domove;
//新逻辑
    float dissolve = progress>0.5?1.0:0.0;
    move/=100.0;
    vec3 color = vec3(0.0);
    float num=10.0;
    float total=0.0;
    for (float t = -num; t <= num; t++) {
        float weight = num-abs(t);
        color += crossFade(texCoord +move*t, dissolve).rgb * weight;
        total += weight;
    }
    color /= total;
    gl_FragColor= vec4(color, 1.0);

}



