// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform  float progress;

const float PI = 3.1415926;
//uniform float strength; // = 0.4
float strength2 = 0.6;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float Sinusoidal_easeInOut(in float begin, in float change, in float duration, in float time) {
    return -change / 2.0 * (cos(PI * time / duration) - 1.0) + begin;
}

float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

vec3 crossFade(in vec2 uv, in float dissolve) {
    return mix(getFromColor(uv).rgb, getToColor(uv).rgb, dissolve);
}


//type 0 横向 1 纵向 34xy 都移动，3是左上+xy右下-xy， 4是左下+xy右上-xy
float type=0.0;
//单程的时间
float once=0.9;
//分成几个部分
float splitnum=8.0;


//获取相对的 once 的进度
float getusepro(){

    float splitpos=0.0;
    //    type移动方向由另一个位置决定
    if (type==0.0){
        splitpos=textureCoordinate.y*splitnum;
    } else {
        splitpos=textureCoordinate.x*splitnum;
    }
    //    计算出这是第几部分
    splitpos=floor(splitpos);

    //    计算splitpos位置的延迟的启动时间progress
    float delaypos=(1.0-once)*splitpos/(splitnum-1.0);//(1.0-once)

    return (progress-delaypos)/once;
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}


//转换pro 0-0.4不变 0.4-0.5映射成 0.4-0.9  0.5-1.0 映射成 0.9-1.0
float getresetpro(float pro){
    pro=getspeedpro(pro);
    if (pro<0.4)pro=pro;
    else if (pro<=0.45){
        pro=0.4+(pro-0.4)*5.0;
    }else if(pro>=0.45&&pro<0.7){
        pro=0.65+(pro-0.45)*1.0;
    }else{
        pro=0.9+(pro-0.7)/3.0;
    }

    pro=getspeedpro(pro);
    pro=min(1.0,pro);
    return pro;
}
vec2 resetpos(vec2 texCoord){
    //    超出镜像

    bool isx=type==0.0;
    if (progress<=0.5){
        if(isx){
            if (texCoord.x<0.0){
                texCoord.x=-texCoord.x;
            }
        }else{
            if (texCoord.y>1.0){
                texCoord.y=2.0-texCoord.y;
            }
        }


    }
    if (progress>0.5){
        if(isx){
            if (texCoord.x>0.0){
                texCoord.x=1.0-texCoord.x;
            } else if (texCoord.x<0.0){
                texCoord.x=1.0+texCoord.x;
            }
        }else{
            if (texCoord.y>0.0&&texCoord.y<1.0){
                texCoord.y=1.0-texCoord.y;
            } else if (texCoord.y>1.0){
                texCoord.y=texCoord.y-1.0;
            }
        }
    }

    return texCoord;
}


void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    float usepro=getusepro();

    if (usepro<=0.0){
        gl_FragColor=getFromColor(texCoord);
        return;
    } else if (usepro>=1.0){
        gl_FragColor=getToColor(texCoord);
        return;
    }
    vec2 move=vec2(0.0);
    float domove=0.0;
    domove=getresetpro(usepro);

    if (type==0.0){
        move.x=domove;
        texCoord=texCoord-move;
    } else {
        move.y=domove;
        texCoord=texCoord+move;
    }

    //    超出镜像
    //    if (texCoord.y>1.0){
    //        if (texCoord.y<2.0)
    //        texCoord.y=2.0-texCoord.y;
    //        else texCoord.y=texCoord.y-2.0;
    //    }

    texCoord=resetpos(texCoord);

    //    if(true){
    //        gl_FragColor=progress<=0.5?getFromColor(texCoord):getToColor(texCoord);
    //        return;
    //    }

    if (type==0.0){
        move.x=domove/8.0;
    } else {
        move.y=domove/8.0;
    }
    vec2 center = texCoord+move;
    // Mirrored sinusoidal loop. 0->strength then strength->0
    domove=usepro*1.0;
    if (usepro>0.58){
        domove=max(0.65-usepro, 0.0)*4.0;
    }




    float strength = strength2*domove;
    //    strength=0.0;
    vec3 color = vec3(0.0);
    float total = 0.0;
    vec2 toCenter = move;

    float offset = rand(texCoord);
    float dissolve = progress>0.5?1.0:0.0;
    if (strength==0.0){
        gl_FragColor=getToColor(texCoord);
        return;
    }
    float num=10.0;
    for (float t = 0.0; t <= num; t++) {
        float percent = (t + offset) / num;
        float weight = 4.0 * (percent - percent * percent);
        color += crossFade(texCoord + toCenter * percent * strength, dissolve) * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);

}



