// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform  float progress;
uniform  float progress2;

const float PI = 3.1415926;
//uniform float strength; // = 0.4
float strength2 = 0.5;
vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float Sinusoidal_easeInOut(in float begin, in float change, in float duration, in float time) {
    return -change / 2.0 * (cos(PI * time / duration) - 1.0) + begin;
}

float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
vec2 zhuanhua(vec2 texCoord){
    //        0-1
    if (progress<0.5){
        //            x -y
        if ((texCoord.y<0.0)&&abs(texCoord.x-0.5)<=0.5){
            texCoord.y=-texCoord.y;
        } else // -x -y
        if (texCoord.x<0.0&&texCoord.y<0.0){
            texCoord.x=-texCoord.x;
            texCoord.y=-texCoord.y;
        }
    } else {
        //            +x y
        if (abs(texCoord.y-0.5)<=0.5&&texCoord.x>1.0){
            texCoord.x=2.0-texCoord.x;
        } else//+x+y
        if (texCoord.x>1.0&&texCoord.y>1.0){
            texCoord.x=2.0-texCoord.x;
            texCoord.y=2.0-texCoord.y;
        }
    }
    return texCoord;
}

vec2 zhuanhua2(vec2 texCoord){
    if (progress<0.5){
        //x +y
        if (texCoord.y>1.0&&abs(texCoord.x-0.5)<=0.5){
            texCoord.y=2.0-texCoord.y;
        } else //+x +y
        if (texCoord.x>1.0&&texCoord.y>1.0){
            texCoord.x=2.0-texCoord.x;
            texCoord.y=2.0-texCoord.y;
        }
    }else{
        //-x y
        if (abs(texCoord.y-0.5)<=0.5&&texCoord.x<0.0){
            texCoord.x=-texCoord.x ;
        } else//-x -y
        if (texCoord.x<0.0&&texCoord.y<0.0){
            texCoord.x=-texCoord.x;
            texCoord.y=-texCoord.y;
        }
    }
    return texCoord;
}

vec4 crossFade(in vec2 uv, in float dissolve) {
    return mix(getFromColor(uv), getToColor(uv), dissolve);
}


float type=1.0;

vec2 resettexCoord(vec2 texCoord,vec2 move){
    if (texCoord.x>texCoord.y){
        move=-move;
        texCoord=texCoord+move;
        texCoord=zhuanhua(texCoord);
    } else {
        texCoord=texCoord+move;
        texCoord=zhuanhua2(texCoord);
    }
    return texCoord;
}
//屏幕左上-右下
void main() {
    vec2 texCoord = textureCoordinate.xy/vec2(1.0);

    float domove= progress2;
    domove=progress>=0.5?1.0-domove:domove;
    vec2 move=vec2(domove, domove);
    if (progress>=0.5)move=-move;
    if(texCoord.x>texCoord.y+0.5||texCoord.x<texCoord.y-0.5){
        move/=2.0;
    }

    float num=10.0;
    float total=0.0;
    float offset = rand(texCoord);
    float dissolve=progress>=0.5?1.0:0.0;
    vec3 color=vec3(0.0);
    for (float t = 0.0; t <= num; t++) {
        float percent = (t + offset) / num;
        float weight = 4.0 * (percent - percent * percent);
        color += crossFade(resettexCoord(texCoord ,move*(1.0+ 0.2* percent * strength2)), dissolve).rgb * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);


}



