//中间关闭 竖
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform highp float progress;
uniform highp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//判断坐标是否在两条线段之间
float sdfTwoLine(vec2 uv, float percent)
{
    //将坐标轴换算成标准坐标轴
    vec2 pos = uv - 0.5;
    pos.y = -pos.y;
    //线1 y = 0.5
    float l1 = (1.0 - percent) / 2.0;
    //线2 y = -0.5
    float l2 = -(1.0 - percent) / 2.0;

    float d1 = -(pos.x - l1);
    float d2 = pos.x - l2;

    return min(d1, d2);
}


void main() {
    vec2 uv = textureCoordinate;

    float percent = progress;

    vec4 texColor1 = getFromColor(uv);
    vec4 texColor2 = getToColor(uv);

    float d = sdfTwoLine(uv, percent);

    gl_FragColor = mix(texColor2, texColor1, step(0.0, d));
}
