
//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


void main() {

    //矩形的个数
    float num = 9.0;
    float pre = 1.0 / num;
    float infopos;
    float usevalue;
    if(type==0.0){
        usevalue=textureCoordinate.x;
    }else if(type==1.0){
        usevalue=1.0-textureCoordinate.x;
    }else if(type==2.0){
        usevalue=textureCoordinate.y;
    }else {
        usevalue=1.0-textureCoordinate.y;
    }
    infopos=usevalue*num;
    infopos=infopos-mod(infopos,1.0);
    float startpro=infopos*pre;
    float endpro=startpro+pre;

    //    相对进度
    float usepro = 0.0;
    usepro=smoothstep(startpro,endpro,progress);
    float mixvalue=1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, 1.0-mixvalue);
}
