
//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//y=2x;
void main() {
    //矩形的个数
    float num = 5.5;
    if(ratio>1.0){
        num*=ratio;
    }else{
        num/=ratio;
    }
    float pre = 1.0 / num;
    vec2 useuv;
    if(type==0.0){
        useuv=textureCoordinate;
    }else if(type==1.0){
        useuv=vec2(1.0)-textureCoordinate;
    }else if(type==2.0){
        useuv.x=textureCoordinate.x;
        useuv.y=1.0-textureCoordinate.y;
    }else if(type==3.0){
        useuv.x=textureCoordinate.x;
        useuv.y=1.0-textureCoordinate.y;
        useuv=vec2(1.0)-useuv;
    }

    float pos=useuv.y-2.0*useuv.x;
//    pos 范围(-2,1) 》(0,3)
    pos=pos+2.0;
    pos/=3.0;
    pos/=pre;
    float infopos=pos-mod(pos,1.0);


    //    相对进度
    float startpro=infopos*pre;
    float endpro=startpro+pre;
    float usepro=smoothstep(startpro,endpro,progress);
    float mixvalue=1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, 1.0-mixvalue);
}
