//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//y=x*1.4-0.2
void main() {

    //矩形的个数
    float num = 2.5;
    float num2 = 4.0;
    if(ratio>1.0){
        num*=ratio;
        num2*=ratio;
    }else{
        num/=ratio;
        num2/=ratio;
    }
    float pre = 1.0 / num;
    float infopos;
    float usevalue = (1.0 - textureCoordinate.y) - textureCoordinate.x * 1.4 + 0.2;
    usevalue = abs(usevalue);
    usevalue -= pre / 2.0;

    if (usevalue < 0.0) {
        infopos = 0.0;
    } else {
        infopos = usevalue * num;
        infopos = infopos - mod(infopos, 1.0);
        infopos += 1.0;
    }
    if(type==1.0){
        infopos=num2-infopos;
    }

    float startpro = infopos * pre;
    float endpro = startpro + pre;
    startpro -= pre / 2.0;
    endpro -= pre / 2.0;
    //    相对进度
    float usepro = progress*2.0;

    usepro = smoothstep(startpro, endpro, usepro);
    float mixvalue = 1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, 1.0 - mixvalue);
}
