//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//y=x*1.4-0.2
void main() {

    //矩形的个数
    float num = 2.5;
    float pre = 1.0 / num;
    float infopos;
    float usevalue = (1.0 - textureCoordinate.y) - textureCoordinate.x * 1.4 + 0.2;
    usevalue = abs(usevalue);
    usevalue -= pre / 2.0;

    if (usevalue < 0.0) {
        infopos = 0.0;
    } else {
        infopos = usevalue * num;
        infopos = infopos - mod(infopos, 1.0);
        infopos += 1.0;
    }

    float startpro;
    float endpro;
    if(mod(infopos, 2.0)==0.0){
        startpro=0.0;
        endpro=0.5;
    }else{
        startpro=0.5;
        endpro=1.0;
    }

    float usepro = smoothstep(startpro, endpro, progress);
    float mixvalue = 1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, 1.0 - mixvalue);
}
