//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//矩形
float sdfBox(vec2 uv, vec2 size, vec2 center)
{
    vec2 pos = uv - center;
    vec2 d = abs(pos) - size;
    return length(max(d, 0.0)) + min(max(d.x,d.y), 0.0);
}

void main() {
    new float[]
    //矩形的个数
    float num = 9.0;
    //每个矩形动画的时间
    float duration = 0.5;
    //矩形动画之间的间隔
    float interval = (1.0 - duration) / (num - 1.0);
    //矩形的长的一半 这里设置大一些 保证矩形能覆盖所有比例
    float sizeW = 10.0;
    //矩形宽的一半
    float sizeH = 1.0 / num / 2.0;
    //矩形中心点  这里矩形按照中心点旋转 在画面外边
    float centerW = -sizeH * 3.0;

    //多个矩形的拼接，用min来拼接多个sdf图形
    float minD = 0.0;

    for (float i = 0.0; i < num; i++) {
        //每一个矩形的中心点h
        float centerH = sizeH * (2.0 * i + 1.0);
        //每一个矩形动画的开始时间
        float startTime = interval * i;
        //每一个矩形动画的结束时间
        float endTime = startTime + duration;
        //这里是每一个矩形动画的进度，用smoothstep做的曲线，也可以仿照smoothstep自定义自己的曲线
        float percent = smoothstep(startTime, endTime, progress);
        //根据进度计算出当前的角度
        float degree = 90.0 - percent * 90.0;
        //绘制矩形
        float d = sdfRotateBox(textureCoordinate, vec2(sizeW, sizeH), vec2(centerW, centerH), vec2(0.0), degree, ratio);
        //取最小值 即为多个sdf图形拼接
        minD = min(minD, d);
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, step(0.0, minD));
}
