precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform int  type;
const float PI = 3.1415926;

vec4 getToColor(vec2 usepos){
    return texture2D(inputImageTexture2, usepos);
}
vec4 getFromColor(vec2 usepos){
    return texture2D(inputImageTexture, usepos);
}
float startingAngle=90.0;
void main() {
    vec2 usepos;
    if(type==0){
        usepos=textureCoordinate;
    } else if(type==1){
        usepos=textureCoordinate;
        usepos.x=1.0-usepos.x;
    }  else if(type==2){
        usepos=textureCoordinate;
        usepos.y=1.0-usepos.y;
    } else if(type==3){
        usepos=vec2(1.0)-textureCoordinate;
    }
    
    float offset = startingAngle * PI / 180.0;
    float angle = atan(1.0-usepos.y, usepos.x - 1.0) + offset;
    float normalizedAngle = (angle + PI) / (2.0 * PI);

    normalizedAngle = normalizedAngle - floor(normalizedAngle);

    
    gl_FragColor= mix(
        getFromColor(textureCoordinate),
        getToColor(textureCoordinate),
        step(normalizedAngle, progress/4.0)
    );
}
