precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform int type;


const float PI = 3.1415926;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    float usevalue;

    if (type == 0) {
        usevalue = textureCoordinate.y;
    } else if (type == 1) {
        usevalue = 1.0 - textureCoordinate.y;
    } else if (type == 2) {
        usevalue = textureCoordinate.x;
    } else if (type == 3) {
        usevalue = 1.0 - textureCoordinate.x;
    }
    float mixvalue = usevalue < progress ? 1.0 : 0.0;

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, mixvalue);
}
