//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
//x分割几部分，y横向分割还是纵向分割,>0 横向切，<0纵向
uniform lowp vec2 splitinfo;
//分割的中心点；
uniform lowp vec3 centers;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


void main() {
    float mixvalue;
    float usepro = progress;

    float usevalue;
    float comparevalue;
    if (splitinfo.y > 0.0) {
        usevalue = textureCoordinate.y;
        comparevalue = textureCoordinate.x;
    } else {
        usevalue = textureCoordinate.x;
        comparevalue = textureCoordinate.y;
    }
    usevalue *= splitinfo.x;
    float usecenter;
    if (usevalue < 1.0) {
        usecenter = centers.x;
    } else if (usevalue < 2.0) {
        usecenter = centers.y;
    } else {
        usecenter = centers.z;
    }
    bool isabovecenter = usecenter > comparevalue;

    if (isabovecenter) {
        usepro = usecenter * (1.0 - usepro);
        mixvalue = comparevalue > usepro ? 0.0 : 1.0;
    } else {
        usepro = usecenter + (1.0 - usecenter) * usepro;
        mixvalue = comparevalue > usepro ? 1.0 : 0.0;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, 1.0-mixvalue);
}
