//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;
float center = 0.7;



vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float getprogress(float x) {
    return x < 0.5 ? 4.0 * x * x * x : 1.0 - pow(-2.0 * x + 2.0, 3.0) / 2.0;
}

void main() {
    float mixvalue;
    float comparevalue;
    float usevalue;
    if(type==0.0){
        comparevalue = textureCoordinate.y;
        usevalue = textureCoordinate.x;
    }else{
        comparevalue = textureCoordinate.x;
        usevalue = textureCoordinate.y;
    }
    float usepro;
    if (comparevalue <= center) {
        usepro = getprogress(progress);
        mixvalue = comparevalue < center * usepro ? 0.0 : 1.0;
    } else {
        if (usevalue < 0.5) {
            usepro = progress < 0.6 ? 0.0 : getprogress((progress - 0.6) / 0.4);
        } else {
            usepro = progress < 0.3 ? 0.0 : getprogress((progress - 0.3) / 0.7);
        }
        mixvalue = comparevalue > 1.0 - (1.0 - center) * usepro ? 0.0 : 1.0;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, 1.0 - mixvalue);
}
