//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;

float sdTriangle(in vec2 p, in vec2 p0, in vec2 p1, in vec2 p2)
{
    vec2 e0 = p1 - p0, e1 = p2 - p1, e2 = p0 - p2;
    vec2 v0 = p - p0, v1 = p - p1, v2 = p - p2;
    vec2 pq0 = v0 - e0 * clamp(dot(v0, e0) / dot(e0, e0), 0.0, 1.0);
    vec2 pq1 = v1 - e1 * clamp(dot(v1, e1) / dot(e1, e1), 0.0, 1.0);
    vec2 pq2 = v2 - e2 * clamp(dot(v2, e2) / dot(e2, e2), 0.0, 1.0);
    float s = sign(e0.x * e2.y - e0.y * e2.x);
    vec2 d = min(min(vec2(dot(pq0, pq0), s * (v0.x * e0.y - v0.y * e0.x)), vec2(dot(pq1, pq1), s * (v1.x * e1.y - v1.y * e1.x))), vec2(dot(pq2, pq2), s * (v2.x * e2.y - v2.y * e2.x)));
    return -sqrt(d.x) * sign(d.y);
}

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float getprogress(float x) {
    return x < 0.5 ? 4.0 * x * x * x : 1.0 - pow(-2.0 * x + 2.0, 3.0) / 2.0;
}

void main() {
    float mixvalue;


    float pro1 = progress < 0.2 ? 0.0 : (progress - 0.2) / 0.7;
    pro1 = min(1.0, pro1);
    float pro2 = progress / 0.8;
    pro2 = min(1.0, pro2);
    float pro3 = progress < 0.5 ? 0.0 : (progress - 0.5) / 0.5;
    pro1 = getprogress(1.0 - pro1);
    pro2 = getprogress(1.0 - pro2);
    pro3 = getprogress(1.0 - pro3);

    vec2 center = vec2(1.0, 0.0) + vec2(1.0, -1.0) * pro1;
    float l1 = sdTriangle(textureCoordinate - center, vec2(0.0, 0.0), vec2(-1.0, 0.0), vec2(0.0, 1.0));
    if (l1 < 0.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }

    center = vec2(0.5, 0.5) + vec2(-0.5, 0.0) * pro2;
    l1 = sdTriangle(textureCoordinate - center, vec2(0.0, 0.0), vec2(-0.5, 0.5), vec2(-0.5, -0.5));
    if (l1 < 0.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }

    center = vec2(0.5, 0.5) + vec2(-0.5, 0.5) * pro3;
    l1 = sdTriangle(textureCoordinate - center, vec2(0.0, 0.0), vec2(-0.5, 0.5), vec2(0.5, 0.5));
    if (l1 < 0.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
