precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//默认横纵比
uniform lowp float ratio;

// y坐标每100/splitnum算作一个部分，y轴作为短边时候20个，若是长边则/ratio增加相应数量
float splitnum=4.0;

//横向中心纵向中心
lowp float hengshu=1.0;

//=0 中心向两侧 1两侧向中心
 lowp float isstartcenter=0.0;

//0 指从中间开始分裂1的话从0.25 0.75处开始
 lowp float centernum=1.0;


//同一个位置的坐标拿两个随机数
vec2 getstartmove(float texCoord){
    float usenum=texCoord*100.0;
    //    转成整数
    int num1=int(usenum/splitnum);
    float num=float(num1)*splitnum/100.0;
    num+=1.0;
    float r1=fract(num*num*2.98*43.53);
    float r2=fract(r1*1.98*47.543);
    return vec2(r1*r1, r2*r2);
}
vec4 getstartmove2(float texCoord){
    float usenum=texCoord*100.0;
    //    转成整数
    int num1=int(usenum/splitnum);
    float num=float(num1)*splitnum/100.0;
    num+=1.0;
    float r1=fract(num*num*2.98*43.53);
    float r2=fract(r1*1.98*47.543);
    float r3=fract(r2*1.78*47.123);
    float r4=fract(r3*1.67*47.456);
    return vec4(r1*r2, r2*r3, r3*r4, r4*r1);
}

float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}
void main() {
    //    splitnum/=ratio;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    //    用哪个值来进行计算startmove
    float choosenum=texCoord.x;
    //    用哪个值判断
    float boolnum=texCoord.y;
    if (hengshu==0.0){
        choosenum=texCoord.y;
        boolnum=texCoord.x;
    }

    bool isinbool=false;
    float usepro=getuseprogress(2.0);
    if (isstartcenter==0.0){
        if (centernum==0.0){
            vec2 startmove=getstartmove(choosenum);
            if (boolnum<=0.5){
                isinbool=boolnum>(0.5-usepro*(usepro*0.5+startmove.x));
            } else {
                isinbool=boolnum<(0.5+usepro*(usepro*0.5+startmove.y));
            }
        } else {
            vec4 startmove =getstartmove2(choosenum);
            if (boolnum<=0.25){
                isinbool=boolnum>(0.25-usepro*(usepro*0.25+startmove.r));
            } else if (boolnum>=0.75){
                isinbool=boolnum<(0.75+usepro*(usepro*0.25+startmove.g));
            } else {
                isinbool=
                boolnum>(0.75-usepro*(usepro*0.25+startmove.b))
                ||boolnum<(0.25+usepro*(usepro*0.25+startmove.a));
            }
        }

    } else {
        vec2 startmove=getstartmove(choosenum);
        isinbool=boolnum>
        (1.0-usepro*(usepro*0.5+startmove.y))||boolnum<(usepro*(usepro*0.5+startmove.x));
    }
    float isin=(isinbool)?1.0:0.0;

    vec2 center=vec2(0.5);
    vec2 usefrom=center+(texCoord-center)*(1.0-progress*0.2);
    vec2 useto=center+(texCoord-center)*(1.0-(1.0-progress)*0.2);
    gl_FragColor= mix(
    getFromColor(usefrom),
    getToColor(useto),
    isin);
}
