precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 center=vec2(0.5);
uniform float ratio;



vec2 doroate(vec2 c2, float roate){

    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

vec2 resetuse(vec2 offuse){
    if (offuse.x<0.0&&offuse.x>-1.0)offuse.x=-offuse.x;
    if (offuse.y<0.0&&offuse.y>-1.0)offuse.y=-offuse.y;
    if (offuse.x>1.0)offuse.x=2.0-offuse.x;
    if (offuse.y>1.0)offuse.y=2.0-offuse.y;
    return offuse;
}

float start=0.05;
void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if(progress==1.0){
        gl_FragColor=getToColor(textureCoordinate);
        return;
    }
    float useprogress;
    useprogress=((cos((progress + 1.) * PI) / 2.0) + 0.5);
    float xx=useprogress/2.0*1.2+start;
    float yy=useprogress/2.0*1.2+start;
    if(ratio>1.0){
        yy*=ratio;
    }else{
        xx/=ratio;
    }
    vec2 afterroate=doroate(texCoord,PI/4.0);
    bool isinbool=false;
    isinbool=abs(afterroate.x-center.x)<xx&&abs(afterroate.y-center.y)<yy;
    float isin=(isinbool)?1.0:0.0;
    if(progress<0.1){
        isin*=(progress*10.0);
    }

    vec2 useto=center+(texCoord-center)*(1.0-(useprogress-1.0)*0.2);
    useto=resetuse(useto);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(useto),
    isin);
}
