precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 center=vec2(0.5);
uniform float ratio;
//三角形中心
vec2 trianglecenter=vec2(0.5, 0.2);

float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}

//三角形消失部分
float jiange;

// roate PI=180
//在0，0处旋转，不需要设置center
vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2;
    //    if (ratio>1.0){
    //        uv2.x=uv2.x*ratio;
    //    } else {
    //        uv2.y=uv2.y/ratio;
    //    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    }
    else {
        dy2=dy2/ratio;
    }
    vec2 rtn=vec2(dx2, dy2);
    return rtn;
}

float check(vec2 p1, vec2 p2, vec2 p3)
{
    return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

//是否在三角形内
bool isin_triangle(vec2 pt, vec2 p1, vec2 p2, vec2 p3){
    bool b1, b2, b3;
    b1 = check(pt, p1, p2) < 0.0;
    b2 = check(pt, p2, p3) < 0.0;
    b3 = check(pt, p3, p1) < 0.0;
    return ((b1 == b2) && (b2 == b3));
}

float startradius=0.45;
float maxjiange=0.6;

vec2 movecenter=vec2(0.0);
vec2 moveleft=vec2(0.0);
vec2 moveright=vec2(0.0);

void setpoints(float length){
    length*=(ratio/1.2);
    movecenter=vec2(0.0, length);
    moveleft =doroate(movecenter, PI*(0.58));
    if(ratio<1.0){
        moveleft.x=moveleft.x/ratio;
    }
    moveright=vec2(-moveleft.x, moveleft.y);

}
void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if (progress<0.02){
        gl_FragColor=getFromColor(texCoord);
        return;
    }

    float usepro=getuseprogress(2.0);
    //    0.0-0.2
    jiange=maxjiange*(usepro/2.0);
    startradius/=ratio;

    setpoints(startradius+jiange*1.5);
    bool isinbool=false;
    if(ratio<1.0)
    trianglecenter.y=trianglecenter.y/ratio;
    //    在最小的三角形内部
    isinbool=isin_triangle(texCoord, trianglecenter+movecenter,
    trianglecenter+moveleft, trianglecenter+moveright);

    //        不在里面
    if (!isinbool){
        setpoints(startradius+maxjiange-jiange*0.5);
        isinbool=!isin_triangle(texCoord, trianglecenter+movecenter,
        trianglecenter+moveleft, trianglecenter+moveright);
    }
    float isin=(isinbool)?1.0:0.0;
    float mixnum=progress<0.64?(0.2+progress/0.8):1.0;
    //    加个透明度渐变
    if (isinbool)isin=mixnum;
    if(!isinbool){
        setpoints(startradius+jiange*1.5+0.025);
        isinbool=isin_triangle(texCoord, trianglecenter+movecenter,
        trianglecenter+moveleft, trianglecenter+moveright);
        if(isinbool)isin=pow(mixnum,2.0);
        if(!isinbool){
            setpoints(startradius+jiange*1.5+0.05);
            isinbool=isin_triangle(texCoord, trianglecenter+movecenter,
            trianglecenter+moveleft, trianglecenter+moveright);
            if(isinbool)isin=pow(mixnum,3.0);


            if(!isinbool){
                setpoints(startradius+maxjiange-jiange*0.5-0.025);
                isinbool=isin_triangle(texCoord, trianglecenter+movecenter,
                trianglecenter+moveleft, trianglecenter+moveright);
                if(!isinbool)isin=pow(mixnum,2.0);
                if(isinbool){
                    setpoints(startradius+maxjiange-jiange*0.5-0.05);
                    isinbool=isin_triangle(texCoord, trianglecenter+movecenter,
                    trianglecenter+moveleft, trianglecenter+moveright);
                    if(!isinbool)isin=pow(mixnum,3.0);
                }
            }
        }
    }



//    vec2 usefrom=center+(texCoord-center)*(1.0-progress*0.2);
//    vec2 useto=center+(texCoord-center)*(1.0-(1.0-progress)*0.2);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(texCoord),
    isin);
}
