precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


//0 tpointx bpointx 是与y=1,y=0的情况下x轴的坐标
//1 tpointx bpointx 是与x=1,x=0的情况下y轴的坐标
float hengshu=0.0;

const float tpointx=0.6;
float bpointx=1.0-tpointx;
//方程式是 y=ax+b;

float a=1.0;
float b=1.0;

float usepro=0.0;

float isin(vec2 use){

    if(use.y>a*use.x+b+(usepro*max(tpointx,1.0-tpointx)*1.1*a))
    return 0.0;
    if(use.y<a*use.x+b-(usepro*max(tpointx,1.0-tpointx)*1.1*a))
    return 0.0;

    return 1.0;
}

vec2 center=vec2(0.5);

float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}

vec2 resetuse(vec2 offuse){
    if (offuse.x<0.0&&offuse.x>-1.0)offuse.x=-offuse.x;
    if (offuse.y<0.0&&offuse.y>-1.0)offuse.y=-offuse.y;
    if (offuse.x>1.0)offuse.x=2.0-offuse.x;
    if (offuse.y>1.0)offuse.y=2.0-offuse.y;
    return offuse;
}

void main() {

    vec2 texCoord = textureCoordinate.xy ;
    if(hengshu>0.5){
        texCoord.x=texCoord.y;
        texCoord.y=textureCoordinate.x;
    }

    a=1.0/(tpointx-bpointx);
    b= -(a*bpointx);
    usepro=getuseprogress(2.0);
    vec2 useto=center+(texCoord-center)*(1.0-(progress-1.0)*0.2);
    useto=resetuse(useto);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(useto),
    isin(texCoord));
}
