precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


//0 tpointx bpointx 是与y=1, y=0 的情况下x轴的坐标
//1 tpointx bpointx 是与x=1, x=0 的情况下y轴的坐标
float hengshu=0.0;

const float tpointx=0.6;
float bpointx=1.0-tpointx;
//方程式是 y=ax+b;

float a=1.0;
float b=1.0;
float inmun=0.0;



vec2 center=vec2(0.5);
float maxnum=5.0;
float isin(vec2 use, float usepro,float i){
    float rtn =1.0;
    if (use.y>a*use.x+b+(usepro*(1.0/(maxnum*0.2-usepro))*(5.0+30.0*progress)))
    rtn=0.0;
    if (use.y<a*use.x+b-(usepro*(1.0/(maxnum*0.2-usepro))*(5.0+30.0*progress)))
    rtn=0.0;
    return rtn;
}


void main() {
    vec2 texCoord = textureCoordinate.xy;
    if (hengshu>0.5){
        texCoord.x=texCoord.y;
        texCoord.y=textureCoordinate.x;
    }

    a=1.0/(tpointx-bpointx);
    b= -(a*bpointx);

    float startnum=0.25;
    float usepro=progress*(1.0+maxnum/10.0-0.5);
    float mixnum=0.0;
    mixnum=isin(texCoord, usepro,0.0);

    if (mixnum==1.0){
        for (float i=0.0;i< maxnum;i++){
//            出现第i个分裂的时候最小的progress；
            float zhishu=1.0-pow(1.0-startnum, i);
            if (usepro<zhishu){
                if (mod(i, 2.0)==0.0){
                    mixnum=0.0;
                }
                break;
            }

//            这个值影响 相当于startnum*xishu
            float xishu=(1.0-i/10.0);
            xishu=pow(xishu, 2.0);

            mixnum=isin(texCoord, (usepro-zhishu)/(1.0-zhishu)*xishu,i);
            if (mixnum==0.0){
                if (mod(i, 2.0)==1.0){
                    mixnum=1.0;
                }
                break;
            }
        }
    }




    vec2 usefrom=center+(textureCoordinate-center)*(1.0-progress*0.2);
    vec2 useto=center+(textureCoordinate-center)*(1.0-(1.0-progress)*0.2);
    gl_FragColor= mix(
    getFromColor(usefrom),
    getToColor(useto),
    mixnum
    );
}
