precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float startingAngle=90.0;
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);


    float offset = startingAngle * PI / 180.0;
    float angle = atan(1.0-uv.y, uv.x - 0.5) + offset-PI*0.5;
    float normalizedAngle = (angle + PI) / (2.0 * PI);
    normalizedAngle = normalizedAngle - floor(normalizedAngle);

    gl_FragColor= mix(
        getToColor(uv),
        getFromColor(uv),
        step(normalizedAngle,0.5+(1.0-progress)*0.5)
    );
}
