precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}




uniform float ratio;

vec2 doroate(vec2 c2, vec2 center,float roate){

    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

//初始中心点
vec2 rectcenter=vec2(0.5,1.2);
//中心点移动方向速度 移动完后rectcenter=rectcenter+rectmove；
vec2 rectmove=vec2(0.0,-0.6);

//初始半径的一半
float startradios=0.15;

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}


//转换pro 0-0.4不变 0.4-0.5映射成 0.4-0.9  0.5-1.0 映射成 0.9-1.0
float getresetpro(float pro){
    pro=getspeedpro(pro);
    if (pro<0.4)pro=pro;
    else if (pro<=0.45){
        pro=0.4+(pro-0.4)*5.0;
    }else if(pro>=0.45&&pro<0.7){
        pro=0.65+(pro-0.45)*1.0;
    }else{
        pro=0.9+(pro-0.7)/3.0;
    }

    pro=getspeedpro(pro);
    pro=min(1.0,pro);
    return pro;
}

vec2 resetuse(vec2 offuse){
    if (offuse.x<0.0&&offuse.x>-1.0)offuse.x=-offuse.x;
    if (offuse.y<0.0&&offuse.y>-1.0)offuse.y=-offuse.y;
    if (offuse.x>1.0)offuse.x=2.0-offuse.x;
    if (offuse.y>1.0)offuse.y=2.0-offuse.y;
    return offuse;
}

void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if(progress<0.02){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    if(progress>0.98){
        gl_FragColor=getToColor(texCoord);
        return;
    }
    float useprogress=getresetpro(progress*0.4+0.2);
    rectcenter=rectcenter+rectmove*useprogress;

    vec2 afterroate=doroate(texCoord,rectcenter,PI*(useprogress+0.2));
    float xx=startradios+(useprogress);
    float yy=startradios+(useprogress);
//    float xaad=0.03*(1.0-useprogress);
//    float yaad=0.03*(1.0-useprogress);
    if(ratio>1.0){
        yy*=ratio;
//        yaad*=ratio;
    }else{
        xx/=ratio;
//        xaad/=ratio;
    }

    bool isinbool=false;
    isinbool=abs(afterroate.x-rectcenter.x)<xx&&abs(afterroate.y-rectcenter.y)<yy;
    float isin=(isinbool)?1.0:0.0;

    vec2 center=vec2(0.5);
    vec2 useto=center+(texCoord-center)*(1.0-(useprogress-1.0)*0.2);
    useto=resetuse(useto);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(useto),
    isin);
}
