precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;
uniform float ratio;

uniform float scale;
uniform float roate;
uniform float trany;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec2 doroate(vec2 c2, vec2 center,float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

//初始中心点
vec2 center=vec2(0.5);

void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;

    center.y+=trany;
    vec2 afterroate=doroate(texCoord,center,roate);

    float xx=scale;
    float yy=scale;
    if(ratio>1.0){
        yy*=ratio;
    }else{
        xx/=ratio;
    }
    float isin=abs(afterroate.x-center.x)<xx&&abs(afterroate.y-center.y)<yy ? 1.0:0.0;

    center=vec2(0.5);
    vec2 topos=center+(texCoord-center)*(1.2-sqrt(progress)*0.2);
    if(topos.x<0.0){
        topos.x=-topos.x;
    }else if(topos.x>1.0){
        topos.x=2.0-topos.x;
    }
    if(topos.y<0.0){
        topos.y=-topos.y;
    }else if(topos.y>1.0){
        topos.y=2.0-topos.y;
    }
    gl_FragColor= mix(
        getFromColor(texCoord),
        getToColor(topos),
        isin);
}
