precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
uniform float ratio;
// roate PI=180
//在0，0处旋转，不需要设置center
vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2;
    if (ratio<1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio<1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(dx2, dy2);
    return rtn;
}

float check(vec2 p1, vec2 p2, vec2 p3){
    return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

//是否在三角形内
bool isin_triangle(vec2 pt, vec2 p1, vec2 p2, vec2 p3){
    bool b1, b2, b3;
    b1 = check(pt, p1, p2) < 0.0;
    b2 = check(pt, p2, p3) < 0.0;
    b3 = check(pt, p3, p1) < 0.0;
    return ((b1 == b2) && (b2 == b3));
}
vec2 movecenter=vec2(0.0);
vec2 moveleft=vec2(0.0);
vec2 moveright=vec2(0.0);
//初始中心点
vec2 center=vec2(-0.1,1.1);
//中心点移动方向速度 移动完后rectcenter=rectcenter+rectmove；
vec2 move=vec2(0.6,-0.6);
void setpoints(float length){
    float roate=PI*length;
//    if(distance(center,vec2(0.5))<0.1){
//        roate*=9.0;
//    }
    if(ratio>1.0){
        length=length*ratio+0.05;
    }
    movecenter=vec2(0.0, length);
    movecenter=doroate(movecenter,-roate);
    moveleft =doroate(movecenter, PI*(0.66));
    moveright =doroate(movecenter, -PI*(0.66));
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}
float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}

vec2 resetuse(vec2 offuse){
    if (offuse.x<0.0&&offuse.x>-1.0)offuse.x=-offuse.x;
    if (offuse.y<0.0&&offuse.y>-1.0)offuse.y=-offuse.y;
    if (offuse.x>1.0)offuse.x=2.0-offuse.x;
    if (offuse.y>1.0)offuse.y=2.0-offuse.y;
    return offuse;
}

//转换pro 0-0.4不变 0.4-0.5映射成 0.4-0.9  0.5-1.0 映射成 0.9-1.0
float getresetpro(float pro){
    pro=getspeedpro(pro);
    if (pro<0.4)pro=pro;
    else if (pro<=0.45){
        pro=0.4+(pro-0.4)*5.0;
    }else if(pro>=0.45&&pro<0.7){
        pro=0.65+(pro-0.45)*1.0;
    }else{
        pro=0.9+(pro-0.7)/3.0;
    }

    pro=getspeedpro(pro);
    pro=min(1.0,pro);
    return pro;
}

void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if (progress<0.02){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    if (progress>0.98){
        gl_FragColor=getToColor(texCoord);
        return;
    }
    float useprogress=getresetpro(progress*0.4+0.2);
    center+=move*useprogress;
    setpoints(useprogress*1.4);
    float isin=isin_triangle(texCoord,center+movecenter,center+moveleft,center+moveright)?1.0:0.0;

    center=vec2(0.5);
    vec2 useto=center+(texCoord-center)*(1.0-(useprogress-1.0)*0.2);
    useto=resetuse(useto);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(useto),
    isin);
}
