precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float scale;
uniform lowp float roate;
const float PI = 3.1415926;
uniform float ratio;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
// roate PI=180
//在0，0处旋转，不需要设置center
vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2;
    if (ratio<1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio<1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(dx2, dy2);
    return rtn;
}

float check(vec2 p1, vec2 p2, vec2 p3){
    return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

//是否在三角形内
bool isin_triangle(vec2 pt, vec2 p1, vec2 p2, vec2 p3){
    bool b1, b2, b3;
    b1 = check(pt, p1, p2) < 0.0;
    b2 = check(pt, p2, p3) < 0.0;
    b3 = check(pt, p3, p1) < 0.0;
    return ((b1 == b2) && (b2 == b3));
}


vec2 movecenter=vec2(0.0);
vec2 moveleft=vec2(0.0);
vec2 moveright=vec2(0.0);

//初始中心点
vec2 center=vec2(0.5);


void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if (progress<0.02){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    vec2 move=vec2(0.0,-scale);

    movecenter=doroate(move,roate);
    moveleft=doroate(move,roate+PI*2.0/3.0);
    moveright=doroate(move,roate-PI*2.0/3.0);

    float isin=isin_triangle(texCoord,center+movecenter,center+moveleft,center+moveright)?1.0:0.0;
    vec2 topos=center+(texCoord-center)*(1.2-sqrt(progress)*0.2);
    if(topos.x<0.0){
        topos.x=-topos.x;
    }else if(topos.x>1.0){
        topos.x=2.0-topos.x;
    }
    if(topos.y<0.0){
        topos.y=-topos.y;
    }else if(topos.y>1.0){
        topos.y=2.0-topos.y;
    }
    gl_FragColor= mix(
        getFromColor(texCoord),
        getToColor(topos),
        isin);
}
