precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;//视图的真实比例
const int num=10;
float usepro=0.0;
const float PI = 3.1415926;

//xy 中心点, z*progress ,扩张系数
const vec4 center4=vec4(-0.1, 0.0, 0.3,0.5);
const vec4 center3=vec4(0.1, 0.1, 0.6,1.0);
const vec4 center5=vec4(0.15, 0.8, 0.6,0.4);
const vec4 center7=vec4(0.2, 0.45, 0.8,0.3);
const vec4 center1=vec4(0.4, 0.5, 0.7,1.0);
const vec4 center9=vec4(0.45, 0.1, 0.5,0.8);
const vec4 center8=vec4(0.5, 0.9, 0.4,0.5);
const vec4 center6=vec4(0.7, 0.4, 0.6,0.6);
const vec4 center2=vec4(0.8, 0.7, 0.8,1.0);
const vec4 center0=vec4(0.9, 0.2, 0.5,1.0);

vec4 vec3Array[num];


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float incile(vec2 texCoord, vec2 ratio2){
    for (int i=0;i<num;i++){
        vec4 bijiao=vec3Array[i];
        //pow(x,y) 返回x的y次方
        float s = bijiao.z*usepro;
        if(bijiao.z>=0.5){
            s+=bijiao.z/6.0;
        }
        float dist = length((texCoord- bijiao.xy) * ratio2);
        if (dist<s){
            return usepro*7.0*(1.0+bijiao.a);
        }
    }
    return 0.0;
}

float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}
vec2 resetuse(vec2 offuse){
    if (offuse.x<0.0&&offuse.x>-1.0)offuse.x=-offuse.x;
    if (offuse.y<0.0&&offuse.y>-1.0)offuse.y=-offuse.y;
    if (offuse.x>1.0)offuse.x=2.0-offuse.x;
    if (offuse.y>1.0)offuse.y=2.0-offuse.y;
    return offuse;
}

void main() {
//    if(textureCoordinate.x<0.01){
//        gl_FragColor=vec4(1.0,0.0,0.0,1.0);return;
//    }
//    if(textureCoordinate.x>0.99){
//        gl_FragColor=vec4(0.0,1.0,0.0,1.0);return;
//    }
//    if(textureCoordinate.y<0.01){
//        gl_FragColor=vec4(.0,0.0,1.0,1.0);return;
//    }
//    if(textureCoordinate.y>0.99){
//        gl_FragColor=vec4(0.0,1.0,1.0,1.0);return;
//    }
    if(progress==0.0||progress==1.0){
        gl_FragColor=
        progress==1.0?getToColor(textureCoordinate):getFromColor(textureCoordinate);
        return;
    }
    vec3Array[0]=center0;
    vec3Array[1]=center1;
    vec3Array[2]=center2;
    vec3Array[3]=center3;
    vec3Array[4]=center4;
    vec3Array[5]=center5;
    vec3Array[6]=center6;
    vec3Array[7]=center7;
    vec3Array[8]=center8;
    vec3Array[9]=center9;
    usepro=getuseprogress(1.5);
    usepro=usepro*0.6;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec2 ratio2 = ratio<1.0?vec2(1, 1.0 / ratio):vec2(ratio, 1.0);
    float mixvalue=incile(texCoord, ratio2);
    mixvalue=min(usepro+mixvalue,1.0);


    vec2 center=vec2(0.5);
    vec2 useto=center+(texCoord-center)*(1.0-(progress-1.0)*0.2);
    useto=resetuse(useto);
    gl_FragColor= mix(
    getFromColor(texCoord),
    getToColor(useto),
    mixvalue
    );
}
