precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}


vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

vec2 reset2(vec2 texCoord){
    if (texCoord.x<0.0){
        texCoord.x=0.0;
    } else if (texCoord.x>1.0){
        texCoord.x=1.0;
    }
    if (texCoord.y<0.0){
        texCoord.y=0.0;
    } else if (texCoord.y>1.0){
        texCoord.y=1.0;
    }
    return texCoord;

}

void main() {
    vec2 texCoord=textureCoordinate/vec2(1.0);
    if(progress<0.5){
        texCoord=center-(center-texCoord)/(1.0+pow(1.0-progress,10.0));
    }
    if(progress<0.4){
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        return;
    }
    float usepro=0.5+(progress-0.4)/0.6*0.5;
    float move=pow(usepro,10.0);
    float roate=move/2.0*PI;
    vec2 texCoordr=doroate(texCoord,roate);
    if(texCoordr.x>=0.33&&texCoordr.x<=0.67){
        if(texCoordr.y>1.0||texCoordr.y<0.0){
            gl_FragColor=vec4(0.0);
        }else
        gl_FragColor=texture2D(inputImageTexture, texCoordr);
        return;
    }
    if(texCoord.x<0.33){
        texCoord.y+=move;
        if(texCoord.y>1.0)
        gl_FragColor=vec4(0.0);
        else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
    }else if(texCoord.x>0.67){
        texCoord.y-=move;
        if(texCoord.y<0.0)
        gl_FragColor=vec4(0.0);
        else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
    }
}
