precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(0.5);
float rand (vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}
float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

//轻微抖动
void main() {
    vec2 texCoord=textureCoordinate/vec2(1.0);
    float usepro;
    if(progress<=0.5){
        center.y=1.0;
//        usepro =1.0-sqrt(sqrt(progress*2.0));
        usepro =pow((1.0-progress*1.2),10.0);
        usepro*=0.8;
    }else{
        usepro =pow(0.4+(progress-0.5)*1.2,10.0)*0.8;
        if(usepro<0.2){
            float movex=usepro*5.0;
            movex=sqrt(movex);
//            movex=getspeedpro(movex);
            texCoord.x+=(movex)/25.0*1.5;
        }else{
            texCoord.x+=0.06;
        }
        center.y=0.0;

    }
    float angle=PI*usepro/2.0;
    texCoord=doroate(texCoord, angle);
    vec2 tocenter=center-texCoord;
    vec3 color = vec3(0.0);
    float total = 0.0;
    /* randomize the lookup values to hide the fixed number of samples */
    float offset = rand(textureCoordinate);
    float num=10.0;
    for (float t = 0.0; t <= num; t++) {
        float percent = (t + offset) / num;
        float weight = 4.0 * (percent - percent * percent);
        float needroate=angle-(num-t)*0.04*usepro;
        vec2 movepos=doroate(texCoord, needroate);
        movepos=reset(movepos);
        color += texture2D(inputImageTexture,movepos).rgb * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);

}
