precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

float move=0.25;

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2*(1.0+(move)/6.0), center.y+dy2*(1.0+(move)/6.0));
    return rtn;
}

vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

vec2 reset2(vec2 texCoord){
    if (texCoord.x<0.0){
        texCoord.x=0.0;
    } else if (texCoord.x>1.0){
        texCoord.x=1.0;
    }
    if (texCoord.y<0.0){
        texCoord.y=0.0;
    } else if (texCoord.y>1.0){
        texCoord.y=1.0;
    }
    return texCoord;

}


float getspeedmove(float pos){
    float move=abs(0.5-pos);
    move=pow(0.5+move,8.0);
    if (progress>0.5){
        move*=1.2;
    }
    return move*move/4.0-0.1;
}

float cha=0.01;

void main() {
    vec2 texCoord=textureCoordinate/vec2(1.0);
    move=getspeedmove(progress);

    center.x+=move/2.0;
    texCoord.x+=move;
    float angle=(move+0.1)/24.0;
    angle=sqrt(angle);
    if (progress>0.5){
        angle=-angle;
    }
    texCoord=doroate(texCoord, angle);
    texCoord=reset(texCoord);
    if (progress>0.5){
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        return;
    }
    if (progress==0.5){
        cha=0.0;
    } else if (progress>0.0){
        cha=getspeedmove(progress-0.01)-move;
    }
    float num=5.0;
    vec3 color=vec3(0.0);
    float total=0.0;
    for (float t = 0.0; t <= num*2.0; t++) {
        float weight=1.0;
        vec2 movepos=texCoord;
        movepos.x=texCoord.x-(num-t)*cha/3.0;
        movepos=reset2(movepos);
        color += texture2D(inputImageTexture, movepos).rgb* weight;
        total += weight;
    }

    gl_FragColor= vec4(color / total, 1.0);

}
