precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
float angle;
float move;
const float PI = 3.1415926;
vec2 center=vec2(0.5);
float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    float scale=1.0-sqrt(progress*2.0);
    scale=getspeedpro(scale);
    vec2 rtn=vec2(center.x+dx2*(1.0-(scale)/4.0), center.y+dy2*(1.0-(scale)/4.0));
    return rtn;
}

vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

float ms [6];
float as [6];


//type=0 ms,1 as
float getvalue(float time, int type) {
    float druction=100.0;

    if (time <= 0.0) return type==0?ms[0]:as[0];
    if (time>=druction){
        return type==0?ms[ms.length-1]:as[as.length-1];
    }
    float length=float(ms.length);
    //        每段变化的持续时间
    float averagetime = float (100.0/(length - 1.0));
    //        转化为持续时间内的时间
    float inputpos = getspeedpro(mod(time, druction) / druction) * druction;
    //        位于第几个间隔
    int pos = int (floor(inputpos / averagetime));

    float start = ms[pos];
    float end = ms[pos + 1];
    if (type==1){
        start = as[pos];
        end = as[pos + 1];
    }

    //        KLog.e(input);
    float pro=mod(inputpos, averagetime) / averagetime;
    pro=getspeedpro(pro);
    float nowvalue = start + (end - start) * (pro);
    return nowvalue;
}


//轻微抖动
void main() {
    vec2 texCoord=textureCoordinate/vec2(1.0);


    if (progress<=0.5){
        ms[0]=-0.15;
        ms[1]=0.07;
        ms[2]=-0.04;
        ms[3]=0.02;
        ms[4]=-0.01;
        ms[5]=0.0;

        as[0]=-0.2;
        as[1]=-0.04;
        as[2]=0.06;
        as[3]=-0.01;
        as[4]=0.004;
        as[5]=0.0;
        float time=progress*2.0*98.0+2.0;
        move=getvalue(time, 0)*1.8;
        angle=getvalue(time, 1);
        center.x-=move/2.0*1.2;
        texCoord.x-=move*1.2;
        texCoord=doroate(texCoord, -angle);
        texCoord=reset(texCoord);
        gl_FragColor=texture2D(inputImageTexture, texCoord);
    } else {

        float usepro=pow(0.7+(progress-0.5)*0.6, 20.0);
        if(progress>0.51){
            float cha=usepro-pow(0.7+(progress-0.51)*0.6, 20.0)*2.0;
            usepro-=cha;
        }

        vec2 tocenter=(center-texCoord)/(usepro+1.0);

        float strength = 0.2*(usepro);
        vec3 color = vec3(0.0);
        float total = 0.0;
        /* randomize the lookup values to hide the fixed number of samples */
        float offset = rand(textureCoordinate);
        float num=10.0;
        for (float t = 0.0; t <= num; t++) {
            float percent = (t + offset) / num;
            float weight = 4.0 * (percent - percent * percent);
            color += texture2D(inputImageTexture,
            reset(center-tocenter - tocenter * percent * strength)).rgb * weight;
            total += weight;
        }
        gl_FragColor= vec4(color / total, 1.0);
    }


}
