precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

float move=0.25;

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}


vec2 reset2(vec2 texCoord){
    if (texCoord.x<0.0){
        texCoord.x=0.0;
    } else if (texCoord.x>1.0){
        texCoord.x=1.0;
    }
    if (texCoord.y<0.0){
        texCoord.y=0.0;
    } else if (texCoord.y>1.0){
        texCoord.y=1.0;
    }
    return texCoord;

}


float getspeedmove(float pos){
    float move=abs(0.5-pos)*2.0;
    if (progress>0.5){
        move*=1.2;
    }
    return move*move/4.0-0.1;
}

float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}


void main() {
    vec2 texCoord=textureCoordinate/vec2(1.0);
    if (progress<0.5){
        vec2 tocenter=center-texCoord;
        texCoord=center-tocenter/(1.5-progress);
    }
    float move=pow(0.8 + progress * 0.2, 20.0);
    move=move*move/2.0;
    float angle=move*PI;
    texCoord.x-=move/3.0;
    texCoord=doroate(texCoord,angle);
//    if(progress>0.3){
//        float move=(progress-0.3)/0.7;
//        move=pow(move,3.5)/2.0;
//        float angle=move*PI;
//        texCoord.x-=move/3.0;
//        texCoord=doroate(texCoord,angle);
//    }
    if(texCoord.x<0.0||texCoord.x>1.0||texCoord.y<0.0||texCoord.y>1.0){
        gl_FragColor=vec4(0.0);
    }else
    gl_FragColor=texture2D(inputImageTexture, texCoord);
}
