#extension GL_OES_EGL_image_external : require

precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform samplerExternalOES inputImageTexture3;
uniform  float progress;


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

  float mixturePercent=0.9;
  float hueAdjust=0.0;
const highp vec4 kRGBToYPrime = vec4 (0.299, 0.587, 0.114, 0.0);
const highp vec4 kRGBToI = vec4 (0.595716, -0.274453, -0.321263, 0.0);
const highp vec4 kRGBToQ = vec4 (0.211456, -0.522591, 0.31135, 0.0);

const highp vec4 kYIQToR = vec4 (1.0, 0.9563, 0.6210, 0.0);
const highp vec4 kYIQToG = vec4 (1.0, -0.2721, -0.6474, 0.0);
const highp vec4 kYIQToB = vec4 (1.0, -1.1070, 1.7046, 0.0);

void main()
{
    mediump vec4 textureColor =
    progress<=0.5?
    texture2D(inputImageTexture, textureCoordinate):
    texture2D(inputImageTexture2, textureCoordinate);

    mediump vec4 textureColor2 = texture2D(inputImageTexture3, textureCoordinate);

    highp float YPrime = dot (textureColor2, kRGBToYPrime);
    highp float I = dot (textureColor2, kRGBToI);
    highp float Q = dot (textureColor2, kRGBToQ);

    // Calculate the hue and chroma
    highp float hue = atan (Q, I);
    highp float chroma = sqrt (I * I + Q * Q);

    // Make the user's adjustments
    hue += (-hueAdjust);//why negative rotation?

    // Convert back to YIQ
    Q = chroma * sin (hue);
    I = chroma * cos (hue);

    // Convert back to RGB
    if (textureColor2.r==0.0&&textureColor2.g==0.0&&textureColor2.b==0.0){
        textureColor2.r = 1.0;
        textureColor2.g = 1.0;
        textureColor2.b = 1.0;
    }
    else {
        highp vec4 yIQ = vec4 (YPrime, I, Q, 0.0);
        textureColor2.r = dot (yIQ, kYIQToR);
        textureColor2.g = dot (yIQ, kYIQToG);
        textureColor2.b = dot (yIQ, kYIQToB);
    }
    mediump vec4 whiteColor = vec4(1.0);
    lowp vec4 textureColor3 = whiteColor - ((whiteColor - textureColor2) * (whiteColor - textureColor));
    if (textureColor2.r==1.0&&textureColor2.g==1.0&&textureColor2.b==1.0){
        gl_FragColor=textureColor;
    } else {
        gl_FragColor =vec4(mix(textureColor.rgb, textureColor3.rgb, textureColor3.a*mixturePercent), textureColor.a); }
}
