

// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 1-6
// https://gl-transitions.com/editor/CrossZoom

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;

//uniform float strength; // = 0.4
float strength = 0.4;

float rand (vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}



void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec2 center =vec2(0.5) ;

    vec2 toCenter = center - texCoord;
    float cha=(1.0-progress);
    cha=pow(cha,6.0);
    toCenter/=(1.0+cha*0.6);
    texCoord=center-toCenter;

    // Mirrored sinusoidal loop. 0->strength then strength->0
    float strength = 0.2*cha;
    vec4 color=vec4(0.0);
    float total = 0.0;

    /* randomize the lookup values to hide the fixed number of samples */
    float offset = rand(textureCoordinate);
    float num=30.0;
    for (float t = 0.0; t <= num; t++) {
        float percent = (t + offset) / num;
        vec2 pos=texCoord - toCenter * percent * strength;
        vec4 use=texture2D(inputImageTexture, pos);
        total += use.a;
        color += use;
    }
    gl_FragColor= vec4(color / total);
}
