precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
float angle;
float move;
const float PI = 3.1415926;
vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    float scale=1.0-sqrt(progress);
    scale=getspeedpro(scale);
    vec2 rtn=vec2(center.x+dx2*(1.0-(scale)/4.0), center.y+dy2*(1.0-(scale)/4.0));
    return rtn;
}

vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if (texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if (texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if (texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if (texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

float ms [6];
float as [6];

//type=0 ms,1 as
float getvaluem(float time) {
    float druction=100.0;

    if (time <= 0.0) ms[0];
    if (time>=druction){
        ms[5];
    }
    //        每段变化的持续时间
    float averagetime = 20.0;
    //        转化为持续时间内的时间
    float inputpos = getspeedpro(mod(time, druction) / druction) * druction;
    //        位于第几个间隔
    int pos = 0;
    float pos2=0.0;
    for(;pos<6;pos++){
        pos2+=1.0;
        if(averagetime*pos2>=inputpos)break;
    }

    float start = ms[pos];
    float end = ms[pos + 1];

    //        KLog.e(input);
    float pro=mod(inputpos, averagetime) / averagetime;
    pro=getspeedpro(pro);
    float nowvalue = start + (end - start) * (pro);
    return nowvalue;
}

float getvaluea(float time) {
    float druction=100.0;

    if (time <= 0.0) return as[0];
    if (time>=druction){
        return as[5];
    }
    //        每段变化的持续时间
    float averagetime = 20.0;
    //        转化为持续时间内的时间
    float inputpos = getspeedpro(mod(time, druction) / druction) * druction;
    //        位于第几个间隔
    int pos = 0;
    float pos2=0.0;
    for(;pos<6;pos++){
        pos2+=1.0;
        if(averagetime*pos2>=inputpos)break;
    }

    float start = as[pos];
    float end = as[pos + 1];

    //        KLog.e(input);
    float pro=mod(inputpos, averagetime) / averagetime;
    
    float nowvalue = start + (end - start) * (pro);
    return nowvalue;
}

//轻微抖动
void main() {
    if(progress>0.99){
        gl_FragColor=texture2D(inputImageTexture, textureCoordinate);
        return;
    }
    ms[0]=-0.16;as[0]=-0.20;
    ms[1]=0.08; as[1]=-0.04;
    ms[2]=-0.04;as[2]=0.1;
    ms[3]=0.02; as[3]=0.02;
    ms[4]=-0.01;as[4]=-0.05;
    ms[5]=0.0;  as[5]=0.0;

    float pp=2.0+progress*98.0;
    move=getvaluem(pp)*1.8;
    angle=getvaluea(pp);

    vec2 texCoord=textureCoordinate/vec2(1.0);
    center.x-=move/2.0*1.2;
    texCoord.x-=move*1.2;

    texCoord=doroate(texCoord, -angle);
    texCoord=reset(texCoord);

    gl_FragColor=texture2D(inputImageTexture, texCoord);


}
