precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;


float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}


vec2 center=vec2(0.5, -0.5);
vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}


vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if(texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if(texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if(texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if(texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

float as [6];
float getvalue(float time) {
    float druction=100.0;

    if (time <= 0.0) return as[0];
    if (time>=druction){
        return as[5];
    }
    //        每段变化的持续时间
    float averagetime = 20.0;
    //        转化为持续时间内的时间
    float inputpos = (mod(time, druction) / druction) * druction;
    //        位于第几个间隔
    int pos = 0;
    float pos2=0.0;
    for(;pos<6;pos++){
        pos2+=1.0;
        if(averagetime*pos2>inputpos)break;
    }

    float  start = as[pos];
    float  end = as[pos + 1];

    //        KLog.e(input);
    float pro=mod(inputpos, averagetime) / averagetime;
    pro=getspeedpro(pro);
    float nowvalue = start + (end - start) * (pro);
    return nowvalue;
}

//左右抖动
void main() {
    as[0]=0.5;
    as[1]=-0.15;
    as[2]=0.05;
    as[3]= -0.01;
    as[4]=0.002;
    as[5]=0.0;


    float vv=getvalue(progress*100.0);

    vec2 texCoord=doroate(textureCoordinate, vv);
    texCoord=reset(texCoord);
    float num=5.0;
    vec4 color=vec4(0.0);

    float total=0.0;
    for (float t = 0.0; t <= num*2.0; t++) {
        float weight = 1.0;
        float needroate=vv*(1.0-(num-t)*0.01);
        vec2 movepos=doroate(textureCoordinate, -needroate);
        movepos=reset(movepos);
        vec4 use=texture2D(inputImageTexture, movepos);
        color += use;
        total += use.a;
    }

    gl_FragColor= vec4(color / total);

}
