precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(1.0, 0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}
float rand (vec2 co) {
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

float getusepeo(){
    return sqrt(progress);
}


void main() {
    float usepro=1.0-getusepeo();
    float roate=-usepro*PI/2.0;
    vec2 texCoord=textureCoordinate/vec2(1.0);

    vec4 color=texture2D(inputImageTexture, doroate(texCoord,roate));
    //    return;
    if(color.a!=1.0){
        gl_FragColor=color;
        return;
    }


    float num=5.0;
    color=vec4(0.0);
    float total=0.0;
    for (float t = 0.0; t <= num*2.0; t++) {
        float needroate=roate-(num-t)*0.02*usepro;
        vec2 movepos=doroate(texCoord, needroate);
        vec4 use=texture2D(inputImageTexture, movepos);
        color += use;
        total += use.a;
    }

    gl_FragColor= vec4(color / total);

}
