precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float PI = 3.1415926;
vec2 center=vec2(0.5, 0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}
vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(center.x+dx2, center.y+dy2);
    return rtn;
}

float getusepeo(){
    float pro=progress;
    if (pro < 0.25) {
        pro =pro*2.0;
    } else if (pro < 0.5){
        pro=0.5+(pro-0.25);
    } else {
        pro=0.75+(pro-0.5)/2.0;
    }
    pro=getspeedpro(pro);
    pro=sqrt(pro);
    return sqrt(pro);
}


void main() {
    float usepro=getusepeo();
    float roate =(usepro-1.0)*PI/2.0;
    vec2 texCoord = textureCoordinate/1.0;

    texCoord.x-=(1.0-usepro)*0.35;
    texCoord = doroate(texCoord, -roate);

    if (texCoord.x<0.0||texCoord.x>1.0||texCoord.y<0.0||texCoord.y>1.0){
        gl_FragColor=vec4(0.0);
    } else
    gl_FragColor=texture2D(inputImageTexture, texCoord);


}
