precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

float radiuspro;
float blurpro;


float radius = 0.4;
// 凹凸的比例
vec2 center = vec2(0.5);


//处理凹凸
vec2 getuseuv(vec2 uv) {
    vec2 useuv = uv;
    vec2 cha = useuv - center;

    if (ratio < 1.0) {
        cha.y /= ratio;
    } else {
        cha.x *= ratio;
    }

    float l = length(cha);
    if (l <= radius) {
        //        这样就变成了0-1
        l /= radius;
        float usel;
        //凸
        float scale;

        usel = pow(l, 1.1);
        scale = 1.0 + (usel - 1.0) * radiuspro;
        scale = 2.0 - scale;

        cha *= scale;
        if (ratio < 1.0) {
            cha.y *= ratio;
        } else {
            cha.x /= ratio;
        }
        useuv = cha + center;
        return useuv;
    } else {
        return uv;
    }
}

vec4 getusecolor(vec2 uv) {
    uv=getuseuv(uv);
    return texture2D(inputImageTexture, uv);
}

//处理模糊
vec4 getblur(vec2 uv) {
    float mixvalue = blurpro;
    //    float random = (0.5 - Rand(uv * mixvalue)) * 0.05 * mixvalue;
    //    float random2 = (0.5 - Rand(uv * mixvalue / 2.0)) * 0.05 * mixvalue;
    //    uv += vec2(random, random2);
    vec2 size = vec2(mixvalue * 0.02);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol = 0.0;
    {
        vec4 sum = vec4(0.0);
        sum += getusecolor(uv);

        sum += getusecolor(uv + vec2(size.x, size.y));
        sum += getusecolor(uv + vec2(-size.x, size.y));
        sum += getusecolor(uv + vec2(size.x, -size.y));
        sum += getusecolor(uv + vec2(-size.x, -size.y));

        sum += getusecolor(uv + vec2(0.0, -size.y));
        sum += getusecolor(uv + vec2(0.0, size.y));
        sum += getusecolor(uv + vec2(size.x, 0.0));
        sum += getusecolor(uv + vec2(-size.x, 0.0));
        tol += 9.0;

        //        sum += getusecolor(uv + vec2(0.0, -size.y * 2.0));
        //        sum += getusecolor(uv + vec2(size.x, -size.y * 2.0));
        //        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y * 2.0));
        //        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y * 2.0));
        //        sum += getusecolor(uv + vec2(-size.x, -size.y * 2.0));
        //
        //        sum += getusecolor(uv + vec2(0.0, size.y * 2.0));
        //        sum += getusecolor(uv + vec2(size.x, size.y * 2.0));
        //        sum += getusecolor(uv + vec2(size.x * 2.0, size.y * 2.0));
        //        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y * 2.0));
        //        sum += getusecolor(uv + vec2(-size.x, size.y * 2.0));
        //
        //        sum += getusecolor(uv + vec2(size.x * 2.0, size.y));
        //        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y));
        //        sum += getusecolor(uv + vec2(size.x * 2.0, 0.0));
        //
        //        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y));
        //        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y));
        //        sum += getusecolor(uv + vec2(-size.x * 2.0, 0.0));
        //        tol += 16.0;
        usecolor = vec4(sum / tol);
    }
    return usecolor;
}

float getvalue(float x){
    return x < 0.5 ? 2.0 * x * x
    : 1.0 - pow(-2.0 * x + 2.0, 2.0) / 2.0;
}
void main() {
    if(progress<0.5){
        gl_FragColor=texture2D(inputImageTexture, textureCoordinate);
        return;
    }
    float usepro=(progress-0.5)*2.0;
//    usepro = progress;
    radiuspro=usepro<0.94?getvalue(usepro/0.94):1.0;
    radiuspro=(1.0-radiuspro)/3.0;
    if(usepro<0.69){
        blurpro=0.0;
    }else if(usepro<0.81){
        blurpro=getvalue((usepro-0.69)/(0.81-0.69));
    }else if(usepro<0.88){
        blurpro=getvalue((usepro-0.81)/(0.88-0.81));
        blurpro=1.0-blurpro;
    }else{
        blurpro=0.0;
    }
    if(blurpro==0.0){
        gl_FragColor = getusecolor(textureCoordinate);
    }else{
        blurpro/=5.0;
        gl_FragColor = getblur(textureCoordinate);
    }

}
