precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
vec3 getusecolor(vec2 uv) {
    vec4 usecolor = progress < 0.5 ? getFromColor(uv) : getToColor(uv);
    return usecolor.rgb;
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * 3.14159) / 2.0) + 0.5);
}

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float pro=getspeedpro(progress);
    float mixvalue = min(progress, 1.0 - pro);
    float random = (0.5 - Rand(uv * pro)) *0.05*mixvalue;
    float random2 = (0.5 - Rand(uv * pro/2.0)) *0.05*mixvalue;


    /**float maxmosaic=0.01;
    vec2 mosaic=vec2(maxmosaic*mixvalue);
    if(ratio>1.0){
        mosaic.y*=ratio;
    }else{
        mosaic.x/=ratio;
    }
    vec2 cha=(uv)+mosaic/2.0;
    cha=floor(cha/mosaic)*mosaic;
    uv=cha;
    */
    uv += vec2(random, random2);
    vec2 size = vec2(mixvalue * 0.02);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol=0.0;
    {
        lowp vec3 sum = vec3(0.0);
        sum += getusecolor(uv) * 1.0;

        sum += getusecolor(uv + vec2(size.x, size.y));
        sum += getusecolor(uv + vec2(-size.x, size.y));
        sum += getusecolor(uv + vec2(size.x, -size.y));
        sum += getusecolor(uv + vec2(-size.x, -size.y));

        sum += getusecolor(uv + vec2(0.0, -size.y));
        sum += getusecolor(uv + vec2(0.0, size.y));
        sum += getusecolor(uv + vec2(size.x, 0.0));
        sum += getusecolor(uv + vec2(-size.x, 0.0));
        tol+=9.0;

        sum += getusecolor(uv + vec2(0.0, -size.y*2.0));
        sum += getusecolor(uv + vec2(size.x, -size.y*2.0));
        sum += getusecolor(uv + vec2(size.x*2.0, -size.y*2.0));
        sum += getusecolor(uv + vec2(-size.x*2.0, -size.y*2.0));
        sum += getusecolor(uv + vec2(-size.x, -size.y*2.0));

        sum += getusecolor(uv + vec2(0.0, size.y*2.0));
        sum += getusecolor(uv + vec2(size.x, size.y*2.0));
        sum += getusecolor(uv + vec2(size.x*2.0, size.y*2.0));
        sum += getusecolor(uv + vec2(-size.x*2.0, size.y*2.0));
        sum += getusecolor(uv + vec2(-size.x, size.y*2.0));

        sum += getusecolor(uv + vec2(size.x*2.0, size.y));
        sum += getusecolor(uv + vec2(size.x*2.0, -size.y));
        sum += getusecolor(uv + vec2(size.x*2.0, 0.0));

        sum += getusecolor(uv + vec2(-size.x*2.0, size.y));
        sum += getusecolor(uv + vec2(-size.x*2.0, -size.y));
        sum += getusecolor(uv + vec2(-size.x*2.0, 0.0));
        tol+=16.0;
        usecolor = vec4(sum / tol, 1.0);
    }
    //    if (mixvalue > 0.01) {
    //        vec3 randcolor = vec3(Rand(uv));
    //        usecolor.rbg = usecolor.rbg*(1.0-mixvalue) + randcolor *mixvalue;
    //    }

    gl_FragColor = usecolor;
}
