precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

#define m_p 3.1415926538
#define m_dp 6.283185308



float v = 1600.0;
vec3 Bokeh(sampler2D tex, vec2 uv, float pro)
{

    float a = 0.0;  // angle ngon
    //    调节是几边形
    float vc = 6.0;  // ngon vertices count
    //    调节范围
    float ss = pro * 4.0;  // sample strength
    float k = 10.0;
    vec2 s = vec2(1.0 / v);
    if (ratio > 1.0) {
        s.x /= ratio;
    } else {
        s.y *= ratio;
    }
    vec2 uses = s * ss;
    float hk = k * 0.5;
    vec3 mcol = vec3(0.0);
    vec2 pt;
    for (float x = 0.0 - hk; x < hk; x += 1.0)
    {
        for (float y = 0.0 - hk; y < hk; y += 1.0)
        {
            pt.x = x;
            pt.y = y;
            float an = a + atan(x, y);
            float ngon = cos(an - (m_dp * floor((m_p + vc * an) / m_dp)) / vc) / cos(m_p / vc);
            float ngonSdf = ngon * length(pt) - hk;

            if (ngonSdf < 0.0)
            {
                vec3 col = texture2D(tex, uv + uses * vec2(x, y)).rgb;
                mcol = max(mcol, col);
            }
        }
    }
    return mcol;
}

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);

    //    uv*=v;
    //    uv=floor(uv)/v;

    //    float pro = getspeedpro(progress);
    //    if (progress <= 0.4) {
    //        gl_FragColor = vec4(Bokeh(inputImageTexture, uv, progress / 0.6), 1.0);
    //    } else if (progress >= 0.6) {
    //        gl_FragColor = vec4(Bokeh(inputImageTexture2, uv, (1.0 - progress) / 0.6), 1.0);
    //    } else {
    //        vec4 color1 = vec4(Bokeh(inputImageTexture, uv, progress / 0.6), 1.0);
    //        vec4 color2 = vec4(Bokeh(inputImageTexture2, uv, (1.0 - progress) / 0.6), 1.0);
    //        gl_FragColor = mix(color1, color2, (progress - 0.4) / 0.2);
    //    }

    if (progress <= 0.5) {
        gl_FragColor = vec4(Bokeh(inputImageTexture, uv, progress / 0.5), 1.0);
    } else {
        gl_FragColor = vec4(Bokeh(inputImageTexture2, uv, (1.0 - progress) / 0.5), 1.0);
    }
}
