precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

uniform float xoff;
uniform float yoff;
uniform float scale;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float isin() {
    vec2 center = vec2(xoff, yoff);
    vec2 change = textureCoordinate - center;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    return length(change) > scale ? 1.0 : 0.0;
}

void main() {
    gl_FragColor = mix(getFromColor(textureCoordinate), getToColor(textureCoordinate), isin());
}
