precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform float scale;
uniform float xoff;
uniform float yoff;

vec2 center = vec2(0.5);
bool showto1 = false, showto2 = false;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec4 getshowcolor(vec2 uv) {
    //    return progress < 0.5 ? getFromColor(uv) : getToColor(uv);
    return showto1 && showto2 ? getToColor(uv) : getFromColor(uv);
}

float whitewidth = 0.015;
vec4 whitecolor = vec4(1.0);


float resetvalue(float v) {
    //   -1-0||1-2;镜像
    if (abs(v - 0.5) <= 0.5) {

    } else if ((v >= -1.0 && v < 0.0) || (v <= 2.0 && v > 1.0)) {
        v = v < 0.0 ? -v : 2.0 - v;
    }//-2 - -1|| 2-3;重复
    else if ((v >= -2.0 && v < -1.0) || (v <= 3.0 && v > 2.0)) {
        v = v < 0.0 ? 2.0 + v : v - 2.0;
        showto1 = true;
    }
    return v;
}

//映射到坐标正常位置
vec2 resetpos(vec2 uv) {
    uv.x = resetvalue(uv.x);
    uv.y = resetvalue(uv.y);
    return uv;
}

vec2 getshowpos(vec2 uv) {
    vec2 cha = uv - center;
    if (abs(cha.x) <= 0.5 && abs(cha.y) <= 0.5) {
        showto2 = true;
        return uv;
    }
    float w = whitewidth;
    float h = whitewidth;
    if (ratio > 1.0) {
        h *= ratio;
    } else {
        w /= ratio;
    }
    vec2 usepoint;
    vec2 usepointpos;

    if (uv.x < -w && uv.y < 1.0) {
        usepoint = vec2(-w, 1.0);
        cha = (uv - usepoint) / 2.0;
        usepointpos = vec2(1.0, 1.0);
        return usepointpos + cha;
    }

    if (uv.x > (1.0) + w && uv.y > (0.0)) {
        usepoint = vec2((1.0) + w, (0.0));
        usepointpos = vec2(0.0, 0.0);
        cha = (uv - usepoint) / 2.0;
        return usepointpos + cha;
    }

    if (uv.y < (0.0) - h && uv.x > (0.0)) {
        usepoint = vec2((0.0), (0.0) - h);
        usepointpos = vec2(0.0, 1.0);
        cha = (uv - usepoint) / 2.0;
        return vec2(cha.x, usepointpos.y + cha.y);
    }

    if (uv.y > (1.0) + h && uv.x < (1.0)) {
        usepoint = vec2((1.0), (1.0) + h);
        usepointpos = vec2(1.0, 0.0);
        cha = (usepoint - uv) / 2.0;
        return vec2(usepointpos.x - cha.x, cha.y);
    }
    return vec2(-1.0);
}

vec2 getscalepos(vec2 uv) {
    vec2 newuv = uv + vec2(xoff, yoff);
    newuv = resetpos(newuv);
    newuv = center + (newuv - center) / (scale);
    return newuv;
}


void main() {
    vec2 uv = getscalepos(textureCoordinate);
    uv = getshowpos(uv);
    if (uv.x < 0.0) {
        gl_FragColor = whitecolor;
        return;
    }
    gl_FragColor = getshowcolor(uv);
}
