precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
vec2 center = vec2(0.5);

vec2 doroate(vec2 c2, float roate, float scale) {
    //    vec2 center=vec2(centerx, centery);

    //计算旋转角度
    vec2 uv2 = c2 - center;
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    vec2 rtn = vec2(center.x + dx2 / scale, center.y + dy2 / scale);
    return rtn;
}

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    float usepro=1.0-progress;
    float minvalue=min(usepro, 1.0 - usepro);
    minvalue=sqrt(minvalue*2.0)/2.0;
    float d = minvalue * 0.3;
    vec4 usecolor;
    float scale;
    float roate;
    if(progress<0.2){
        float pro=progress*5.0;
        scale=1.0+pro*0.2;
    }else{
        float pro=(progress-0.2)/0.8;
        scale=1.2-pro*0.2;
    }
    roate=-(scale-1.0)/3.0;

    vec2 uv = textureCoordinate.xy / vec2(1.0);

    //    函数是 y=d*x+usepro
    if (uv.x * -d + usepro <= uv.y) {
        uv.y += (progress) * 0.3-0.3;
        uv = doroate(uv, roate, scale);
        usecolor=getToColor(uv);
    } else {
        uv.y -= usepro * 0.3-0.3;
        uv = doroate(uv, roate, scale);
        usecolor = getFromColor(uv);
    }
    gl_FragColor = usecolor;
}
