precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
vec2 center = vec2(0.5);

vec2 doroate(vec2 c2, float roate, float scale) {
    //    vec2 center=vec2(centerx, centery);

    //计算旋转角度
    vec2 uv2 = c2 - center;
    if (ratio > 1.0) {
        uv2.x = uv2.x * ratio;
    } else {
        uv2.y = uv2.y / ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x * c + uv2.y * s;
    float dy2 = -uv2.x * s + uv2.y * c;
    if (ratio > 1.0) {
        dx2 = dx2 / ratio;
    } else {
        dy2 = dy2 * ratio;
    }
    vec2 rtn = vec2(center.x + dx2 / scale, center.y + dy2 / scale);
    return rtn;
}

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

uniform int type;
uniform float scale;
uniform float roate;
uniform float usepro2;
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    vec4 usecolor;
    float usepro=progress;
    float d = min(usepro, 1.0 - usepro) * 0.2;
    if(type==1){
        //    函数是 y=d*x+usepro
        if (uv.x * d + usepro <= uv.y) {
            uv.y -= usepro2;
            uv = doroate(uv, roate, scale);
            usecolor = getFromColor(uv);
        } else {
            uv.y += 0.2-usepro2;
            uv = doroate(uv, roate, scale);
            usecolor = getToColor(uv);
        }
    }else if(type==3){
        //    函数是 y=d*x+usepro
        if (uv.y * d + usepro <= uv.x) {
            uv.x -= usepro2;
            uv = doroate(uv, roate, scale);
            usecolor = getFromColor(uv);
        } else {
            uv.x += 0.2-usepro2;
            uv = doroate(uv, roate, scale);
            usecolor = getToColor(uv);
        }
    }else{
        usepro=1.0-progress;
        if(type==2){
            //    函数是 y=d*x+usepro
            if (uv.x * -d + usepro <= uv.y) {
                uv.y -= 0.2-usepro2;
                uv = doroate(uv, roate, scale);
                usecolor=getToColor(uv);
            } else {
                uv.y += usepro2;
                uv = doroate(uv, roate, scale);
                usecolor = getFromColor(uv);
            }
        }else{
            //    函数是 y=d*x+usepro
            if (uv.y * -d + usepro <= uv.x) {
                uv.x -= 0.2-usepro2;
                uv = doroate(uv, roate, scale);
                usecolor=getToColor(uv);
            } else {
                uv.x += usepro2;
                uv = doroate(uv, roate, scale);
                usecolor = getFromColor(uv);
            }
        }
    }

    gl_FragColor = usecolor;
}
