precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center=vec2(0.5);
float maxmosaic=0.1;

vec3 rgbToHsv(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsvToRgb(vec3 c) {//convertHsvToRgb
                       vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
                       vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
                       return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}
vec3 addmax=vec3(0.0,0.0,0.5);
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float d = min(progress, 1.0 - progress);
    if(d>0.001){
        vec2 mosaic=vec2(maxmosaic*d);
        if(ratio>1.0){
            mosaic.y*=ratio;
        }else{
            mosaic.x/=ratio;
        }
        vec2 cha=(uv)+mosaic/2.0;
        cha=floor(cha/mosaic)*mosaic;
        uv=cha;
    }
    vec4 usecolor=progress<0.5?getFromColor(uv):getToColor(uv);

    vec3 hsl=rgbToHsv(usecolor.xyz);
    hsl+=addmax*d;
    usecolor.xyz=hsvToRgb(hsl);

    gl_FragColor = usecolor;
}
