// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform  float progress;
uniform float ratio;

uniform float xoff;
uniform float yoff;
uniform float off;
uniform float domove;

const float PI = 3.1415926;
vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 zhuanhua(vec2 texCoord){
    if(texCoord.x<0.0){
        texCoord.x*=-1.0;
    }
    if(texCoord.y<0.0){
        texCoord.y*=-1.0;
    }
    if(texCoord.x>1.0){
        texCoord.x=2.0-texCoord.x;
    }
    if(texCoord.y>1.0){
        texCoord.y=2.0-texCoord.y;
    }
    return texCoord;
}

vec4 crossFade(vec2 uv) {
    uv=zhuanhua(uv);
    return progress<0.5?getFromColor(uv):getToColor(uv);
}


//float type=1.0;
//float getspeedpro(float usepro){
//    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
//}

vec3 rgbToHsv(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsvToRgb(vec3 c) {//convertHsvToRgb
                       vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
                       vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
                       return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}
vec3 addmax=vec3(0.0,0.0,0.5);

void main() {
    vec2 texCoord = textureCoordinate.xy/vec2(1.0);
    float pro=domove;
    float domovex = (pro<0.5?pro:pro-1.0);
//    float domovex = domove;
    float domovey = domovex;
    domovex*=xoff;
    domovey*=yoff;
    if(off>0.0){
        texCoord.x+=domovex;
        texCoord.y+=domovey;
    }
    if(ratio<1.0){
        domovex*=ratio;
    }else{
        domovey/=ratio;
    }
    vec2 move=vec2(domovex, domovey);
    move/=100.0;
    float num=20.0;
    float total=0.0;
    vec3 color=vec3(0.0);
    for (float t = -num; t <= num; t++) {
        float weight = num-abs(t);
        color += crossFade(texCoord +move*t).rgb * weight;
        total += weight;
    }
    color /= total;
    if(off<0.0){
        vec3 hsl=rgbToHsv(color);
        hsl+=addmax*min(pro, 1.0 - pro);
        color=hsvToRgb(hsl);
    }
    gl_FragColor= vec4(color, 1.0);
}



