// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;

uniform vec2 center;
uniform float roate;
uniform int type;

const float PI = 3.1415926;
float pro;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 zhuanhua(vec2 texCoord){
    if(texCoord.x<0.0){
        texCoord.x*=-1.0;
    }
    if(texCoord.y<0.0){
        texCoord.y*=-1.0;
    }
    if(texCoord.x>1.0){
        texCoord.x=2.0-texCoord.x;
    }
    if(texCoord.y>1.0){
        texCoord.y=2.0-texCoord.y;
    }
    return texCoord;
}


float offmax=PI;

vec2 doroate(vec2 c2, float roate){
    //计算旋转角度
    vec2 uv2  =c2-center;
    if (ratio>1.0){
        uv2.x=uv2.x*ratio;
    } else {
        uv2.y=uv2.y/ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx2 = uv2.x*c+uv2.y*s;
    float dy2 = -uv2.x*s+uv2.y*c;
    if (ratio>1.0){
        dx2=dx2/ratio;
    } else {
        dy2=dy2*ratio;
    }
    return zhuanhua(vec2(center.x+dx2,center.y+dy2));
}

vec4 crossFade(vec2 uv,float roate) {
    uv=doroate(uv,roate);
    return pro<0.5?getFromColor(uv):getToColor(uv);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

void main() {
    vec2 texCoord = textureCoordinate.xy/vec2(1.0);
    pro=getspeedpro(progress);
    pro=getspeedpro(pro);

    float off=min(pro,1.0-pro);
    float useroate=roate;
//    if(type>=0){
//        useroate*=pro;
//    }else
    if(type<0){
        offmax=roate*3.0;
    }
    float num=20.0;
    float total=0.0;
    vec3 color=vec3(0.0);
    for (float t = 0.0; t <= num; t++) {
        float weight = t;
        color += crossFade(texCoord,useroate-(offmax*(t/num/2.0)*off)).rgb * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);
}



