// License: MIT
// Author: rectalogic
// ported by gre from https://gist.github.com/rectalogic/b86b90161503a0023231

// Converted from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/CrossZoom/CrossZoom.frag
// Which is based on https://github.com/evanw/glfx.js/blob/master/src/filters/blur/zoomblur.js
// With additional easing functions from https://github.com/rectalogic/rendermix-basic-effects/blob/master/assets/com/rendermix/Easing/Easing.glsllib

// 3-1
// https://gl-transitions.com/editor/CrossZoom

precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
//uniform float ratio;
//uniform float isout;
uniform float scale;

const float PI = 3.1415926;
vec2 center=vec2(0.5);
float pro;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
vec2 zhuanhua(vec2 texCoord){
    if(texCoord.x<0.0){
        texCoord.x*=-1.0;
    }
    if(texCoord.y<0.0){
        texCoord.y*=-1.0;
    }
    if(texCoord.x>1.0){
        texCoord.x=2.0-texCoord.x;
    }
    if(texCoord.y>1.0){
        texCoord.y=2.0-texCoord.y;
    }
    return texCoord;
}

vec2 doscale(vec2 uv){
    vec2 cha=uv-center;
    cha/=scale;
    uv=center+cha;
    return zhuanhua(uv);
}

vec4 crossFade(vec2 uv) {
    uv=doscale(uv);
    return pro<0.5?getFromColor(uv):getToColor(uv);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

void main() {
    vec2 texCoord = textureCoordinate.xy/vec2(1.0);
    pro=getspeedpro(progress);
    float off=min(pro,1.0-pro);
    vec2 move = center-texCoord;
    move/=2.0;
    float num=20.0;
    float total=0.0;
    vec3 color=vec3(0.0);
    for (float t = 0.0; t <= num; t++) {
        float weight = num-t;
        float moveoff=1.0+t/num;
        color += crossFade(texCoord +move*(moveoff)*off).rgb * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);
}



