//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float radius = 0.4;
// 凹凸的比例
float radiuspro;
vec2 center = vec2(0.5);

//处理凹凸
vec2 getuseuv(vec2 uv) {
    vec2 useuv = uv;
    vec2 cha = useuv - center;

    if (ratio < 1.0) {
        cha.y /= ratio;
    } else {
        cha.x *= ratio;
    }

    float l = length(cha);
    if (l <= radius) {
        //        这样就变成了0-1
        l /= radius;
        float usel;
        //凸
        float scale;
        if (progress < 0.5) {
            usel = sqrt(l);
            scale = 1.0 + (usel - 1.0) * radiuspro;
        } else { //凹
                 usel = pow(l, 1.1);
                 scale = 1.0 + (usel - 1.0) * radiuspro;
                 scale = 2.0 - scale;
        }
        cha *= scale;

        if (ratio < 1.0) {
            cha.y *= ratio;
        } else {
            cha.x /= ratio;
        }

        useuv = cha + center;
        return useuv;
    } else {
        return uv;
    }
}

vec4 getusecolor(vec2 uv) {
    uv = getuseuv(uv);
    return progress < 0.5 ? getFromColor(uv) : getToColor(uv);
}

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

float blurpro;
//处理模糊
vec4 getblur(vec2 uv) {
    float mixvalue = blurpro;
    vec2 uv = textureCoordinate;
    float random = (0.5 - Rand(uv * mixvalue)) * 0.05 * mixvalue;
    float random2 = (0.5 - Rand(uv * mixvalue / 2.0)) * 0.05 * mixvalue;
    uv += vec2(random, random2);
    vec2 size = vec2(mixvalue * 0.02);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol = 0.0;
    {
        vec4 sum = vec4(0.0);
        sum += getusecolor(uv);

        sum += getusecolor(uv + vec2(size.x, size.y));
        sum += getusecolor(uv + vec2(-size.x, size.y));
        sum += getusecolor(uv + vec2(size.x, -size.y));
        sum += getusecolor(uv + vec2(-size.x, -size.y));

        sum += getusecolor(uv + vec2(0.0, -size.y));
        sum += getusecolor(uv + vec2(0.0, size.y));
        sum += getusecolor(uv + vec2(size.x, 0.0));
        sum += getusecolor(uv + vec2(-size.x, 0.0));
        tol += 9.0;

        sum += getusecolor(uv + vec2(0.0, -size.y * 2.0));
        sum += getusecolor(uv + vec2(size.x, -size.y * 2.0));
        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y * 2.0));
        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y * 2.0));
        sum += getusecolor(uv + vec2(-size.x, -size.y * 2.0));

        sum += getusecolor(uv + vec2(0.0, size.y * 2.0));
        sum += getusecolor(uv + vec2(size.x, size.y * 2.0));
        sum += getusecolor(uv + vec2(size.x * 2.0, size.y * 2.0));
        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y * 2.0));
        sum += getusecolor(uv + vec2(-size.x, size.y * 2.0));

        sum += getusecolor(uv + vec2(size.x * 2.0, size.y));
        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y));
        sum += getusecolor(uv + vec2(size.x * 2.0, 0.0));

        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y));
        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y));
        sum += getusecolor(uv + vec2(-size.x * 2.0, 0.0));
        tol += 16.0;
        usecolor = vec4(sum / tol);
    }
    return usecolor;
}

float radiusmax = 0.3;
float bluroff = 0.1;
void main() {
    blurpro = 0.1;
    float usepro = progress < 0.5 ? progress : (1.0 - progress);
    usepro *= 2.0;
    radiuspro = usepro * usepro;
    blurpro *= usepro;
    if (progress > 0.5) {
        radiuspro *= 0.3;
    }
    //    gl_FragColor = getusecolor(uv);
    if (blurpro > 0.0) {
        gl_FragColor = getblur(textureCoordinate);
    } else {
        gl_FragColor = getusecolor(textureCoordinate);
    }

}
