// 5-9 曲线
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);

//圆形
float sdCircle(vec2 p, float r)
{
    return length(p) - r;// 到圆表面的距离
}

float PI = 3.14159;
//一圈有多少个环
float usePI = 3.14159/2.0 / 3.0;

float startlength = 0.015;
void main() {
    float maxnum = 35.0;
    float length_scale = min(1.0, progress / 0.5);
    float off = 1.0;
    if (progress > 0.5 && progress < 0.7) {
        off = 1.0 + sin((progress - 0.5) * 20.0 * PI) * (0.7 - progress) * startlength;
    }
    float baselength = startlength;
    if (progress < 0.5) {
        baselength = startlength * length_scale;
    } else if (progress > 0.7) {
        baselength = pow(progress / 0.7, 3.0) * startlength;
    }
    for (float i = 0.0;i < maxnum; i++) {
        float length = pow(i, off) * 0.02 * length_scale;
        float radius = length / 0.02 * usePI;
        vec2 usecenter = vec2(length * sin(radius), length * cos(radius));
        if (ratio < 1.) {
            usecenter.x = usecenter.x / ratio;
        } else {
            usecenter.y = usecenter.y * ratio;
        }
        usecenter += center;
        vec2 st = textureCoordinate - usecenter;
        if (ratio > 1.) {
            st.y = st.y / ratio;
        } else {
            st.x = st.x * ratio;
        }
        float l = sdCircle(st, sqrt(i + 1.0) * baselength);
        if (l < 0.0) {
            gl_FragColor = getToColor(textureCoordinate);
            gl_FragColor = vec4(1.0);
            return;
        }
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
