// 5-9 环绕
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//圆形
float sdCircle(vec2 p, float r)
{
    return length(p) - r;// 到圆表面的距离
}
vec2 center = vec2(0.5);
float PI = 3.14159;
float circlenum = 10.0;
//出现的时候会有几个在进行动画
float animpos = 6.0;

float size = 0.1;

float isincircle(vec2 pos, vec2 usecenter, float length) {
    vec2 st = pos - usecenter;
    if (ratio > 1.) {
        st.y = st.y / ratio;
    } else {
        st.x = st.x * ratio;
    }
    float l = sdCircle(st, length);
    return l;
}

float getuseprogress(float usepro, float nowpos, float pre) {
    float start = nowpos * (1.0 - pre);
    if (usepro < start)return 0.0;
    if (usepro > start + pre)return 1.0;
    return (usepro - start) / pre;
}

void main() {
    //    center.x = sin(progress * PI);
    //    center.y = cos((progress+0.5) * PI)+1.0;

    float little_size = size * 0.3;
    float use_size = (1.0-abs(progress - 0.5) / 0.5) * size;
    float l;
    l = isincircle(textureCoordinate, center, use_size);
    if (l < 0.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }


    float length = size * 1.6 * (1.0 + sin(progress * PI) / 2.0);
    float pretime = animpos / circlenum;
    for (float i = 0.0; i < circlenum; i++) {
        float radius = PI * i / circlenum * 2.0 + progress * PI * 5.0;
        float uselength;
        float usesize;
        if (progress < 0.4) {
            float usepro = (progress) / 0.4;
            usepro = getuseprogress(usepro, i / circlenum, pretime);
            usepro = sqrt(usepro);
            uselength = sqrt(usepro) * length;
            usesize = little_size*usepro;
        } else if (progress > 0.6) {
            float usepro = (1.0 - progress) / 0.4;
            usepro = getuseprogress(usepro, i / circlenum, pretime);
            usepro = sqrt(usepro);
            uselength = usepro * length;
            usesize = little_size*usepro;
        } else {
            uselength = length;
            usesize = little_size;
        }

        vec2 usecenter = vec2(uselength * sin(radius), uselength * cos(radius));
        if (ratio < 1.) {
            usecenter.x = usecenter.x / ratio;
        } else {
            usecenter.y = usecenter.y * ratio;
        }
        usecenter += center;
        l = isincircle(textureCoordinate, usecenter, usesize);
        if (l < 0.0) {
            gl_FragColor = getToColor(textureCoordinate);
            return;
        }
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
