// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 p0 = vec2(0.0, 0.0);
vec2 p1 = vec2(0.3, 0.5);
vec2 p2 = vec2(0.8, 0.5);
vec2 p3 = vec2(1.0, 0.0);

vec2 bezier_3order_mix(float t)
{
    vec2 q0 = mix(p0, p1, t);
    vec2 q1 = mix(p1, p2, t);
    vec2 q2 = mix(p2, p3, t);

    vec2 r0 = mix(q0, q1, t);
    vec2 r1 = mix(q1, q2, t);

    return mix(r0, r1, t);
}

void main() {
    p1.y=progress;
    p2.y=1.0-progress;
    vec2 value2 = bezier_3order_mix(textureCoordinate.x);

    gl_FragColor = textureCoordinate.y>value2.y ? getFromColor(textureCoordinate) : getToColor(textureCoordinate);
}
