//https://www.shadertoy.com/view/lssGR7

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
const float timeEffect = 1.0;

/* This animation is the material of my first youtube tutorial about creative
   coding, which is a video in which I try to introduce programmers to GLSL
   and to the wonderful world of shaders, while also trying to share my recent
   passion for this community.
                                       Video URL: https://youtu.be/f4s1h2YETNY
*/

//https://iquilezles.org/articles/palettes/
vec3 palette(float t) {
    vec3 a = vec3(0.5, 0.5, 0.5);
    vec3 b = vec3(0.5, 0.5, 0.5);
    vec3 c = vec3(1.0, 1.0, 1.0);
    vec3 d = vec3(0.263, 0.416, 0.557);

    return a + b * cos(6.28318 * (c * t + d));
}

//https://www.shadertoy.com/view/mtyGWy
void main() {
    float usepro = progress;
    vec2 uv = textureCoordinate * 2.0 - vec2(1.0);
    vec2 uv0 = uv;
    vec3 finalColor = vec3(0.0);

    for (float i = 0.0; i < 4.0; i++) {
        uv = fract(uv * 1.5) - 0.5;

        float d = length(uv) * exp(-length(uv0));

        vec3 col = palette(length(uv0) + i * .4 + usepro * .4);

        d = sin(d * 8. + usepro) / 8.;
        d = abs(d);

        d = pow(0.01 / d, 1.2);

        finalColor += col * d;
    }
    float maxvaluse = max(finalColor.r, finalColor.g);
    maxvaluse = max(maxvaluse, finalColor.b);
    vec4 color1=vec4(finalColor, 1.0);
    vec4 color2=texture2D(inputImageTexture, textureCoordinate);
    maxvaluse=step(maxvaluse,0.5);
    gl_FragColor = mix(color1,color2,maxvaluse);
}

// RENDER
//void main()
//{
//    vec2 q = textureCoordinate;
//    vec2 pos = -1.0 + 2.0*q;
//    pos.x *= ratio;
////    vec4 res = imageFunction(pos,fragCoord);
//    vec4 color = imageFunction(pos,fragCoord);
//    color = (color+1.0)*0.5;
//    color.w=1.0;
//    gl_FragColor = color;
//}

