// Heartfelt - by Martijn Steinrucken aka BigWings - 2017
// Email:countfrolic@gmail.com Twitter:@The_ArtOfCode
// License Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

// I revisited the rain effect I did for another shader. This one is better in multiple ways:
// 1. The glass gets foggy.
// 2. Drops cut trails in the fog on the glass.
// 3. The amount of rain is adjustable (with Mouse.y)

// To have full control over the rain, uncomment the HAS_HEART define

// A video of the effect can be found here:
// https://www.youtube.com/watch?v=uiF5Tlw22PI&feature=youtu.be

// Music - Alone In The Dark - Vadim Kiselev
// https://soundcloud.com/ahmed-gado-1/sad-piano-alone-in-the-dark
// Rain sounds:
// https://soundcloud.com/elirtmusic/sleeping-sound-rain-and-thunder-1-hours

//https://www.shadertoy.com/view/ltffzl

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
float random2 (in vec2 st) {
    return fract(sin(dot(st.xy,vec2(12.9898,78.233)))* 43758.5453123)-0.5;
}

vec2 myPattern(in vec2 uv){
    vec2 uv2 = uv;
    uv2.y = uv2.y + (random2(uv));
    uv2.x = uv2.x + (random2(uv.yx));
    return uv2 - uv;
}

void main () {
    vec2 uv = textureCoordinate;
    vec2 p = uv;
    for (int i = 0; i < 10; i ++) p -= myPattern(p) * 0.02;
    gl_FragColor = texture2D(inputImageTexture, p);
}
