//https://www.shadertoy.com/view/4scXWB

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;


vec2 iResolution = vec2(1080.0);
void main()
{
    float time = progress / 1000.0;
    vec2 texcoord = textureCoordinate;
    vec4 coloruse = texture2D(inputImageTexture, texcoord);
    vec4 sum = vec4(0.0);
    float blurSize = 1.0 / 1080.0;
    sum += texture2D(inputImageTexture, vec2(texcoord.x, texcoord.y)) * 0.20;

    sum += texture2D(inputImageTexture, vec2(texcoord.x + blurSize, texcoord.y)) * 0.11;
    sum += texture2D(inputImageTexture, vec2(texcoord.x - blurSize, texcoord.y)) * 0.11;
    sum += texture2D(inputImageTexture, vec2(texcoord.x, texcoord.y + blurSize)) * 0.11;
    sum += texture2D(inputImageTexture, vec2(texcoord.x, texcoord.y - blurSize)) * 0.11;

    sum += texture2D(inputImageTexture, vec2(texcoord.x + blurSize, texcoord.y + blurSize)) * 0.07;
    sum += texture2D(inputImageTexture, vec2(texcoord.x + blurSize, texcoord.y - blurSize)) * 0.07;
    sum += texture2D(inputImageTexture, vec2(texcoord.x - blurSize, texcoord.y + blurSize)) * 0.07;
    sum += texture2D(inputImageTexture, vec2(texcoord.x - blurSize, texcoord.y - blurSize)) * 0.07;

    sum += texture2D(inputImageTexture, vec2(texcoord.x + 2.0 * blurSize, texcoord.y)) * 0.02;
    sum += texture2D(inputImageTexture, vec2(texcoord.x - 2.0 * blurSize, texcoord.y)) * 0.02;
    sum += texture2D(inputImageTexture, vec2(texcoord.x, texcoord.y + 2.0 * blurSize)) * 0.02;
    sum += texture2D(inputImageTexture, vec2(texcoord.x, texcoord.y - 2.0 * blurSize)) * 0.02;

    //increase blur with intensity!
    //fragColor = sum*intensity + texture2D(iChannel0, texcoord);
    float value = abs(sin(time));
    gl_FragColor = sum * value + texture2D(inputImageTexture, texcoord);

}

