//https://www.shadertoy.com/view/MsySWh

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;


void main() {
    vec4 waterColor = vec4(1.0);
    float reflactionY = 0.5+params.r*0.5;
    vec2 uv = textureCoordinate;
    float iTime = progress / 100.0;
    if (uv.y > reflactionY)
    {
        float oy = uv.y;
        uv.y = 2.0 * reflactionY - uv.y;
        uv.y = uv.y + sin((oy - reflactionY) * 150.0 + iTime) * 0.004;
        uv.x = uv.x + sin((uv.x)*150.0+iTime)*0.001;
    }
    gl_FragColor = texture2D(inputImageTexture, uv);
}