//https://www.shadertoy.com/view/ldsGDn

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

//#define LIGHT_SNOW // Comment this out for a blizzard
//
//#ifdef LIGHT_SNOW
//	#define LAYERS 50.0
//	#define DEPTH .5
//	#define WIDTH .3
//	#define SPEED .6
//#else // BLIZZARD
//	#define LAYERS 200.0
//	#define DEPTH .1
//	#define WIDTH .8
//	#define SPEED 1.5
//#endif

float LAYERS = 10.0;
float DEPTH = .5;
float WIDTH = .3;
float SPEED = .6;

void main()
{
    const mat3 p = mat3(13.323122, 23.5112, 21.71123, 21.1212, 28.7312, 11.9312, 21.8112, 14.7212, 61.3934);
    vec2 uv = textureCoordinate;
    uv.y=1.0-uv.y;
    if(ratio>1.0){
        uv.x=(uv.x-0.5)*ratio+0.5;
    }else{
        uv.y=(uv.y-0.5)/ratio+0.5;
    }
    float acc = 0.0;
    float iTime = progress / 100.0;
    float dof = 5. * sin(iTime);
    for (float fi = 0.0;fi < LAYERS; fi++) {
        vec2 q = uv * (1. + fi * DEPTH);
        q += vec2(q.y * (WIDTH * mod(fi * 7.238917, 1.) - WIDTH * .5), SPEED * iTime / (1. + fi * DEPTH * .03));
        vec3 n = vec3(floor(q), 31.189 + fi);
        vec3 m = floor(n) * .00001 + fract(n);
        vec3 mp = (31415.9 + m) / fract(p * m);
        vec3 r = fract(mp);
        vec2 s = abs(mod(q, 1.) - .5 + .9 * r.xy - .45);
        s += .01 * abs(2. * fract(10. * q.yx) - 1.);
        float d = .6 * max(s.x - s.y, s.x + s.y) + max(s.x, s.y) - .01;
        float edge = .005 + .05 * min(.5 * abs(fi - 5. - dof), 1.);
        acc += smoothstep(edge, -edge, d) * (r.x / (1. + .02 * fi * DEPTH));
    }
//    vec4 color1=vec4(acc);
    vec4 color2=texture2D(inputImageTexture, textureCoordinate);
    color2.rgb+=vec3(acc);
    gl_FragColor=color2;
//    gl_FragColor=color1.r>0.1?color1:color2;
//    gl_FragColor = mix(color2,color1,color1.r);
}