//https://www.shadertoy.com/view/4scXWB

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;


float flare(vec2 U, float time)                            // rotating hexagon
{    vec2 A = sin(vec2(0.0, 1.57) + time);
     U = abs(U * mat2(A, -A.y, A.x)) * mat2(2.0, 0.0, 1.0, 1.7);
     return .2 / max(U.x, U.y);                      // glowing-spiky approx of step(max,.2)
     //return .2*pow(max(U.x,U.y), -2.);

}

float r(float x) {
    return fract(1e4 * sin((x) * 541.17));     // rand, signed rand   in 1, 2, 3D.
}

vec2 r2(vec2 x) {
    return fract(1e4 * sin((x) * 541.17));     // rand, signed rand   in 1, 2, 3D.
}

vec4 r4(vec4 x) {
    return fract(1e4 * sin((x) * 541.17));     // rand, signed rand   in 1, 2, 3D.
}

vec2 sr2(float x) {
    return r2(vec2(x, x + 0.1)) * 2.0 - 1.0;
}

vec4 sr3(float x) {
    return r4(vec4(x, x + 0.1, x + 0.2, 0.0)) * 2.0 - 1.0;
}

vec4 getscreencolor(vec4 base, vec4 overlay) {
    vec4 one = vec4(1.0);
    vec4 rtn = one - (one - base) * (one - overlay);
    return rtn;
}
vec2 iResolution = vec2(1080.0);
void main()
{
    float time = progress / 300.0;
    vec4 color1 = texture2D(inputImageTexture, textureCoordinate);

    vec2 center = vec2(0.5);
    vec2 pos = textureCoordinate - center;
    vec2 outer = center;
    if (ratio > 1.0) {
        pos.y /= ratio;
    } else {
        pos.x *= ratio;
    }
    pos += center;

    vec2 R = iResolution;
    vec2 U = pos * iResolution;
    vec4 O;
    U = (U + U - R) / R.y;
    O -= O + .3;
    for (float i = 0.0; i < 50.0; i++) {
        O += flare(U - sr2(i) * R / R.y, time)           // rotating flare at random location
        * r(i + 0.2)                          // random scale
        * (1.0 + sin(time + r(i + 0.3) * 6.0)) * 0.1  // time pulse
        * (1.0 + 0.1 * sr3(i + 0.4));               // random color - uncorrelated
        // * (1.+.1*sr3(i));                  // random color - correlated
    }
    gl_FragColor = getscreencolor(color1, O);
}

