precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform lowp float progress;
uniform float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
vec3 getusecolor(vec2 uv) {
    vec4 usecolor = progress < 0.5 ? getFromColor(uv) : getToColor(uv);
    return usecolor.rgb;
}

float getspeedpro(float usepro) {
    return ((cos((usepro + 1.) * 3.14159) / 2.0) + 0.5);
}
vec4 getblur(vec2 uv, float mixvalue) {
    float random = (0.5 - Rand(uv * progress)) * 0.05 * mixvalue;
    float random2 = (0.5 - Rand(uv * progress / 2.0)) * 0.05 * mixvalue;
    uv += vec2(random, random2);
    vec2 size = vec2(mixvalue * 0.02);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    float tol = 0.0;
    lowp vec3 sum = vec3(0.0);
    sum += getusecolor(uv) * 1.0;

    sum += getusecolor(uv + vec2(size.x, size.y));
    sum += getusecolor(uv + vec2(-size.x, size.y));
    sum += getusecolor(uv + vec2(size.x, -size.y));
    sum += getusecolor(uv + vec2(-size.x, -size.y));

    sum += getusecolor(uv + vec2(0.0, -size.y));
    sum += getusecolor(uv + vec2(0.0, size.y));
    sum += getusecolor(uv + vec2(size.x, 0.0));
    sum += getusecolor(uv + vec2(-size.x, 0.0));
    tol += 9.0;

    sum += getusecolor(uv + vec2(0.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x, -size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x * 2.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x, -size.y * 2.0));

    sum += getusecolor(uv + vec2(0.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x, size.y * 2.0));
    sum += getusecolor(uv + vec2(size.x * 2.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x * 2.0, size.y * 2.0));
    sum += getusecolor(uv + vec2(-size.x, size.y * 2.0));

    sum += getusecolor(uv + vec2(size.x * 2.0, size.y));
    sum += getusecolor(uv + vec2(size.x * 2.0, -size.y));
    sum += getusecolor(uv + vec2(size.x * 2.0, 0.0));

    sum += getusecolor(uv + vec2(-size.x * 2.0, size.y));
    sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y));
    sum += getusecolor(uv + vec2(-size.x * 2.0, 0.0));
    tol += 16.0;
    return vec4(sum / tol, 1.0);
}

vec4 getExposure(vec4 textureColor, float pro) {
    return vec4(textureColor.rgb * pow(2.0, pro), textureColor.a);// rgb * 2^效果值
}

/// Screen 滤色 1   C=255-(A反相×B反相)/255
vec4 getscreencolor(vec4 base, vec4 overlay) {
    vec4 one = vec4(1.0);
    vec4 rtn = one - (one - base) * (one - overlay);
    return rtn;
}



void main() {

    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float pro = getspeedpro(progress);

    float scale = pro < 0.5 ? pro : pro - 0.5;
    //    曝光
    float exposure = 0.0;
    float exposureprogress = scale * 2.0 * 30.0;
    if (exposureprogress < 4.0) {
        exposure = 0.0;
    } else if (exposureprogress < 8.0) {
        exposure = 0.4 * (exposureprogress - 4.0) / 4.0;
    } else if (exposureprogress < 12.0) {
        exposure = 0.4 * (12.0-exposureprogress) / 4.0;
    } else if (exposureprogress < 16.0) {
        exposure = 1.0 * (exposureprogress - 12.0) / 4.0;
    } else if (exposureprogress < 21.0) {
        exposure = 1.0 * (21.0-exposureprogress) / 5.0;
    }else if (exposureprogress < 25.0) {
        exposure = 0.0;
    } else if (exposureprogress < 26.0) {
        exposure = 0.24 * (exposureprogress - 25.0);
    } else if (exposureprogress < 27.0) {
        exposure = 0.24 * (27.0-exposureprogress);
    }

    scale = scale < 0.25 ? scale : 0.5 - scale;
    float mixvalue = scale / 2.0;

    scale *= 0.2;
    scale = 1.0 - scale;
    vec2 center = vec2(0.5);
    uv = center + (uv - center) * scale;

    //    毛玻璃->曝光->screen
    vec4 usecolor = getblur(uv, mixvalue);
    usecolor = getExposure(usecolor, exposure);

    vec2 pos = textureCoordinate;
    float ratio2 = 9.0 / 16.0;
    if (ratio > ratio2) {
        pos.y = 0.5 + (pos.y - 0.5) / ratio * ratio2;
    } else {
        pos.x = 0.5 + (pos.x - 0.5) * ratio / ratio2;
    }
    vec4 screencolor = texture2D(inputImageTexture3, pos);
    usecolor = getscreencolor(usecolor, screencolor);
    gl_FragColor = usecolor;
}
