precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float progress;
uniform float ratio;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    vec4 color1 = progress<=0.5?getFromColor(textureCoordinate):getToColor(textureCoordinate);

    vec2 pos = textureCoordinate;

    float useratio=ratio;
//    if(useratio>1.0){
//        useratio=1.0/useratio;
//        pos=pos.yx;
//    }
    float ratio2=9.0/16.0;
    if(useratio>ratio2){
        pos.y=0.5+(pos.y-0.5)/useratio*ratio2;
    }else{
        pos.x=0.5+(pos.x-0.5)*useratio/ratio2;
    }
    pos.x /= 2.0;
    vec4 color2 = texture2D(inputImageTexture3, pos);
    pos.x += 0.5;
    vec4 colormix = texture2D(inputImageTexture3, pos);

    vec4 coloruse = mix(color1, color2, colormix);
    gl_FragColor = coloruse;

}
