precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float progress;
uniform float ratio;

/// Screen 滤色 1   C=255-(A反相×B反相)/255
vec4 getscreencolor(vec4 base, vec4 overlay) {
    vec4 one = vec4(1.0);
    vec4 rtn = one - (one - base) * (one - overlay);
    return rtn;
}

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    vec4 color1 = getFromColor(textureCoordinate);
    vec4 color2 = getToColor(textureCoordinate);

    vec2 pos = textureCoordinate;

    float ratio2=9.0/16.0;
    if(ratio>ratio2){
        pos.y=0.5+(pos.y-0.5)/ratio*ratio2;
    }else{
        pos.x=0.5+(pos.x-0.5)*ratio/ratio2;
    }
    pos.x /= 2.0;
    vec4 colorscreen = texture2D(inputImageTexture3, pos);
    pos.x += 0.5;
    vec4 colormix = texture2D(inputImageTexture3, pos);

    vec4 coloruse = mix(color1, color2, colormix);
    coloruse = getscreencolor(coloruse, colorscreen);
    gl_FragColor = coloruse;

}
