/// 饱和度滤镜.fsh

/// 把各个分量按照各自的权重相加
// float = dot(mask, W); //mask.r*W.x + mask.g*W.y + mask.b*W.z;

/// 对vec3x和vec3y进行混合。
// vec3 = mix(vec3x, vec3y, a); //vec3x*(1−a) + vec3y*a

precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform lowp float Time;

// Values from "Graphics Shaders: Theory and Practice" by Bailey and Cunningham
const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);

float saturation = 2.0;
void main()
{
    saturation = Time;

    // 和自身的亮度混合
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    lowp float luminance = dot(textureColor.rgb, luminanceWeighting);
    lowp vec3 greyScaleColor = vec3(luminance);
    gl_FragColor = vec4(mix(greyScaleColor, textureColor.rgb, saturation), textureColor.w);

}