/// 马赛克滤镜.fsh

precision highp float;
//纹理采样器
uniform sampler2D inputImageTexture;
//纹理坐标
varying vec2 textureCoordinate;
//时间撮
uniform float Time;

//纹理图片size
const vec2 TextSize = vec2(600.0, 600.0);
//马赛克size
const vec2 mosaicSize = vec2(16.0, 16.0);

void main()
{
    //计算实际图像位置
    vec2 intXY = vec2(textureCoordinate.x * TextSize.x, textureCoordinate.y * TextSize.y);
    //floor(x) 内键函数，返回小于/等于x的最大整数值
    vec2 XYMosaic = vec2(floor(intXY.x/mosaicSize.x)*mosaicSize.x, floor(intXY.y/mosaicSize.y)*mosaicSize.y);
    //换算回纹理坐标
    vec2 UVMosaic = vec2(XYMosaic.x/TextSize.x, XYMosaic.y/TextSize.y);
    //获取马赛克后的纹理坐标的颜色值
    vec4 color = texture2D(inputImageTexture, UVMosaic);
    //将马赛克颜色值赋值给gl_FragColor
    gl_FragColor = color;
}