/// 灰度滤镜.fsh

precision highp float;
//纹理采样器
uniform sampler2D inputImageTexture;
//纹理坐标
varying vec2 textureCoordinate;
//时间撮
uniform float Time;


/*
/// 直接取绿色作为亮度
void main()
{
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = vec4(mask.g, mask.g, mask.g, 1.0);
}*/


/// rgb按照权重，合成亮度
const highp vec3 W = vec3(0.2125, 0.7154, 0.0721); // vec3(0.3, 0.59, 0.11); //
void main()
{
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);
    float luminance = dot(mask.rgb, W); //mask.r*W.x + mask.g*W.y + mask.b*W.z;
    gl_FragColor = vec4(vec3(luminance), 1.0);
}

/*
/// 绿色滤镜
const highp vec3 W = vec3(0.4, 1.0, 0.4);
void main()
{
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);

    float r = mask.r * W.x;
    float g = mask.g * W.y;
    float b = mask.b * W.z;

    gl_FragColor = vec4(vec3(r,g,b), 1.0);
}*/

/*
/// 红色滤镜
const highp vec3 W = vec3(1.0, 0.4, 0.4);
void main()
{
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);

    float r = mask.r * W.x;
    float g = mask.g * W.y;
    float b = mask.b * W.z;

    gl_FragColor = vec4(vec3(r,g,b), 1.0);
}*/

/*
/// 蓝色滤镜
const highp vec3 W = vec3(0.4, 0.4, 1.0);
void main()
{
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);

    float r = mask.r * W.x;
    float g = mask.g * W.y;
    float b = mask.b * W.z;

    gl_FragColor = vec4(vec3(r,g,b), 1.0);
}
*/