/// 浮雕滤镜.fsh

precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
const highp vec3 W = vec3(0.2125, 0.7154, 0.0721);
const vec2 TexSize = vec2(100.0, 100.0);
const vec4 bkColor = vec4(0.5, 0.5, 0.5, 1.0);

void main()
{
    vec2 upLeftUV = vec2(textureCoordinate.x-1.0/TexSize.x, textureCoordinate.y-1.0/TexSize.y);
    vec4 curColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 upLeftColor = texture2D(inputImageTexture, upLeftUV);
    vec4 delColor = curColor - upLeftColor;
    float luminance = dot(delColor.rgb, W);
    gl_FragColor = vec4(vec3(luminance), 0.0) + bkColor;
}