// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


/**
float inHeart(vec2 p, vec2 center, float size) {
    if (size == 0.0) return 0.0;
    p.y = 1. - p.y;
    //        if(size<0.1&&distance(p,center)>0.1)return 0.0;

    vec2 change = (p - center) * 0.9;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    p = center + change;
    float cha = (ratio < 1. ? ratio : 1. / ratio);
    //        float showmax=1.6*cha*cha;
    float showmax = 1.6;
    vec2 o = (p - center) / (showmax * size);
    float a = o.x * o.x + o.y * o.y - 0.3;
    return step(a * a * a, o.x * o.x * o.y * o.y * o.y);

}

float inHeart2 (vec2 p, vec2 center, float size) {
    if (size==0.0) return 0.0;
    p.y=1.-p.y;
    //        if(size<0.1&&distance(p,center)>0.1)return 0.0;

    vec2 change=(p-center);
    if(ratio>1.){
        change.y=change.y/ratio;
    }else{
        change.x=change.x*ratio;
    }

    float value = pow(length(change)-0.2,3.);
    float d = value - pow(change.x,2.)*pow(change.y,3.);
    return d > 0.? 1.0: 0.0;
}
*/

float inHeart3(vec2 p, vec2 center, float size) {
    center.y+=0.25;
    p.y = 1. - p.y-size/10.0;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    change/=size;
    float x = change.x;
    if(abs(x)<=2.1){
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}


void main() {

    gl_FragColor = mix(
        getFromColor(textureCoordinate),
        getToColor(textureCoordinate),
        inHeart3(textureCoordinate, vec2(0.5, 0.45), progress)
    );
}
