// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float inHeart(vec2 p, vec2 center, float size,float roate) {
    if (size == 0.0) return 0.0;
    center.y+=0.25;
    p.y = 1. - p.y-size/10.0;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx = change.x*c+change.y*s;
    float dy = -change.x*s+change.y*c;
    change.x=dx;
    change.y=dy;
    change/=size;
    float x = change.x;
    if(abs(x)<=2.1){
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}

float startsize = 0.15;
float check(float cx, float usepro,float pos) {
    //    <1 中心点上升旋转
    float cy = usepro > 1.0 ? 0.6 : 1.6 - usepro;
    float roate = usepro > 1.0 ? 0.0 : 3.14159 * (1.0 - usepro);
    //    roate = 0.0;
    //    >1 开始放大
    float scale = usepro < 1.0 ? 0.0 :(sqrt((usepro - 1.0)/2.3)*2.3) * (1.0+pos*0.2);
    scale=pow(scale,2.0)+1.0;
    vec2 center = vec2(cx, 1.0-cy);
    vec2 usepos;
    usepos = textureCoordinate;
    float isin = inHeart(usepos, center, 0.12 * scale,roate);
    return isin;
}
void main() {
    float size = 0.3;
    float usepro = progress / size;
    float startx = 0.15;
    float off = 0.0;
    for (float i = 0.0;i < 3.0; i++) {
        float cx = startx + i * (0.5 - startx);
        if (progress > off) {
            usepro = (progress - off) / size;
            float isin = check(cx, usepro,i);
            if (isin >= 1.0) {
                gl_FragColor = getToColor(textureCoordinate);
                return;
            }
        }
        off += 0.15;
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
