// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float inHeart(vec2 p, vec2 center, float size) {
    if (size == 0.0) return 0.0;
    center.y+=0.05;
    p.y = 1. - p.y-size/10.0;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    change/=size;
    float x = change.x;
    if(abs(x)<=2.1){
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}

void main() {
    float cx;
    float cy;
    float usepro;
    for (float i = 0.0;i < 12.0; i++) {
        usepro = progress - i / 24.0;
        if(usepro<=0.0){
            continue;
        }
        float pos=i/4.0;
//        小数点前的部分
        float head=pos-mod(pos,1.0);
//        小数点的部分
        float end=mod(pos,1.0);
        cx=0.125+end;
        cy=0.15+(head)*0.4;
        vec2 center = vec2(cx, 1.0-cy);
        float isin = inHeart(textureCoordinate, center, usepro*usepro);
        if (isin >= 1.0) {
            gl_FragColor = getToColor(textureCoordinate);
            return;
        }
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
