// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float Rand(float value) {
    return fract(sin(dot(vec2(value), vec2(12.9898, 78.233))) * 43758.5453);
}


float inHeart(vec2 p, vec2 center, float size) {
    if (size <= 0.0) return 0.0;
    p.y = 1. - p.y;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    change /= size;
    float x = change.x;
    if (abs(x) <= 2.1) {
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}

float usepro;
void main() {
    float oncetime = 0.4;
    vec2 center = vec2(0.5, 0.45);

    float isin;
    //    这个参数设置最远位移多远
    float offsize;
    //    缩放大小
    float maxsize;
    //    这两个参数确定方向
    float offx;
    float offy;
    vec2 offinfo;
    float num = 20.0;
    float startpos = max(floor((progress - oncetime) / 0.75 * num), 1.0);
    for (float i = startpos;i < 21.0; i++) {
        float startprogress = i * 0.75 / num;
        if (startprogress >= progress) {
            break;
        }
        usepro = (progress - startprogress) / oncetime;
        usepro = min(usepro, 1.0);
        usepro = sqrt(usepro);

        maxsize = Rand(i * 1.2);
        maxsize = 0.03 + maxsize * 0.15;
        offx = 0.5 - Rand(maxsize);
        offy = 0.5 - Rand(offx);
        float scale = 0.75 / length(vec2(offx, offy));
        scale *= (1.0 + Rand(scale) / 5.0);
        offx *= scale;
        offy *= scale;
        float modvalue = mod(i, 4.0);
        //        符号
        float xx = (modvalue == 1.0 || modvalue == 2.0) ? 1.0 : -1.0;
        float yy = (modvalue == 0.0 || modvalue == 1.0) ? 1.0 : -1.0;
        offx = abs(offx) * xx;
        offy = abs(offy) * yy;

        offinfo.x = center.x + offx * usepro;
        offinfo.y = center.y + offy * usepro;


        usepro = sqrt(usepro);
        isin = inHeart(textureCoordinate, offinfo, maxsize * usepro);
        if (isin >= 1.0) {
            gl_FragColor = getToColor(textureCoordinate);
            return;
        }
    }

    usepro = sin((progress - 0.75) * 4.0 * 1.57);
    isin = progress > 0.75 ? inHeart(textureCoordinate, vec2(0.5, 0.5 + usepro * 0.3), usepro) : 0.0;
    gl_FragColor = mix(
        getFromColor(textureCoordinate),
        getToColor(textureCoordinate),
        isin
    );

}
