// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float inHeart(vec2 p, vec2 center, float size, float roate) {
    if (size <= 0.0) return 0.0;
    p.y = 1. - p.y;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx = change.x * c + change.y * s;
    float dy = -change.x * s + change.y * c;
    change.x = dx;
    change.y = dy;
    change /= size;
    float x = change.x;
    if (abs(x) <= 2.1) {
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}

float startsize = 0.15;
vec2 pos1x = vec2(0.4, 0.2);
vec2 pos1y = vec2(-0.01, 1.5);
vec2 pos1scale = vec2(0.02, 0.3);
float pos1roate = -0.1;

vec2 pos2x = vec2(-0.6, 0.6);
vec2 pos2y = vec2(-1., 0.85);
vec2 pos2scale = vec2(-0.3, 1.0);
float pos2roate = -0.2;

vec2 pos3x = vec2(1.2, 0.6);
vec2 pos3y = vec2(-2.0, 1.0);
vec2 pos3scale = vec2(-0.3, 1.0);
float pos3roate = 0.25;
float usepro;

vec3 getinfo(vec2 xinfo, vec2 yinfo, vec2 scaleinfo) {
    float cx = xinfo.x + (xinfo.y - xinfo.x) * usepro;
    float cy = yinfo.x + (yinfo.y - yinfo.x) * usepro;
    float s = scaleinfo.x + (scaleinfo.y - scaleinfo.x) * usepro;
    return vec3(cx, cy, s);
}
void main() {
    usepro = progress * progress;
    vec3 info = getinfo(pos1x, pos1y, pos1scale);
    pos1roate+=usepro/5.0;
    float isin = inHeart(textureCoordinate, info.xy, info.z, pos1roate);
    if (isin >= 1.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }

    info = getinfo(pos2x, pos2y, pos2scale);
    isin = inHeart(textureCoordinate, info.xy, info.z, pos2roate);
    if (isin >= 1.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }

    info = getinfo(pos3x, pos3y, pos3scale);
    isin = inHeart(textureCoordinate, info.xy, info.z, pos3roate);
    if (isin >= 1.0) {
        gl_FragColor = getToColor(textureCoordinate);
        return;
    }

    gl_FragColor = getFromColor(textureCoordinate);
}
