// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float inHeart(vec2 p, vec2 center, float size, float roate) {
    if (size <= 0.0) return 0.0;
    p.y = 1. - p.y;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx = change.x * c + change.y * s;
    float dy = -change.x * s + change.y * c;
    change.x = dx;
    change.y = dy;
    change /= size;
    float x = change.x;
    if (abs(x) <= 2.1) {
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}
vec2 pos0 = vec2(0.8, 0.8);
vec4 info0 = vec4(-0.05, 0.2, -0.5, -0.1);

vec2 pos1 = vec2(0.05, 0.94);
vec4 info1 = vec4(0.0, 0.5, -0.4, 0.1);

vec2 pos2 = vec2(0.1, 0.15);
vec4 info2 = vec4(-0.12, 0.6, 0.4, 0.5);

vec2 pos3 = vec2(-0.1, 0.45);
vec4 info3 = vec4(0.0, 0.35, 0.3, 0.5);

vec2 pos4 = vec2(0.6, 0.7);
vec4 info4 = vec4(0.0, 0.1, 0.4, 0.3);


vec2 pos5 = vec2(0.95, 0.7);
vec4 info5 = vec4(0.0, 0.4, 0.0, 0.23);

vec2 pos6 = vec2(0.8, 0.2);
vec4 info6 = vec4(-0.1, 0.6, -0.4, -0.5);

vec2 pos7 = vec2(0.5, 0.3);
vec4 info7 = vec4(-0.05, 0.4, 0.0, 0.05);

vec2 pos8 = vec2(0.6, 0.9);
vec4 info8 = vec4(0.0, 0.35, 0.3, 0.3);

vec2 pos9 = vec2(0.3, 0.5);
vec4 info9 = vec4(0.0, 0.35, -0.5, -0.4);


vec2 pos10 = vec2(0.9, 0.9);
vec4 info10 = vec4(-0.05, 0.15, 0.4, 0.2);

vec2 pos11 = vec2(0.45, 0.06);
vec4 info11 = vec4(-0.05, 0.2, 0.1, 0.2);

vec2 pos12 = vec2(0.7, 0.5);
vec4 info12 = vec4(-0.05, 0.25, -0.3, 0.2);

vec2 pos13 = vec2(0.38, 0.75);
vec4 info13 = vec4(-0.03, 0.35, 0.5, 1);

//中心点
vec2 poss[14];
//前两位心的比例，后面是旋转
vec4 infos[14];
float usepro;

float getinfo(vec4 info, vec2 pos) {
    float s = info.x + (info.y - info.x) * usepro;
    float r = info.b + (info.a - info.b) * usepro;
    return inHeart(textureCoordinate, pos, s, r);
}
void main() {
    usepro = progress * progress;
    poss[0] = pos0;     infos[0] = info0;
    poss[1] = pos1;     infos[1] = info1;
    poss[2] = pos2;     infos[2] = info2;
    poss[3] = pos3;     infos[3] = info3;
    poss[4] = pos4;     infos[4] = info4;
    poss[5] = pos5;     infos[5] = info5;
    poss[6] = pos6;     infos[6] = info6;
    poss[7] = pos7;     infos[7] = info7;
    poss[8] = pos8;     infos[8] = info8;
    poss[9] = pos9;     infos[9] = info9;
    poss[10] = pos10;   infos[10] = info10;
    poss[11] = pos11;   infos[11] = info11;
    poss[12] = pos12;   infos[12] = info12;
    poss[13] = pos13;   infos[13] = info13;

    for (int i = 0;i < 14; i++) {
        float isin = getinfo(infos[i], poss[i]);
        if (isin >= 1.0) {
            gl_FragColor = getToColor(textureCoordinate);
            return;
        }
    }

    gl_FragColor = getFromColor(textureCoordinate);
}
