// 5-9
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float inHeart(vec2 p, vec2 center, float size, float roate) {
    if (size <= 0.0) return 0.0;
    p.y = 1. - p.y;
    vec2 change = (p - center) * 2.0;
    if (ratio > 1.) {
        change.y = change.y / ratio;
    } else {
        change.x = change.x * ratio;
    }
    float c = cos(roate);
    float s = sin(roate);
    float dx = change.x * c + change.y * s;
    float dy = -change.x * s + change.y * c;
    change.x = dx;
    change.y = dy;
    change /= size;
    float x = change.x;
    if (abs(x) <= 2.1) {
        float y = change.y;
        bool isin = y < sqrt((1.2 - pow(abs(x) - 1.0, 2.0)))
        && y > -2.6 * sqrt(1.048 - 0.5 * abs(x));
        return isin ? 1.0 : 0.0;
    }return 0.0;
}
vec4 pos0 = vec4(-0.1, 0.75, 0.05, 0.3);
vec4 info0 = vec4(-0.2, 0.35, -1.2, 0.0);

vec4 pos1 = vec4(0.7, 0.2, 0.7, 0.15);
vec4 info1 = vec4(-0.15, 0.35, -0.8, 0.6);

vec4 pos2 = vec4(1.2, 0.4, 1.0, 0.3);
vec4 info2 = vec4(-0.2, 0.25, -0.8, 2.0);

vec4 pos3 = vec4(0.9, 0.5, -0.3, 0.7);
vec4 info3 = vec4(0.0, 0.25, -0.5, 0.95);

vec4 pos4 = vec4(-0.8, 0.45, 1.8, -0.0);
vec4 info4 = vec4(-0.2, 0.3, -0.75, -1.5);

vec4 pos5 = vec4(1.6, 0.8, -1.5, 1.0);
vec4 info5 = vec4(0.0, 0.6, 1.0, -0.2);

vec4 pos6 = vec4(-1.7, 0.15, -2.9, 0.9);
vec4 info6 = vec4(-1.2, 0.6, -1.2, 0.1);


vec4 poss[7];
vec4 infos[7];
float usepro;

float getinfo(vec4 info, vec4 pos) {
    float s = info.x + (info.y - info.x) * usepro;
    float r = info.b + (info.a - info.b) * usepro;
    float x = pos.x + (pos.y - pos.x) * usepro;
    float y = pos.b + (pos.a - pos.b) * usepro;
    return inHeart(textureCoordinate, vec2(x, y), s, r);
}
void main() {
    usepro = sqrt(progress);
    poss[0] = pos0;     infos[0] = info0;
    poss[1] = pos1;     infos[1] = info1;
    poss[2] = pos2;     infos[2] = info2;
    poss[3] = pos3;     infos[3] = info3;
    poss[4] = pos4;     infos[4] = info4;
    poss[5] = pos5;     infos[5] = info5;
    poss[6] = pos6;     infos[6] = info6;

    for (int i = 0;i < 7; i++) {
        float isin = getinfo(infos[i], poss[i]);
        if (isin >= 1.0) {
            gl_FragColor = getToColor(textureCoordinate);
            return;
        }
    }

    gl_FragColor = getFromColor(textureCoordinate);
}
