// 3-6
// https://gl-transitions.com/editor/Mosaic
#define PI 3.14159265359
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float tranx;// = 2
uniform float trany;// = -1

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
vec2 Rotate(vec2 v, float a) {
    mat2 rm = mat2(cos(a), -sin(a),
                   sin(a), cos(a));
    return rm * v;
}
float CosInterpolation(float x) {
    return -cos(x * PI) / 2. + .5;
}
void main() {
    vec2 p = textureCoordinate.xy - .5;
    vec2 rp = p;
    float rpr = (progress * 2. - 1.);
    float z = -(rpr * rpr * 2.) + 3.;
    float az = abs(z);
    rp *= az;
    rp += mix(vec2(.5, .5), vec2(tranx + .5, trany + .5),
              CosInterpolation(progress) * CosInterpolation(progress));
    vec2 mrp = mod(rp, 1.);
    vec2 crp = rp;
    bool onEnd = floor(crp.x) == tranx && floor(crp.y) == trany;
    if (!onEnd) {
        float ang = float(int(Rand(floor(crp)) * 4.)) * PI;
        mrp = vec2(.5) + Rotate(mrp - vec2(.5), ang);
    }
    if (onEnd || Rand(floor(crp)) > .5) {
        gl_FragColor = getToColor(mrp);
        return;
    } else {
        gl_FragColor = getFromColor(mrp);
        return;
    }
}
