// 4-4
// https://gl-transitions.com/editor/DreamyZoom
#define DEG2RAD 0.0392699081// 1/180*PI
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
// In degrees
//uniform float rotation;// = 6
float rotation = 3.0;

// Multiplier
//uniform float scale;// = 1.2
float scale = 1.2;

uniform float ratio;// 视图宽高比


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}



vec2 doroate(vec2 c2,float roate){
    //计算旋转角度
    vec2 uv2  =c2-0.5;
    if(ratio>1.0){
        uv2.x=uv2.x*ratio;
    }else{
        uv2.y=uv2.y/ratio;
    }
    float dx2 = uv2.x*cos(roate)+uv2.y*sin(roate);
    float dy2 = -uv2.x*sin(roate)+uv2.y*cos(roate);
    if(ratio>1.0){
        dx2=dx2/ratio;
    }else{
        dy2=dy2*ratio;
    }
    vec2 rtn=vec2(0.5+dx2,0.5+dy2);
    return rtn;
}

void main() {
    // Massage parameters

//    白化程度 progress 0-0.5 phase0-1  progress 0.5-1 phase0-1
    float phase = progress < 0.5 ? progress * 2.0 : (progress - 0.5) * 2.0;

//    角度偏移 应该是弧度转角度
    float angleOffset = progress < 0.5 ? mix(0.0, rotation , phase)
                    : mix(-rotation , 0.0, phase);
//  当前的比例
    float newScale = progress < 0.5 ? mix(1.0, scale, phase) : mix(scale, 1.0, phase);

    vec2 center = vec2(0., 0.);

    // Calculate the source point
    vec2 assumedCenter = vec2(0.5, 0.5);
    vec2 p= (textureCoordinate.xy - assumedCenter) / newScale;
    p+=assumedCenter;
    p=doroate(p,angleOffset);

    vec4 c = progress < 0.5 ? getFromColor(p) : getToColor(p);

    // Finally, apply the color
    gl_FragColor=c + (progress < 0.5 ? mix(0.0, 1.0, phase) : mix(1.0, 0.0, phase));
}
