// 4-6
// https://gl-transitions.com/editor/ripple
precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
//uniform float amplitude; // = 100.0
//uniform float speed; // = 50.0
float amplitude = 100.0;
float speed = 50.0;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


void main() {
    vec2 dir = textureCoordinate - vec2(.5);
    float dist = length(dir);
    vec2 offset = dir * (sin(progress * dist * amplitude - progress * speed) + .5) / 30.;
    gl_FragColor= mix(
    getFromColor(textureCoordinate + offset),
    getToColor(textureCoordinate),
    smoothstep(0.2, 1.0, progress)
    );
}
