// 5-2
// https://gl-transitions.com/editor/cube
precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
// Author: gre
// License: MIT
//uniform float persp;// 透视= 左侧图片错切缩小程度0.7
//uniform float unzoom;// 缩放程度= 0.3
//uniform float reflection;// 底部的倒影= 0.4
//uniform float floating;// 与底部倒影的距离 ,有一种漂浮的感觉= 3.0
float persp = 0.7;
float unzoom = 0.3;
float reflection = 0.4;
float floating = 3.0;
/*
vec2 project (vec2 p) {
    return p * vec2(1.0, -1.2) + vec2(0.0, -floating/100.);
}
*/
vec2 project (vec2 p) {
    vec2 rtn= p * vec2(1.0, (1.0-floating/100.)) ;
    rtn.y=2.-rtn.y;
    return rtn;
}

bool inBounds (vec2 p) {
    return all(lessThan(vec2(0.0), p)) && all(lessThan(p, vec2(1.0)));
}

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


vec4 bgColor (vec2 p, vec2 pfr, vec2 pto) {
    vec4 c = vec4(0.0, 0.0, 0.0, 1.0);
    pfr = project(pfr);
    // FIXME avoid branching might help perf!
    if (inBounds(pfr)) {
        c += mix(vec4(0.0), getFromColor(pfr), reflection * mix(0.0, 1.0, pfr.y));
    }
    pto = project(pto);
    if (inBounds(pto)) {
        c += mix(vec4(0.0), getToColor(pto), reflection * mix(0.0, 1.0, pto.y));
    }
    return c;
}


// p : the position
// persp : the perspective in [ 0, 1 ]
// center : the xcenter in [0, 1] \ 0.5 excluded
vec2 xskew (vec2 p, float persp, float center) {
    float x = mix(p.x, 1.0-p.x, center);
    return (
    (
    vec2(x, (p.y - 0.5*(1.0-persp) * x) / (1.0+(persp-1.0)*x))
    - vec2(0.5-distance(center, 0.5), 0.0)
    )
    * vec2(0.5 / distance(center, 0.5) * (center<0.5 ? 1.0 : -1.0), 1.0)
    + vec2(center<0.5 ? 0.0 : 1.0, 0.0)
    );
}


void main() {
    float newProgress = 1.0-progress;
    float uz = unzoom * 2.0*(0.5-distance(newProgress, 0.5));
    vec2 p = -uz*0.5+(1.0+uz) * textureCoordinate;
    vec2 fromP = xskew(
    (p - vec2(newProgress, 0.0)) / vec2(1.0-newProgress, 1.0),
    1.0-mix(newProgress, 0.0, persp),
    0.0
    );
    vec2 toP = xskew(
    p / vec2(newProgress, 1.0),
    mix(pow(newProgress, 2.0), 1.0, persp),
    1.0
    );
    // FIXME avoid branching might help perf!
    if (inBounds(fromP)) {
        gl_FragColor= getToColor(fromP);
    }
    else if (inBounds(toP)) {
        gl_FragColor= getFromColor(toP);
    }else{
    gl_FragColor= bgColor(textureCoordinate, toP, fromP);
    }
}
