// 5-4
// https://gl-transitions.com/editor/doorway
precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
// Author: gre
// License: MIT
// uniform float reflection;// 中间底部倒影的反射清 晰度= 0.4
// uniform float perspective;// 切开图片中间部位的错切程度 透视= 0.4
// uniform float depth;// 中间出现图片的原始缩放程度 1/depth 深度= 3

float reflection = 0.4;
float perspective = 0.4;
float depth = 3.0;

const vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
const vec2 boundMin = vec2(0.0, 0.0);
const vec2 boundMax = vec2(1.0, 1.0);

bool inBounds (vec2 p) {
    return all(lessThan(boundMin, p)) && all(lessThan(p, boundMax));
}

//vec2 project (vec2 p) {
//    return p * vec2(1.0, -1.2) + vec2(0.0, -0.02);
//}

vec2 project (vec2 p) {
    vec2 rtn= p * vec2(1.0, (1.0-depth/100.)) ;
    rtn.y=2.-rtn.y;
    return rtn;
}

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


vec4 bgColor (vec2 p, vec2 pto) {
    vec4 c = black;
    pto = project(pto);
    if (inBounds(pto)) {
        c += mix(black, getToColor(pto), reflection * mix(0.0, 1.0, pto.y));
    }
    return c;
}


void main() {
    vec2 pfr = vec2(-1.), pto = vec2(-1.);
    float middleSlit = 2.0 * abs(textureCoordinate.x-0.5) - progress;
    if (middleSlit > 0.0) {
        pfr = textureCoordinate + (textureCoordinate.x > 0.5 ? -1.0 : 1.0) * vec2(0.5*progress, 0.0);
        float d = 1.0/(1.0+perspective*progress*(1.0-middleSlit));
        pfr.y -= d/2.;
        pfr.y *= d;
        pfr.y += d/2.;
    }
    float size = mix(1.0, depth, 1.-progress);
    pto = (textureCoordinate + vec2(-0.5, -0.5)) * vec2(size, size) + vec2(0.5, 0.5);
    if (inBounds(pfr)) {
        gl_FragColor= getFromColor(pfr);
    }
    else if (inBounds(pto)) {
        gl_FragColor= getToColor(pto);
    }
    else {
        gl_FragColor= bgColor(textureCoordinate, pto);
    }
}
