// 3-6
// https://gl-transitions.com/editor/Mosaic
#define PI 3.14159265359
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform vec4 tranx;// = 2

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


vec4 getcolor(vec2 pos, bool isborder) {
    bool usefrom = false;
    if (isborder) {
        if (pos.x <= 0.0 && pos.x >= -1.0) {
            if (pos.y <= 0.0 && pos.y >= -1.0) {
                usefrom = true;
            } else if (pos.y <= 2.0 && pos.y >= 1.0) {
                usefrom = true;
            }
        }
        if (pos.x <= 2.0 && pos.x >= 1.0) {
            if (pos.y <= 0.0 && pos.y >= -1.0) {
                usefrom = true;
            } else if (pos.y <= 2.0 && pos.y >= 1.0) {
                usefrom = true;
            }
        }
        usefrom = false;
    } else {
        usefrom = !(pos.x > 1.0 || pos.x < 0.0 || pos.y > 1.0 || pos.y < 0.0);
    }
    pos.x = fract(pos.x);
    pos.y = fract(pos.y);
    if (abs(pos.x - 0.5) > 0.5 - progress || abs(pos.y - 0.5) > 0.5 - progress) {
        return vec4(1.0);
    }
    return usefrom ? getFromColor(pos) : getToColor(pos);
}


void main() {
    vec2 center = vec2(0.5);
    float scale = tranx.g;
    float offcenter = tranx.b;
    float offborder = tranx.a;
    vec2 p = textureCoordinate.xy - center;
    p /= scale;
    vec2 useoff = vec2(0.0);
    bool isborder;
    if (tranx.r > 0.0) {
        isborder = abs(p.y) > 0.5;
        useoff.x = isborder ? offborder : offcenter;
    } else {
        isborder = abs(p.x) > 0.5;
        useoff.y = isborder ? offborder : offcenter;
    }
    p += center;
    p += useoff;
    gl_FragColor = getcolor(p, isborder);
}
