precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float progress;

uniform float ratio;
uniform float ratiovideo;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


void main()
{

    vec2 texCoord = textureCoordinate.xy / vec2(1.0);
    float ratio2;
    bool change=false;
    if (ratio >= 1.0 && ratiovideo >= 1.0 || ratio <= 1.0 && ratiovideo <= 1.0) {
        ratio2 = ratiovideo;
    } else {
        ratio2 = 1.0 / ratiovideo;
        change=true;
    }

    float scale = ratio2 / ratio;
    if (scale < 1.0) {
        texCoord.y = 0.5 + (texCoord.y - 0.5) * scale;
    } else {
        texCoord.x = 0.5 + (texCoord.x - 0.5) / scale;
    }
    if(change){
        texCoord = texCoord.yx;
    }
    vec4 textureColor2 = texture2D(inputImageTexture3, texCoord);




    vec4 textureColor = progress <= 0.5 ?
    texture2D(inputImageTexture, textureCoordinate) :
    texture2D(inputImageTexture2, textureCoordinate);

    mediump vec4 whiteColor = vec4(1.0);
    lowp vec4 textureColor3 = whiteColor - ((whiteColor - textureColor2) * (whiteColor - textureColor));
    gl_FragColor = textureColor3;
}
