precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float progress;
uniform float ratio;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0);
    if (progress > 0.98) {
        gl_FragColor = texture2D(inputImageTexture2, texCoord);
        return;
    }
    if (progress < 0.02) {
        gl_FragColor = texture2D(inputImageTexture, texCoord);
        return;
    }
//    if (texCoord.y > 0.9) {
//        gl_FragColor = vec4(1.0);
//        return;
//    }
    //    if(texCoord.y>0.8){
    //        gl_FragColor=texture2D(inputImageTexture3, texCoord);
    //        return;
    //    }

    vec2 pos = texCoord;
    float useratio = ratio;
    if (useratio > 1.0) {
        useratio = 1.0 / useratio;
        pos = pos.yx;
    }
    float ratio2 = 9.0 / 16.0;
    if (useratio > ratio2) {
        pos.y = 0.5 + (pos.y - 0.5) / useratio * ratio2;
    } else {
        pos.x = 0.5 + (pos.x - 0.5) * useratio / ratio2;
    }

    //    gl_FragColor=progress<0.5?getToColor(texCoord):getFromColor(texCoord);
    //    gl_FragColor+=cadd;

    //    gl_FragColor=getFromColor(texCoord)*0.5+getToColor(texCoord)*0.5;

    vec4 cadd = texture2D(inputImageTexture3, pos);
    gl_FragColor = mix(
        texture2D(inputImageTexture, texCoord),
        texture2D(inputImageTexture2, texCoord), cadd.r);//step(0.5,cadd.r)
}
